(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    458916,      11825]
NotebookOptionsPosition[    441546,      11365]
NotebookOutlinePosition[    442085,      11386]
CellTagsIndexPosition[    442042,      11383]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Volume enclosed by Doo-Sabin surfaces\
\>", "Section",
 CellChangeTimes->{{3.604699325951583*^9, 3.604699342005501*^9}, {
  3.605316105939847*^9, 3.6053161113441563`*^9}, {3.6053189977682505`*^9, 
  3.605319007676817*^9}, {3.60569576697237*^9, 3.6056957867405005`*^9}, {
  3.612308616785124*^9, 3.6123086227794666`*^9}}],

Cell[TextData[{
 "code by jph, 2014\ndownload from ",
 StyleBox["www.hakenberg.de",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.605695943586472*^9, 3.6056959456205883`*^9}, {
   3.6056970059162335`*^9, 3.6056970389631243`*^9}, 3.605735755713481*^9, 
   3.612138146605847*^9, {3.612175969429984*^9, 3.6121759752833195`*^9}, {
   3.6121774860257287`*^9, 3.6121774882888584`*^9}, {3.61231043884534*^9, 
   3.6123104396233845`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Implementation", "Section",
 CellChangeTimes->{{3.605327924449959*^9, 3.6053279283121796`*^9}, {
  3.6056149079927945`*^9, 3.6056149089858513`*^9}, {3.6056228516001425`*^9, 
  3.6056228546483173`*^9}, {3.605646909007148*^9, 3.6056469329195156`*^9}, {
  3.60564698352641*^9, 3.6056469954380913`*^9}, {3.605696857837764*^9, 
  3.605696861844993*^9}, {3.605697358177382*^9, 3.605697358385394*^9}, {
  3.6123087117865577`*^9, 3.6123087140776887`*^9}, {3.612310224706092*^9, 
  3.612310236688777*^9}, {3.6123105322016797`*^9, 3.612310532326687*^9}}],

Cell[CellGroupData[{

Cell["Helper functions", "Subsection",
 CellChangeTimes->{{3.606513742476762*^9, 3.606513746957018*^9}, 
   3.6122811832721615`*^9, {3.612310537944008*^9, 3.6123105385180407`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NestT", "[", 
    RowBox[{"form_", ",", "S_"}], "]"}], ":=", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"#", ".", "S"}], ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}], "&"}], ",", 
     "form", ",", "3"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NestP", "[", 
    RowBox[{"form_", ",", "ind_"}], "]"}], ":=", 
   RowBox[{"Nest", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", "ind", "\[RightDoubleBracket]"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"2", ",", "3", ",", "1"}], "}"}]}], "]"}], "&"}], ",", 
     "form", ",", "3"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RHS", "[", 
   RowBox[{"reg_", ",", "gen_", ",", "sub_", ",", "ind_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"NestT", "[", 
    RowBox[{"reg", ",", 
     RowBox[{"sub", "\[LeftDoubleBracket]", 
      RowBox[{"ind", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[RightDoubleBracket]"}]}], "]"}], "+", 
   RowBox[{"NestT", "[", 
    RowBox[{"reg", ",", 
     RowBox[{"sub", "\[LeftDoubleBracket]", 
      RowBox[{"ind", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "\[RightDoubleBracket]"}]}], "]"}], "+", 
   RowBox[{"NestT", "[", 
    RowBox[{"reg", ",", 
     RowBox[{"sub", "\[LeftDoubleBracket]", 
      RowBox[{"ind", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
      "\[RightDoubleBracket]"}]}], "]"}], "+", 
   RowBox[{"NestT", "[", 
    RowBox[{"gen", ",", 
     RowBox[{"sub", "\[LeftDoubleBracket]", 
      RowBox[{"ind", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
      "\[RightDoubleBracket]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Skew3", "[", "frm_", "]"}], ":=", 
  RowBox[{"frm", "-", 
   RowBox[{"Transpose", "[", 
    RowBox[{"frm", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HashGet", "[", 
   RowBox[{"hash_", ",", "key_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"entry", "=", 
      RowBox[{"hash", "[", "key", "]"}]}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Head", "[", "entry", "]"}], "===", "hash"}], ",", "Null", ",",
       "entry"}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6072454291602287`*^9, 3.6072454396158266`*^9}, {
   3.6089343516197047`*^9, 3.60893436273534*^9}, 3.6123087832576456`*^9, 
   3.6123090134618125`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumericMesh", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"N", "[", "V", "]"}], ",", "F"}], "}"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PlotMesh", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Graphics3D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Polygon", "[", 
       RowBox[{"V", "\[LeftDoubleBracket]", 
        RowBox[{"#", ",", "All"}], "\[RightDoubleBracket]"}], "]"}], "&"}], "/@",
      "F"}], ",", 
    RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"HueValues", "[", "lst_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"mn", "=", 
       RowBox[{"Min", "[", "lst", "]"}]}], ",", 
      RowBox[{"mx", "=", 
       RowBox[{"Max", "[", "lst", "]"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"lst", "-", "mn"}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"mx", "-", "mn"}], ")"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PlotMesh", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", "vol_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"hue", "=", 
      RowBox[{"HueValues", "[", "vol", "]"}]}], "}"}], ",", 
    RowBox[{"Graphics3D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Hue", "[", 
           RowBox[{
           "hue", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
           "]"}], ",", 
          RowBox[{"Polygon", "[", 
           RowBox[{"V", "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{
             "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], ",",
              "All"}], "\[RightDoubleBracket]"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", 
          RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "Automatic"}]}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{
  3.6056884725371523`*^9, {3.6056916585413814`*^9, 3.6056916603574853`*^9}, {
   3.6056929270129337`*^9, 3.605692927350953*^9}, 3.6057452624192333`*^9, {
   3.605904510119336*^9, 3.605904512804489*^9}, {3.60601814107796*^9, 
   3.6060181527506275`*^9}, {3.606018433068661*^9, 3.606018444850335*^9}, {
   3.606018505237789*^9, 3.6060185554976635`*^9}, 3.6064761283891163`*^9, {
   3.6064764752519445`*^9, 3.6064765094974704`*^9}, {3.606518749067122*^9, 
   3.6065188500849*^9}, {3.6065189233370895`*^9, 3.6065189241701374`*^9}, {
   3.6065190671383147`*^9, 3.606519072808639*^9}, {3.6066444171121025`*^9, 
   3.6066444174401207`*^9}, 3.6066444636937666`*^9, {3.6075028094102373`*^9, 
   3.607502810516301*^9}, {3.6075030583374753`*^9, 3.6075030721572657`*^9}, 
   3.612309025848521*^9, {3.612309186296698*^9, 3.612309224034857*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Corollary2", "[", 
   RowBox[{"sub_", ",", "ind_", ",", "frm_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", "=", 
      RowBox[{"Length", "[", 
       RowBox[{"ind", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
       "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"With", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"SUB", "=", 
          RowBox[{"sub", "\[LeftDoubleBracket]", 
           RowBox[{
           "ind", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
           "\[RightDoubleBracket]"}]}], "}"}], ",", 
        RowBox[{
         RowBox[{"ArrayReshape", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"SUB", "\[LeftDoubleBracket]", 
                 RowBox[{"a", ",", "i"}], "\[RightDoubleBracket]"}], " ", 
                RowBox[{"SUB", "\[LeftDoubleBracket]", 
                 RowBox[{"b", ",", "j"}], "\[RightDoubleBracket]"}], 
                RowBox[{"SUB", "\[LeftDoubleBracket]", 
                 RowBox[{"c", ",", "k"}], "\[RightDoubleBracket]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"c", ",", "m"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"b", ",", "m"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"a", ",", "m"}], "}"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "m"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "m"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "m"}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"m", "^", "3"}], ",", 
             RowBox[{"m", "^", "3"}]}], "}"}]}], "]"}], "-", 
         RowBox[{"IdentityMatrix", "[", 
          RowBox[{"m", "^", "3"}], "]"}]}]}], "]"}], "\[IndentingNewLine]", 
      ",", 
      RowBox[{"-", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"NestT", "[", 
          RowBox[{"frm", ",", 
           RowBox[{"sub", "\[LeftDoubleBracket]", 
            RowBox[{
            "ind", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}]}], "]"}], "+", 
         RowBox[{"NestT", "[", 
          RowBox[{"frm", ",", 
           RowBox[{"sub", "\[LeftDoubleBracket]", 
            RowBox[{
            "ind", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}]}], "]"}], "+", 
         RowBox[{"NestT", "[", 
          RowBox[{"frm", ",", 
           RowBox[{"sub", "\[LeftDoubleBracket]", 
            RowBox[{
            "ind", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}]}], "]"}]}], "]"}]}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.607162300850188*^9, 3.60716233165495*^9}, {
   3.6071623703741646`*^9, 3.607162422277133*^9}, {3.6071626305650463`*^9, 
   3.607162703079194*^9}, {3.6071627826137433`*^9, 3.607162821181949*^9}, {
   3.6071628849865985`*^9, 3.6071628903059025`*^9}, 3.607163066822999*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Subdivision", "Subsection",
 CellChangeTimes->{{3.6123087875068884`*^9, 3.6123087918591375`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuadLinearSubdivide", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Vout", "=", "V"}], ",", 
      RowBox[{"Fout", "=", 
       RowBox[{"{", "}"}]}], ",", "mid", ",", "key", ",", "hash", ",", "edge",
       ",", "list"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"Vout", ",", 
          RowBox[{"Mean", "[", 
           RowBox[{"V", "\[LeftDoubleBracket]", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], "]"}]}], "]"}], ";", 
        RowBox[{"mid", "=", 
         RowBox[{"Length", "[", "Vout", "]"}]}], ";", 
        RowBox[{"list", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"key", "=", 
            RowBox[{"Sort", "[", 
             RowBox[{
              RowBox[{"RotateLeft", "[", 
               RowBox[{
                RowBox[{
                "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
                ",", 
                RowBox[{"j", "-", "1"}]}], "]"}], "\[LeftDoubleBracket]", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"edge", "=", 
            RowBox[{"HashGet", "[", 
             RowBox[{"hash", ",", "key"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"edge", "===", "Null"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"Vout", ",", 
                RowBox[{"Mean", "[", 
                 RowBox[{
                 "V", "\[LeftDoubleBracket]", "key", 
                  "\[RightDoubleBracket]"}], "]"}]}], "]"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"edge", "=", 
               RowBox[{"Length", "[", "Vout", "]"}]}], ";", 
              RowBox[{
               RowBox[{"hash", "[", "key", "]"}], "=", "edge"}]}]}], "]"}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"AppendTo", "[", 
            RowBox[{"list", ",", "edge"}], "]"}], ";"}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
             "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
             "]"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"Fout", ",", 
            RowBox[{"{", 
             RowBox[{"mid", ",", 
              RowBox[{"list", "\[LeftDoubleBracket]", 
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"j", "-", "2"}], ",", 
                  RowBox[{"Length", "[", 
                   RowBox[{
                   "F", "\[LeftDoubleBracket]", "k", 
                    "\[RightDoubleBracket]"}], "]"}]}], "]"}], "+", "1"}], 
               "\[RightDoubleBracket]"}], ",", 
              RowBox[{"F", "\[LeftDoubleBracket]", 
               RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], ",", 
              RowBox[{
              "list", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}]}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
             "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
             "]"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
     RowBox[{"{", 
      RowBox[{"Vout", ",", "Fout"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6123092614349957`*^9, 3.6123092641501513`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DooSabinWeight", "[", "n_", "]"}], ":=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"4", " ", "n"}]], 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", "+", "5"}], "}"}], ",", 
       RowBox[{"3", "+", 
        RowBox[{"2", " ", 
         RowBox[{"Cos", "[", 
          RowBox[{"2", " ", "\[Pi]", " ", 
           RowBox[{
            RowBox[{"Range", "[", 
             RowBox[{"n", "-", "1"}], "]"}], "/", "n"}]}], "]"}]}]}]}], 
      "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinMatrix", "[", "n_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"w", "=", 
      RowBox[{"DooSabinWeight", "[", "n", "]"}]}], "}"}], ",", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"RotateRight", "[", 
       RowBox[{"w", ",", 
        RowBox[{"k", "-", "1"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "n"}], "}"}]}], "]"}]}], "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"VertexRing", "[", 
   RowBox[{"F_", ",", "f_", ",", "vind_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fn", "=", 
       RowBox[{"RotateLeft", "[", 
        RowBox[{"f", ",", 
         RowBox[{"vind", "-", "1"}]}], "]"}]}], ",", "v1", ",", "v2", ",", 
      "adj", ",", 
      RowBox[{"ring", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"count", "=", "0"}], ",", 
      RowBox[{"rev", "=", 
       RowBox[{"{", "}"}]}], ",", "tmp", ",", "pos"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"adj", "=", "fn"}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"ring", ",", "adj"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"rev", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{"F", ",", "f"}], "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"vind", "-", "1"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"++", "count"}], "<", "10"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"v1", "=", 
         RowBox[{
         "adj", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"v2", "=", 
         RowBox[{"Last", "[", "adj", "]"}]}], ";", 
        RowBox[{"(*", 
         RowBox[{"this", " ", "used", " ", "to", " ", 
          RowBox[{
          "be", " ", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}],
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{"tmp", "=", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{"F", ",", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Union", "[", "#", "]"}], "\[NotEqual]", 
               RowBox[{"Union", "[", "adj", "]"}]}], "\[And]", 
              RowBox[{"MemberQ", "[", 
               RowBox[{"#", ",", "v1"}], "]"}], "\[And]", 
              RowBox[{"MemberQ", "[", 
               RowBox[{"#", ",", "v2"}], "]"}]}], "&"}]}], "]"}], 
          "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pos", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{"tmp", ",", "v1"}], "]"}], "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"adj", "=", 
         RowBox[{"RotateLeft", "[", 
          RowBox[{"tmp", ",", "pos"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"adj", "\[Equal]", "fn"}], ",", 
          RowBox[{"Break", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ring", ",", "adj"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"rev", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{"F", ",", "tmp"}], "]"}], "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", "pos"}],
            "}"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
     RowBox[{"{", 
      RowBox[{"ring", ",", "rev"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6056882724627085`*^9, 3.6056883453958807`*^9}, {
  3.6056884876190147`*^9, 3.6056885310424986`*^9}, {3.605688644786004*^9, 
  3.6056886654661875`*^9}, {3.6056891823907537`*^9, 3.6056891852929196`*^9}, {
  3.605689769738348*^9, 3.605689776326725*^9}, {3.6056898164250183`*^9, 
  3.6056898204342475`*^9}, {3.6056898546592054`*^9, 3.6056898723452168`*^9}, {
  3.605689903609005*^9, 3.605689984347623*^9}, {3.6056900268750553`*^9, 
  3.605690029665215*^9}, {3.605690080540125*^9, 3.605690090137674*^9}, {
  3.605691408210063*^9, 3.6056914192316933`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinSubdivide", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Vout", ",", 
      RowBox[{"Fout", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"count", "=", "0"}], ",", 
      RowBox[{"Vind", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"rings", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", 
             RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], ","}], 
       "*)"}], "ring", ",", "rev"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{"Face", " ", "subdivision"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Vout", "=", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"point", "=", 
               RowBox[{"V", "\[LeftDoubleBracket]", 
                RowBox[{"#", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
              RowBox[{"n", "=", 
               RowBox[{"Length", "[", "#", "]"}]}]}], "}"}], ",", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"Fout", ",", 
               RowBox[{"count", "+", 
                RowBox[{"Range", "[", "n", "]"}]}]}], "]"}], ";", 
             RowBox[{"count", "+=", "n"}], ";", 
             RowBox[{
              RowBox[{"DooSabinMatrix", "[", "n", "]"}], ".", "point"}]}]}], 
           "]"}], "&"}], "/@", "F"}], ",", "1"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{"Vind", ",", 
              RowBox[{
               RowBox[{
               "F", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
               "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
             "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"AppendTo", "[", 
             RowBox[{"Vind", ",", 
              RowBox[{
               RowBox[{
               "F", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
               "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"tmp", "=", 
               RowBox[{"Join", "@@", 
                RowBox[{"rings", "\[LeftDoubleBracket]", 
                 RowBox[{
                 "F", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
                 "\[RightDoubleBracket]"}]}]}], ";"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"ring", ",", "rev"}], "}"}], "=", 
             RowBox[{"VertexRing", "[", 
              RowBox[{"F", ",", 
               RowBox[{
               "F", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
               ",", "k"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"Vertex", " ", "subdivision"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"Fout", ",", 
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"RotateRight", "[", 
                  RowBox[{
                   RowBox[{"Fout", "\[LeftDoubleBracket]", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", "1"}], "\[RightDoubleBracket]"}], 
                    "\[RightDoubleBracket]"}], ",", 
                   RowBox[{"-", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", "2"}], "\[RightDoubleBracket]"}]}]}], 
                  "]"}], "\[LeftDoubleBracket]", "1", 
                 "\[RightDoubleBracket]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"m", ",", 
                  RowBox[{"Length", "[", "rev", "]"}]}], "}"}]}], "]"}]}], 
             "]"}], ";", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"Edge", " ", "subdivision"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"ring", "\[LeftDoubleBracket]", 
                  RowBox[{"m", ",", "1"}], "\[RightDoubleBracket]"}], "<", 
                 RowBox[{"ring", "\[LeftDoubleBracket]", 
                  RowBox[{"m", ",", "2"}], "\[RightDoubleBracket]"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"With", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"n", "=", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"m", "\[Equal]", "1"}], ",", 
                    RowBox[{"Length", "[", "rev", "]"}], ",", 
                    RowBox[{"m", "-", "1"}]}], "]"}]}], "}"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                   RowBox[{"Fout", ",", 
                    RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"RotateRight", "[", 
                    RowBox[{
                    RowBox[{"Fout", "\[LeftDoubleBracket]", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", "1"}], "\[RightDoubleBracket]"}], 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"0", "-", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"m", ",", "2"}], "\[RightDoubleBracket]"}]}]}], 
                    "]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], "\[RightDoubleBracket]"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"RotateRight", "[", 
                    RowBox[{
                    RowBox[{"Fout", "\[LeftDoubleBracket]", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"n", ",", "1"}], "\[RightDoubleBracket]"}], 
                    "\[RightDoubleBracket]"}], ",", 
                    RowBox[{"1", "-", 
                    RowBox[{"rev", "\[LeftDoubleBracket]", 
                    RowBox[{"n", ",", "2"}], "\[RightDoubleBracket]"}]}]}], 
                    "]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "1"}], "}"}], 
                    "\[RightDoubleBracket]"}]}], "]"}]}], "]"}]}], "]"}]}], 
               "\[IndentingNewLine]", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", 
                RowBox[{"Length", "[", "rev", "]"}]}], "}"}]}], "]"}], 
            ";"}]}], "\[IndentingNewLine]", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
            "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], 
     RowBox[{"(*", 
      RowBox[{"&", "/@", "F"}], "*)"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Vout", ",", "Fout"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.605687021623165*^9, 3.605687098938587*^9}, {
   3.605687222334645*^9, 3.6056872447969294`*^9}, {3.605687437926976*^9, 
   3.605687449908661*^9}, {3.6056874839176064`*^9, 3.605687582134224*^9}, {
   3.6056876256947155`*^9, 3.6056876404875617`*^9}, {3.605688753694234*^9, 
   3.6056887683080697`*^9}, {3.6056888425253143`*^9, 
   3.6056889301073236`*^9}, {3.6056889641722727`*^9, 
   3.6056891428214903`*^9}, {3.605689229388442*^9, 3.605689244669316*^9}, {
   3.605689287877787*^9, 3.605689299957478*^9}, {3.6056901254656944`*^9, 
   3.6056901628878345`*^9}, {3.6056902166629105`*^9, 
   3.6056902390001884`*^9}, {3.6056902853528395`*^9, 3.605690370231694*^9}, {
   3.6056907198126893`*^9, 3.605690838206461*^9}, {3.605690885082142*^9, 
   3.6056909379691668`*^9}, {3.605691039272961*^9, 3.6056910852745924`*^9}, {
   3.605691190969638*^9, 3.605691198764084*^9}, {3.605691229811859*^9, 
   3.605691326141369*^9}, {3.6056915687542458`*^9, 3.6056915795108614`*^9}, {
   3.60569177215788*^9, 3.605691777123164*^9}, {3.605691887340468*^9, 
   3.60569191326095*^9}, {3.60688832448534*^9, 3.6068883455365443`*^9}, {
   3.6068883945753493`*^9, 3.606888500989436*^9}, {3.6068885690613294`*^9, 
   3.606888599965097*^9}, 3.6068886481278515`*^9, 3.6068888101801205`*^9, {
   3.6075477702369556`*^9, 3.6075477873029323`*^9}, {3.6075479115110364`*^9, 
   3.6075480363431764`*^9}, {3.6075480885161605`*^9, 
   3.6075481092493467`*^9}, {3.607548186331755*^9, 3.607548230437278*^9}, {
   3.607548272460682*^9, 3.607548354987402*^9}, {3.6088786493131742`*^9, 
   3.608878650674252*^9}, {3.6123091534378185`*^9, 3.6123091541068573`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DualMesh", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Vout", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Mean", "[", 
          RowBox[{"V", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}],
           "]"}], "&"}], "/@", "F"}]}], ",", 
      RowBox[{"rings", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"index", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], ",", 
      RowBox[{"Fout", "=", 
       RowBox[{"{", "}"}]}], ",", "ring", ",", "rev"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"rings", "\[LeftDoubleBracket]", 
            RowBox[{"F", "\[LeftDoubleBracket]", 
             RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
            "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"index", "\[LeftDoubleBracket]", 
            RowBox[{"F", "\[LeftDoubleBracket]", 
             RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], ",", "k"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
            "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ring", ",", "rev"}], "}"}], "=", 
         RowBox[{"VertexRing", "[", 
          RowBox[{
           RowBox[{
           "rings", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
           ",", 
           RowBox[{"rings", "\[LeftDoubleBracket]", 
            RowBox[{"n", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{
            RowBox[{"Position", "[", 
             RowBox[{
              RowBox[{"rings", "\[LeftDoubleBracket]", 
               RowBox[{"n", ",", "1"}], "\[RightDoubleBracket]"}], ",", "n"}],
              "]"}], "\[LeftDoubleBracket]", 
            RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"Fout", ",", 
          RowBox[{"index", "\[LeftDoubleBracket]", 
           RowBox[{"n", ",", 
            RowBox[{"rev", "\[LeftDoubleBracket]", 
             RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], 
           "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"Length", "[", "rings", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Vout", ",", "Fout"}], "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.607498914401456*^9, 3.6074989973401995`*^9}, {
  3.60749906396301*^9, 3.607499072470497*^9}, {3.607499136908182*^9, 
  3.6074991648147783`*^9}, {3.6074992558529854`*^9, 3.607499386759473*^9}, {
  3.6074994314600296`*^9, 3.607499453875312*^9}, {3.6074995061092997`*^9, 
  3.607499508757451*^9}, {3.6074995511638765`*^9, 3.6074996679415555`*^9}, {
  3.607499703248575*^9, 3.6074997721145144`*^9}, {3.607499858365447*^9, 
  3.607499879409651*^9}, {3.607499920112979*^9, 3.607500007335968*^9}, {
  3.6075000878415728`*^9, 3.6075001085907593`*^9}, {3.607500274222233*^9, 
  3.607500289868128*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Load volume forms", "Subsection",
 CellChangeTimes->{{3.6073261432421274`*^9, 3.6073261482547045`*^9}, {
   3.607684800319235*^9, 3.6076848008522654`*^9}, {3.6088884739271097`*^9, 
   3.608888474763158*^9}, 3.612310418836195*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Lambda]X", "[", 
   RowBox[{"n_", ",", "\[Lambda]_"}], "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"d", "=", 
      RowBox[{"Length", "[", "\[Lambda]", "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"Binomial", "[", 
      RowBox[{"n", ",", "d"}], "]"}], "-", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{"Binomial", "[", 
        RowBox[{
         RowBox[{"n", "-", 
          RowBox[{
          "\[Lambda]", "\[LeftDoubleBracket]", "i", 
           "\[RightDoubleBracket]"}]}], ",", 
         RowBox[{"d", "+", "1", "-", "i"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "d"}], "}"}]}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalLambda]set", "[", 
   RowBox[{"n_", ",", "d_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lst", "=", 
      RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Array", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", "##", "}"}], "==", 
            RowBox[{"Sort", "[", 
             RowBox[{"{", "##", "}"}], "]"}]}], "&&", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{"Union", "[", 
              RowBox[{"{", "##", "}"}], "]"}], "]"}], "\[Equal]", "d"}]}], 
          ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"lst", ",", 
            RowBox[{"{", "##", "}"}]}], "]"}]}], "]"}], "&"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{"n", ",", 
         RowBox[{"{", "d", "}"}]}], "]"}]}], "]"}], ";", "lst"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6117137433353386`*^9, 3.611713743561352*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"InflateForm", "[", 
   RowBox[{"lst_", ",", "n_", ",", "d_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"Array", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"p", "=", 
            RowBox[{"{", "##", "}"}]}], ",", 
           RowBox[{"s", "=", 
            RowBox[{"Signature", "[", 
             RowBox[{"{", "##", "}"}], "]"}]}]}], "}"}], ",", " ", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"s", "\[Equal]", "0"}], ",", "0", ",", 
           RowBox[{"s", " ", 
            RowBox[{"lst", "\[LeftDoubleBracket]", 
             RowBox[{"\[Lambda]X", "[", 
              RowBox[{"n", ",", 
               RowBox[{"Sort", "[", "p", "]"}]}], "]"}], 
             "\[RightDoubleBracket]"}]}]}], "]"}]}], "]"}], "&"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{"n", ",", 
        RowBox[{"{", "d", "}"}]}], "]"}]}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.611850156341178*^9, 3.6118501617654877`*^9}, {
  3.6121340542537775`*^9, 3.612134064621371*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CompressForm", "[", "frm_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"frm", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
       ",", 
       RowBox[{"#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       ",", 
       RowBox[{"#", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
      "\[RightDoubleBracket]"}], "&"}], "/@", 
    RowBox[{"\[CapitalLambda]set", "[", 
     RowBox[{
      RowBox[{"Length", "[", "frm", "]"}], ",", 
      RowBox[{"TensorRank", "[", "frm", "]"}]}], "]"}]}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinListAlt", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"num", "=", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"k", "<", "10"}], ",", "\"\<0\>\"", ",", "\"\<\>\""}], 
           "]"}], "<>", 
          RowBox[{"ToString", "[", "k", "]"}]}]}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"InflateForm", "[", 
        RowBox[{
         RowBox[{"<<", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
            "\"\<_forms\\\\DSalt\>\"", "<>", "num", "<>", "\"\<vec.mx\>\""}], 
           ")"}]}], ",", 
         RowBox[{"5", "+", "k"}], ",", "3"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "3", ",", "12"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607683337072542*^9, 3.6076833777318673`*^9}, {
  3.60768469725134*^9, 3.6076847090920167`*^9}, {3.6088861374804726`*^9, 
  3.608886137872495*^9}, {3.6123089874803267`*^9, 3.6123089947567425`*^9}, {
  3.6123090676609125`*^9, 3.612309075345352*^9}, {3.6123101691279125`*^9, 
  3.61231019268226*^9}, {3.612310278825187*^9, 3.6123102970182276`*^9}, {
  3.6123173009798317`*^9, 3.612317303643984*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Volume", "Subsection",
 CellChangeTimes->{{3.6123088402879076`*^9, 3.6123088453221955`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LinearVolume", "[", 
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"QuadDet", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             FractionBox["1", "12"], ",", "0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             FractionBox["1", "12"], ",", 
             FractionBox["1", "12"], ",", "0"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             FractionBox["1", "12"], ",", 
             FractionBox["1", "12"]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0", ",", "0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0", ",", 
             FractionBox["1", "12"], ",", "0"}], "}"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0", ",", 
             FractionBox["1", "12"]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             FractionBox["1", "12"], ",", "0", ",", "0", ",", 
             FractionBox["1", "12"]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0", ",", "0"}], "}"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             FractionBox["1", "12"], ",", "0", ",", 
             RowBox[{"-", 
              FractionBox["1", "12"]}], ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             FractionBox["1", "12"], ",", 
             FractionBox["1", "12"], ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]}], 
        "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Simplify", "[", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"f", "=", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "m", "\[RightDoubleBracket]"}]}], 
           "}"}], ",", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "f", "]"}], "\[Equal]", "4"}], ",", 
            RowBox[{"QuadDet", ".", 
             RowBox[{"V", "\[LeftDoubleBracket]", 
              RowBox[{"f", ",", "1"}], "\[RightDoubleBracket]"}], ".", 
             RowBox[{"V", "\[LeftDoubleBracket]", 
              RowBox[{"f", ",", "2"}], "\[RightDoubleBracket]"}], ".", 
             RowBox[{"V", "\[LeftDoubleBracket]", 
              RowBox[{"f", ",", "3"}], "\[RightDoubleBracket]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Simplify", "[", 
             RowBox[{
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{"Det", "[", 
                 RowBox[{"V", "\[LeftDoubleBracket]", 
                  RowBox[{
                   RowBox[{"f", "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "k", ",", 
                    RowBox[{"k", "+", "1"}]}], "}"}], 
                    "\[RightDoubleBracket]"}], ",", "All"}], 
                  "\[RightDoubleBracket]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", "2", ",", 
                  RowBox[{
                   RowBox[{"Length", "[", "f", "]"}], "-", "1"}]}], "}"}]}], 
               "]"}], "/", "6"}], "]"}]}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"m", ",", 
          RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{3.612309131945589*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DooSabinStencil", "[", 
    RowBox[{"ringsN_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ring", ",", "rev", ",", "pos"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ring", ",", "rev"}], "}"}], "=", 
       RowBox[{"VertexRing", "[", 
        RowBox[{"ringsN", ",", 
         RowBox[{
         "ringsN", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         ",", 
         RowBox[{
          RowBox[{"Position", "[", 
           RowBox[{
            RowBox[{
            "ringsN", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            ",", "n"}], "]"}], "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"pos", "=", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"Append", "[", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Length", "[", "#", "]"}], "\[NotEqual]", "4"}], 
               "&"}], "/@", "ring"}], ",", "True"}], "]"}], ",", "3"}], "]"}],
          "]"}], "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"ring", "=", 
       RowBox[{"RotateRight", "[", 
        RowBox[{"ring", ",", 
         RowBox[{"3", "-", "pos"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ring", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"3", ",", "4"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"ring", "\[LeftDoubleBracket]", 
          RowBox[{"2", ",", "3"}], "\[RightDoubleBracket]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ring", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1"}], "}"}]}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"ring", "\[LeftDoubleBracket]", 
          RowBox[{"2", ",", "4"}], "\[RightDoubleBracket]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ring", "\[LeftDoubleBracket]", 
          RowBox[{"4", ",", "3"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"Reverse", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{
            "ring", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
            ",", "2"}], "]"}], "]"}]}], "\[IndentingNewLine]", "}"}], 
       "]"}]}]}], "]"}]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.607501604402315*^9, 3.60750163018979*^9}, {
   3.607501690701251*^9, 3.6075017026169324`*^9}, {3.60750174173617*^9, 
   3.607501778885295*^9}, {3.6075018404058137`*^9, 3.607501896887044*^9}, {
   3.6075019605016828`*^9, 3.60750210084671*^9}, {3.6075021315904684`*^9, 
   3.6075021739238896`*^9}, {3.6075022287090235`*^9, 3.607502228933036*^9}, {
   3.6075024523858166`*^9, 3.6075024535488834`*^9}, {3.607548687781437*^9, 
   3.607548688228462*^9}, {3.6090499286962023`*^9, 3.6090499990362253`*^9}, {
   3.6090500308030424`*^9, 3.6090500799958563`*^9}, {3.609050122182269*^9, 
   3.6090502276052985`*^9}, {3.609050269578699*^9, 3.609050273516925*^9}, 
   3.6123088345845814`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DooSabinValences", "[", 
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"rings", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{
            RowBox[{"rings", "\[LeftDoubleBracket]", 
             RowBox[{"F", "\[LeftDoubleBracket]", 
              RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
           "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", 
             RowBox[{
             "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
             "]"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", 
          RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Union", "[", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"DooSabinStencil", "[", 
            RowBox[{
             RowBox[{
             "rings", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
             ",", "n"}], "]"}], "]"}], "-", "5"}], ",", 
         RowBox[{"{", 
          RowBox[{"n", ",", 
           RowBox[{"Length", "[", "rings", "]"}]}], "}"}]}], "]"}], "]"}]}]}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinVolumeVertex", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rings", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k", ",", 
           RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], ",", 
      "stencil"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"rings", "\[LeftDoubleBracket]", 
            RowBox[{"F", "\[LeftDoubleBracket]", 
             RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
            "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"stencil", "=", 
         RowBox[{"DooSabinStencil", "[", 
          RowBox[{
           RowBox[{
           "rings", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], 
           ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"With", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"point", "=", 
             RowBox[{"Transpose", "[", 
              RowBox[{
              "V", "\[LeftDoubleBracket]", "stencil", 
               "\[RightDoubleBracket]"}], "]"}]}], ",", 
            RowBox[{"val", "=", 
             RowBox[{
              RowBox[{"Length", "[", "stencil", "]"}], "-", "5"}]}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Simplify", "[", 
           RowBox[{
            RowBox[{"DooSabinListAlt", "\[LeftDoubleBracket]", 
             RowBox[{"val", "-", "2"}], "\[RightDoubleBracket]"}], ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
            "]"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"Length", "[", "rings", "]"}]}], "}"}]}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinVolume", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Total", "[", 
    RowBox[{"DooSabinVolumeVertex", "[", 
     RowBox[{"{", 
      RowBox[{"V", ",", "F"}], "}"}], "]"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.612309091956302*^9, 3.612309107146171*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinDemo", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", "depth_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"V1", "=", "V"}], ",", 
      RowBox[{"F1", "=", "F"}], ",", "Vd", ",", "Fd", ",", "img", ",", 
      "delta", ",", 
      RowBox[{"lst", "=", 
       RowBox[{"{", "}"}]}], ",", "fcv", ",", 
      RowBox[{"vls", "=", 
       RowBox[{"{", "}"}]}], ",", "vol", ",", "inf", ",", "val", ",", 
      RowBox[{"cmp", "=", 
       RowBox[{"{", "}"}]}], ",", "sub", ",", 
      RowBox[{"size", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "V", "]"}], "<", "100"}], ",", "120", ",", 
         "180"}], "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "V", "]"}], "<", "100"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"TableForm", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<Vertices \[DownArrow]\>\"", ",", 
             "\"\<Faces \[DownArrow]\>\""}], "}"}], ",", 
           RowBox[{"MatrixForm", "/@", 
            RowBox[{"{", 
             RowBox[{"V", ",", "F"}], "}"}]}]}], "}"}], "]"}], "]"}]}], "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"sub", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"And", "@@", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "#", "]"}], "\[Equal]", "4"}], "&"}], "/@",
            "F"}], ")"}]}], ",", "1", ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"vls", ",", 
       RowBox[{"LinearVolume", "[", 
        RowBox[{"{", 
         RowBox[{"V", ",", "F"}], "}"}], "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"img", "=", 
      RowBox[{"Rasterize", "[", 
       RowBox[{
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"PlotMesh", "[", 
           RowBox[{"{", 
            RowBox[{"V", ",", "F"}], "}"}], "]"}], ",", 
          RowBox[{"Axes", "\[Rule]", "False"}], ",", 
          RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
          RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "size"}]}], "]"}], ",", 
        RowBox[{"ImageResolution", "\[Rule]", "size"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"lst", ",", "img"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"V1", ",", "F1"}], "}"}], "=", 
         RowBox[{"DooSabinSubdivide", "[", 
          RowBox[{"{", 
           RowBox[{"V1", ",", "F1"}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"vls", ",", 
          RowBox[{"LinearVolume", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"InexactNumberQ", "[", "inf", "]"}], ",", 
               RowBox[{"V1", "//", "N"}], ",", "V1"}], "]"}], ",", "F1"}], 
            "}"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"sub", "\[Equal]", "k"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"inf", "=", 
            RowBox[{"DooSabinVolume", "[", 
             RowBox[{"{", 
              RowBox[{"V1", ",", "F1"}], "}"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"val", "=", 
            RowBox[{"DooSabinValences", "[", 
             RowBox[{"{", 
              RowBox[{"V1", ",", "F1"}], "}"}], "]"}]}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"img", "=", 
         RowBox[{"Rasterize", "[", 
          RowBox[{
           RowBox[{"Show", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"sub", "\[LessEqual]", "k"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"fcv", "=", 
                 RowBox[{"DooSabinVolumeVertex", "[", 
                  RowBox[{"NumericMesh", "[", 
                   RowBox[{"{", 
                    RowBox[{"V1", ",", "F1"}], "}"}], "]"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"cmp", ",", 
                  RowBox[{"Total", "[", "fcv", "]"}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Vd", ",", "Fd"}], "}"}], "=", 
                 RowBox[{"DualMesh", "[", 
                  RowBox[{"{", 
                   RowBox[{"V1", ",", "F1"}], "}"}], "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"PlotMesh", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Vd", ",", "Fd"}], "}"}], ",", "fcv"}], "]"}]}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"PlotMesh", "[", 
                RowBox[{"{", 
                 RowBox[{"V1", ",", "F1"}], "}"}], "]"}]}], "]"}], ",", 
             RowBox[{"Axes", "\[Rule]", "False"}], ",", 
             RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
             RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "size"}]}], "]"}], ",", 
           RowBox[{"ImageResolution", "\[Rule]", "size"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"lst", ",", "img"}], "]"}], ";"}], "\[IndentingNewLine]", 
       ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "depth"}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"delta", "=", 
      RowBox[{"N", "[", 
       RowBox[{"vls", "-", "inf"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "lst", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Required valences \[Tau](f) \[Element] \>\"", "<>", 
       RowBox[{"ToString", "[", "val", "]"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Limit volume \[DownArrow] \>\"", "<>", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"InexactNumberQ", "[", "inf", "]"}], "\[Equal]", "False"}], 
         ",", 
         RowBox[{"\"\<(\[TildeTilde]\>\"", "<>", 
          RowBox[{"ToString", "[", 
           RowBox[{"N", "[", 
            RowBox[{"inf", ",", "30"}], "]"}], "]"}], "<>", "\"\<)\>\""}], 
         ",", "\"\<\>\""}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "inf", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"TableForm", "[", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"MatrixForm", "[", 
           RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "\"\<Level\>\"", "}"}], ",", 
                RowBox[{"Range", "[", 
                 RowBox[{"0", ",", "depth"}], "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "\"\<Volume\>\"", "}"}], ",", "vls"}], "]"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "\"\<Delta to \[Infinity]\>\"", "}"}], ",", 
                "delta"}], "]"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
           "]"}], ",", 
          RowBox[{"ListLogPlot", "[", 
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Range", "[", 
                RowBox[{"0", ",", "depth"}], "]"}], ",", 
               RowBox[{"delta", "/", 
                RowBox[{
                "delta", "\[LeftDoubleBracket]", "1", 
                 "\[RightDoubleBracket]"}]}]}], "}"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
            RowBox[{"AxesLabel", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"\"\<Level\>\"", ",", "\"\<Rel. error\>\""}], "}"}]}]}],
            "]"}]}], "}"}], "}"}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"cmp", "=", 
      RowBox[{"Union", "[", 
       RowBox[{"Chop", "[", 
        RowBox[{"cmp", "-", "inf"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"1", "<", 
        RowBox[{"Length", "[", "cmp", "]"}]}], ",", 
       RowBox[{"Print", "[", "cmp", "]"}]}], "]"}], ";"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6056947444118834`*^9, 3.605694806787451*^9}, {
   3.6056948914532933`*^9, 3.605694915195651*^9}, {3.605694994686198*^9, 
   3.6056950366906004`*^9}, {3.6056951609467077`*^9, 
   3.6056952028411036`*^9}, {3.6056969226214695`*^9, 
   3.6056969230554943`*^9}, {3.605823698784614*^9, 3.6058237007427263`*^9}, 
   3.6064761536220045`*^9, 3.6065188943384314`*^9, {3.6066923697257676`*^9, 
   3.606692389333889*^9}, {3.606692449893353*^9, 3.606692450132367*^9}, {
   3.606692486065422*^9, 3.606692531680031*^9}, {3.606692564236893*^9, 
   3.60669288587929*^9}, {3.606692925815574*^9, 3.6066929294527826`*^9}, {
   3.6066929697830887`*^9, 3.6066931347265234`*^9}, {3.6066933434764633`*^9, 
   3.60669334499355*^9}, 3.6066934910919065`*^9, 3.606693534668399*^9, {
   3.606693648999938*^9, 3.6066936496419744`*^9}, {3.606734825537229*^9, 
   3.606734861201269*^9}, {3.6067349274160557`*^9, 3.6067349318013067`*^9}, {
   3.606735022009466*^9, 3.6067350891763086`*^9}, {3.6067362559900465`*^9, 
   3.6067362585101905`*^9}, {3.606887000696624*^9, 3.6068870053108883`*^9}, {
   3.6075023593124933`*^9, 3.6075023610295916`*^9}, {3.6075049745180745`*^9, 
   3.6075049929951315`*^9}, 3.607505031546336*^9, {3.6075489134053416`*^9, 
   3.607548937696731*^9}, {3.60884976066334*^9, 3.6088498906907773`*^9}, {
   3.6088510679811144`*^9, 3.608851069794218*^9}, 3.60887855569582*^9, {
   3.60887859434103*^9, 3.6088786177623696`*^9}, {3.608878657565646*^9, 
   3.608878668278259*^9}, {3.6088788849636526`*^9, 3.608878919898651*^9}, {
   3.6088789706975565`*^9, 3.6088791536280193`*^9}, {3.6088793316272*^9, 
   3.6088793699183903`*^9}, {3.6088794088786187`*^9, 
   3.6088794907833033`*^9}, {3.608879708466754*^9, 3.608879709479812*^9}, {
   3.608879853879071*^9, 3.608879855863185*^9}, 3.60888016645395*^9, {
   3.608880211084502*^9, 3.60888040615366*^9}, {3.60888044636296*^9, 
   3.6088804915785456`*^9}, {3.6088805632586455`*^9, 3.60888057365024*^9}, {
   3.6088806831955056`*^9, 3.6088806898038836`*^9}, {3.6088807235598145`*^9, 
   3.60888074761419*^9}, {3.608880784170281*^9, 3.608880813090935*^9}, {
   3.6088808462088294`*^9, 3.6088808918614407`*^9}, {3.6088809690098534`*^9, 
   3.6088810079230785`*^9}, {3.6088812771254764`*^9, 
   3.6088813452933755`*^9}, {3.6088813766451683`*^9, 3.608881414150314*^9}, {
   3.6088814971000586`*^9, 3.6088815481039753`*^9}, {3.6088815784817133`*^9, 
   3.6088816255384045`*^9}, {3.608881666332738*^9, 3.608881669065894*^9}, {
   3.6088820175898285`*^9, 3.6088820477705545`*^9}, {3.608882078439309*^9, 
   3.6088820821705227`*^9}, {3.6088829049675837`*^9, 3.608882950733201*^9}, {
   3.6088831156606345`*^9, 3.608883179756301*^9}, {3.608884194618347*^9, 
   3.6088842263621635`*^9}, {3.60888612833095*^9, 3.60888612903399*^9}, {
   3.608886198866984*^9, 3.6088862516050005`*^9}, {3.6088863013248444`*^9, 
   3.608886304976053*^9}, {3.6088895093103304`*^9, 3.6088895106854095`*^9}, {
   3.609020219209234*^9, 3.60902022106434*^9}, {3.609020435304594*^9, 
   3.60902058611022*^9}, 3.6090217565751667`*^9, {3.6090497250545545`*^9, 
   3.60904976763399*^9}, {3.609049820416009*^9, 3.609049896647369*^9}, {
   3.609050281988409*^9, 3.609050347644164*^9}, {3.609050384175254*^9, 
   3.6090504081196237`*^9}, {3.609050445596767*^9, 3.609050447673886*^9}, {
   3.6090505058842154`*^9, 3.609050508291353*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Mesh examples", "Subsection",
 CellChangeTimes->{{3.6066937912720757`*^9, 3.6066938001225815`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"CubeMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"0", "0", "0"},
        {"1", "0", "0"},
        {"0", "1", "0"},
        {"1", "1", "0"},
        {"0", "0", "1"},
        {"1", "0", "1"},
        {"0", "1", "1"},
        {"1", "1", "1"}
       }], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "6", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "8", ",", "6", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"5", ",", "6", ",", "8", ",", "7"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"7", ",", "8", ",", "4", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"7", ",", "3", ",", "1", ",", "5"}], "}"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CornerMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {"1", "0", "0"},
         {"0", "1", "0"},
         {"1", "1", "0"},
         {"0", "0", "1"},
         {"1", "0", "1"},
         {"0", "1", "1"},
         {"1", "1", "1"},
         {"1", "0", "2"},
         {"1", "1", "2"},
         {"2", "0", "0"},
         {"2", "1", "0"},
         {"2", "0", "1"},
         {"2", "1", "1"},
         {"2", "0", "2"},
         {"2", "1", "2"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "6", ",", "5"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"5", ",", "6", ",", "8", ",", "7"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"7", ",", "8", ",", "4", ",", "3"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"7", ",", "3", ",", "1", ",", "5"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "11", ",", "13", ",", "6"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "13", ",", "15", ",", "9"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "12", ",", "11", ",", "2"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"12", ",", "14", ",", "13", ",", "11"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"14", ",", "16", ",", "15", ",", "13"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"9", ",", "15", ",", "16", ",", "10"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "9", ",", "10", ",", "8"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "8", ",", "14", ",", "12"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"8", ",", "10", ",", "16", ",", "14"}], "}"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TripodMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0"},
         {"1", "0", "0"},
         {"0", "1", "0"},
         {"1", "1", "0"},
         {"0", "0", "1"},
         {"1", "0", "1"},
         {"0", "1", "1"},
         {"1", "1", "1"},
         {"1", "0", "2"},
         {"1", "1", "2"},
         {"2", "0", "0"},
         {"2", "1", "0"},
         {"2", "0", "1"},
         {"2", "1", "1"},
         {"2", "0", "2"},
         {"2", "1", "2"},
         {"1", 
          RowBox[{"-", "1"}], "0"},
         {"2", 
          RowBox[{"-", "1"}], "0"},
         {"1", 
          RowBox[{"-", "1"}], "1"},
         {"2", 
          RowBox[{"-", "1"}], "1"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "6", ",", "5"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4", ",", "2", ",", "1"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"5", ",", "6", ",", "8", ",", "7"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"7", ",", "8", ",", "4", ",", "3"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"7", ",", "3", ",", "1", ",", "5"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "13", ",", "15", ",", "9"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "12", ",", "11", ",", "2"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"12", ",", "14", ",", "13", ",", "11"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"14", ",", "16", ",", "15", ",", "13"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"9", ",", "15", ",", "16", ",", "10"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "9", ",", "10", ",", "8"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "8", ",", "14", ",", "12"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"8", ",", "10", ",", "16", ",", "14"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"17", ",", "18", ",", "20", ",", "19"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"19", ",", "20", ",", "13", ",", "6"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"11", ",", "13", ",", "20", ",", "18"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"11", ",", "18", ",", "17", ",", "2"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"17", ",", "19", ",", "6", ",", "2"}], "}"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TetrahedronMesh", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"A", "=", 
       RowBox[{"(", GridBox[{
          {"1", 
           FractionBox["1", "2"], 
           FractionBox["1", "2"]},
          {"0", 
           FractionBox[
            SqrtBox["3"], "2"], 
           FractionBox["1", 
            RowBox[{"2", 
             SqrtBox["3"]}]]},
          {"0", "0", 
           SqrtBox[
            FractionBox["2", "3"]]}
         }], ")"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", GridBox[{
           {"0", "0", "0"},
           {"1", "0", "0"},
           {"0", "1", "0"},
           {"0", "0", "1"}
          }], ")"}], ".", 
        RowBox[{"Transpose", "[", "A", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "4", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "}"}]}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"OctahedronMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"0", "0", "0"},
        {"1", "0", "0"},
        {"1", "1", "0"},
        {"0", "1", "0"},
        {
         RowBox[{"1", "/", "2"}], 
         RowBox[{"1", "/", "2"}], 
         RowBox[{"1", "/", 
          SqrtBox["2"]}]},
        {
         RowBox[{"1", "/", "2"}], 
         RowBox[{"1", "/", "2"}], 
         RowBox[{
          RowBox[{"-", "1"}], "/", 
          SqrtBox["2"]}]}
       }], ")"}], ",", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"3", ",", "4", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "1", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "2", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "3", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "4", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "1", ",", "4"}], "}"}]}], "\[IndentingNewLine]", 
      "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TriQuadPrismMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"0", "0", "0"},
        {"1", "0", "0"},
        {
         RowBox[{"1", "/", "2"}], 
         FractionBox[
          SqrtBox["3"], "2"], "0"},
        {"0", "0", "1"},
        {"1", "0", "1"},
        {
         RowBox[{"1", "/", "2"}], 
         FractionBox[
          SqrtBox["3"], "2"], "1"}
       }], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "3", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "5", ",", "4"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5", ",", "6"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "3", ",", "6", ",", "5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"3", ",", "1", ",", "4", ",", "6"}], "}"}]}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TwistedPrismMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", GridBox[{
        {"0", "0", "0"},
        {"1", "0", "0"},
        {"0", "1", "0"},
        {"0", "0", "1"},
        {"1", "0", "1"},
        {"0", "1", "1"}
       }], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "2", ",", "5"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"4", ",", "5", ",", "6"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "1", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"5", ",", "2", ",", "6"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"6", ",", "2", ",", "3"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "4", ",", "6"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "6", ",", "3"}], "}"}]}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.606693175688866*^9, 3.6066931925668316`*^9}, {
  3.6066934092942276`*^9, 3.6066934695606747`*^9}, {3.6066936984677677`*^9, 
  3.6066937331517515`*^9}, {3.606693785456743*^9, 3.6066937858307643`*^9}, {
  3.606694300801219*^9, 3.6066943224624577`*^9}, {3.6066944264494057`*^9, 
  3.6066944405282106`*^9}, {3.6066944879599237`*^9, 3.6066944972164536`*^9}, {
  3.6088434287549133`*^9, 3.6088434886233373`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TorusMesh", "=", 
   RowBox[{"{", 
    RowBox[{
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"3", "/", "2"}], "0", "0"},
         {"1.2135254915624212`", "0.8816778784387097`", "0"},
         {"0.4635254915624212`", "1.4265847744427302`", "0"},
         {
          RowBox[{"-", "0.463525491562421`"}], "1.4265847744427305`", "0"},
         {
          RowBox[{"-", "1.213525491562421`"}], "0.8816778784387098`", "0"},
         {
          RowBox[{
           RowBox[{"-", "3"}], "/", "2"}], "0", "0"},
         {
          RowBox[{"-", "1.2135254915624212`"}], 
          RowBox[{"-", "0.8816778784387096`"}], "0"},
         {
          RowBox[{"-", "0.46352549156242134`"}], 
          RowBox[{"-", "1.4265847744427302`"}], "0"},
         {"0.46352549156242084`", 
          RowBox[{"-", "1.4265847744427305`"}], "0"},
         {"1.213525491562421`", 
          RowBox[{"-", "0.88167787843871`"}], "0"},
         {"1", "0", 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{"1", "/", "2"}], "0.8660254037844386`", 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], "0.8660254037844387`", 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{"-", "1"}], "0", 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], 
          RowBox[{"-", "0.8660254037844385`"}], 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{"1", "/", "2"}], 
          RowBox[{"-", "0.8660254037844386`"}], 
          RowBox[{"1", "/", "2"}]},
         {
          RowBox[{"1", "/", "2"}], "0", "0"},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "4"}], "0.43301270189221935`", "0"},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "4"}], 
          RowBox[{"-", "0.43301270189221924`"}], "0"},
         {"1", "0", 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]},
         {
          RowBox[{"1", "/", "2"}], "0.8660254037844385`", 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], "0.8660254037844386`", 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]},
         {
          RowBox[{"-", "1"}], "0", 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]},
         {
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}], 
          RowBox[{"-", "0.8660254037844384`"}], 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]},
         {
          RowBox[{"1", "/", "2"}], 
          RowBox[{"-", "0.8660254037844385`"}], 
          RowBox[{
           RowBox[{"-", "1"}], "/", "2"}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]], ",", "\[IndentingNewLine]", 
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"3", "4", "13"},
         {"12", "2", "3"},
         {"18", "13", "14"},
         {"23", "18", "19"},
         {"21", "20", "17"},
         {"22", "4", "3"},
         {"24", "19", "25"},
         {"8", "24", "9"},
         {"7", "6", "23"},
         {"6", "14", "5"},
         {"14", "13", "5"},
         {"11", "1", "2"},
         {"12", "3", "13"},
         {"13", "4", "5"},
         {"18", "12", "13"},
         {"11", "2", "12"},
         {"10", "16", "9"},
         {"19", "18", "14"},
         {"17", "11", "12"},
         {"18", "17", "12"},
         {"2", "20", "21"},
         {"23", "5", "22"},
         {"2", "1", "20"},
         {"3", "2", "21"},
         {"22", "3", "21"},
         {"22", "5", "4"},
         {"24", "23", "19"},
         {"21", "17", "18"},
         {"18", "22", "21"},
         {"23", "6", "5"},
         {"18", "23", "22"},
         {"24", "7", "23"},
         {"7", "24", "8"},
         {"24", "25", "9"},
         {"25", "10", "9"},
         {"25", "19", "17"},
         {"25", "20", "10"},
         {"10", "20", "1"},
         {"25", "17", "20"},
         {"16", "10", "11"},
         {"19", "16", "17"},
         {"16", "15", "9"},
         {"19", "14", "15"},
         {"17", "16", "11"},
         {"19", "15", "16"},
         {"7", "14", "6"},
         {"15", "14", "7"},
         {"15", "8", "9"},
         {"15", "7", "8"},
         {"10", "1", "11"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.606694128983392*^9, 3.60669414801748*^9}, {
  3.6088426029046774`*^9, 3.6088426832282715`*^9}, {3.608842745425829*^9, 
  3.6088428057522793`*^9}, {3.60884346279786*^9, 3.6088434648269763`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Torus", "[", 
    RowBox[{"R_", ",", "r_", ",", "\[Theta]_", ",", "\[Phi]_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TorusVolume", "[", 
    RowBox[{"R_", ",", "r_"}], "]"}], "=", 
   RowBox[{"2", " ", 
    SuperscriptBox["\[Pi]", "2"], "R", " ", 
    SuperscriptBox["r", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TorusSample", "[", 
   RowBox[{"N_", ",", "M_", ",", "i_", ",", "j_"}], "]"}], ":=", 
  RowBox[{"Torus", "[", 
   RowBox[{"2", ",", "1", ",", 
    RowBox[{
     FractionBox[
      RowBox[{"2", "\[Pi]", " ", "i"}], "N"], "+", 
     FractionBox["\[Pi]", "4"]}], ",", 
    FractionBox[
     RowBox[{"2", "\[Pi]", " ", "j"}], "M"]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6065531864185305`*^9, 3.6065531923228683`*^9}, {
  3.6065544938033085`*^9, 3.606554505849998*^9}, {3.606554616960353*^9, 
  3.606554618703453*^9}, {3.6067694316322355`*^9, 3.6067694620499754`*^9}, {
  3.608806220050144*^9, 3.608806223829361*^9}, {3.6088425841666055`*^9, 
  3.608842590787984*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RegularTorusQuad", "[", 
   RowBox[{"N_", ",", "M_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "func", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"func", "[", 
       RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", " ", "M"}], "+", "j"}], ",", 
         RowBox[{"N", " ", "M"}]}], "]"}], "+", "1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", "i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"N", "-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"M", "-", "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"func", "[", 
               RowBox[{"i", ",", "j"}], "]"}], ",", 
              RowBox[{"func", "[", 
               RowBox[{
                RowBox[{"i", "+", "1"}], ",", "j"}], "]"}], ",", 
              RowBox[{"func", "[", 
               RowBox[{
                RowBox[{"i", "+", "1"}], ",", 
                RowBox[{"j", "+", "1"}]}], "]"}], ",", 
              RowBox[{"func", "[", 
               RowBox[{"i", ",", 
                RowBox[{"j", "+", "1"}]}], "]"}]}], "}"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"N", "-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"M", "-", "1"}]}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
      "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088849060730405`*^9, 3.6088849207658806`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RegularTorusTria", "[", 
   RowBox[{"N_", ",", "M_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "func", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"func", "[", 
       RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"i", " ", "M"}], "+", "j"}], ",", 
         RowBox[{"N", " ", "M"}]}], "]"}], "+", "1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", "i", ",", "j"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"N", "-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"M", "-", "1"}]}], "}"}]}], "]"}], ",", "1"}], "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"func", "[", 
                RowBox[{"i", ",", "j"}], "]"}], ",", 
               RowBox[{"func", "[", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "j"}], "]"}], ",", 
               RowBox[{"func", "[", 
                RowBox[{"i", ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"func", "[", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", "j"}], "]"}], ",", 
               RowBox[{"func", "[", 
                RowBox[{
                 RowBox[{"i", "+", "1"}], ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}], ",", 
               RowBox[{"func", "[", 
                RowBox[{"i", ",", 
                 RowBox[{"j", "+", "1"}]}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "0", ",", 
             RowBox[{"N", "-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"M", "-", "1"}]}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
      "}"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6065532167602663`*^9, 3.6065533077684717`*^9}, {
  3.606553339978314*^9, 3.6065533556702113`*^9}, {3.60655345215273*^9, 
  3.606553453766822*^9}, {3.606553484510581*^9, 3.6065535192295666`*^9}, {
  3.6065536185682487`*^9, 3.6065536493200073`*^9}, {3.606553718464962*^9, 
  3.6065537427133493`*^9}, {3.6065537860728292`*^9, 3.6065538299113364`*^9}, {
  3.6065538753049326`*^9, 3.606553950997262*^9}, {3.6065540157739673`*^9, 
  3.6065540528860903`*^9}, {3.6067688938164744`*^9, 3.606768926741358*^9}, {
  3.6067692563772116`*^9, 3.606769273456188*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Facet topology", "Subsection",
 CellChangeTimes->{{3.612175287980008*^9, 3.612175296248481*^9}, {
  3.612176390496068*^9, 3.6121764020637293`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinDefault", "[", "n_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         SqrtBox["2"], 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\[Alpha]", "=", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Sin", "[", 
              RowBox[{
               RowBox[{"(", 
                FractionBox["k", 
                 RowBox[{"n", "-", "2"}]], ")"}], 
               FractionBox["\[Pi]", "2"]}], "]"}], ",", 
             RowBox[{"Cos", "[", 
              RowBox[{
               RowBox[{"(", 
                FractionBox["k", 
                 RowBox[{"n", "-", "2"}]], ")"}], 
               FractionBox["\[Pi]", "2"]}], "]"}]}], "}"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", 
          RowBox[{"n", "-", "3"}]}], "}"}]}], "]"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "5", ",", "4"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3", ",", "6", ",", "5"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"4", ",", "5", ",", "8", ",", "7"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Flatten", "[", 
       RowBox[{"{", 
        RowBox[{"5", ",", "6", ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"6", "+", "n", "-", "k"}], ",", 
           RowBox[{"{", 
            RowBox[{"k", ",", 
             RowBox[{"n", "-", "3"}]}], "}"}]}], "]"}], ",", "8"}], "}"}], 
       "]"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinPlot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"Vs_", ",", "Fs_"}], "}"}], ",", "col_"}], "]"}], ":=", 
  RowBox[{"Graphics", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Gray", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Line", "[", 
           RowBox[{"Vs", "\[LeftDoubleBracket]", 
            RowBox[{"#", "\[LeftDoubleBracket]", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"Range", "[", 
                RowBox[{"Length", "[", "#", "]"}], "]"}], ",", 
               RowBox[{"{", "1", "}"}]}], "]"}], "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], "]"}], "&"}], "/@", "Fs"}]}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Dashed", "]"}], ",", "LightGreen", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Polygon", "[", 
           RowBox[{"V", "\[LeftDoubleBracket]", 
            RowBox[{"#", ",", "All"}], "\[RightDoubleBracket]"}], "]"}], 
          "&"}], "/@", "F"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", "col", "}"}], "]"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"col", ",", 
          RowBox[{"Opacity", "[", "0.5", "]"}], ",", 
          RowBox[{"Polygon", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Mean", "[", 
              RowBox[{
              "V", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}], 
              "]"}], "&"}], "/@", 
            RowBox[{"F", "\[LeftDoubleBracket]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
             "\[RightDoubleBracket]"}]}], "]"}]}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", "Green", ",", "\[IndentingNewLine]", 
      RowBox[{"EdgeForm", "[", 
       RowBox[{"{", "Blue", "}"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Disk", "[", 
         RowBox[{"#", ",", "0.04"}], "]"}], "&"}], "/@", "Vs"}]}], 
     "\[IndentingNewLine]", "}"}], ",", 
    RowBox[{"Axes", "\[Rule]", "False"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinDecomposition", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", "sub_", ",", "ind_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"fine", "=", 
       RowBox[{"sub", ".", "V"}]}], ",", 
      RowBox[{"Freg", "=", 
       RowBox[{
        RowBox[{"DooSabinDefault", "[", "4", "]"}], "\[LeftDoubleBracket]", 
        "2", "\[RightDoubleBracket]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"DooSabinPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"V", ",", "F"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"V", ",", "F"}], "}"}], ",", "Red"}], "]"}], "}"}], ",", 
      "\"\<=\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DooSabinPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fine", "\[LeftDoubleBracket]", 
             RowBox[{
             "ind", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", "Freg"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", "Green"}], "]"}], ",", 
        "\"\<+\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"DooSabinPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fine", "\[LeftDoubleBracket]", 
             RowBox[{
             "ind", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", "Freg"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", "Green"}], "]"}], ",", 
        "\"\<+\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"DooSabinPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fine", "\[LeftDoubleBracket]", 
             RowBox[{
             "ind", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", "Freg"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", "Green"}], "]"}], ",", 
        "\"\<+\>\"", ",", "\[IndentingNewLine]", 
        RowBox[{"DooSabinPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"fine", "\[LeftDoubleBracket]", 
             RowBox[{
             "ind", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
             "\[RightDoubleBracket]"}], ",", "F"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", "Red"}], "]"}]}], "}"}]}], 
     "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GraphicsWeights", "[", 
   RowBox[{"V_", ",", "s_", ",", 
    RowBox[{"size_:", "Medium"}]}], "]"}], ":=", 
  RowBox[{"Graphics", "[", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"s", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
        "\[NotEqual]", "0"}], ",", 
       RowBox[{"Text", "[", 
        RowBox[{
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{
           "s", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], ",", 
           "Bold", ",", "size"}], "]"}], ",", 
         RowBox[{"V", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
         ",", 
         RowBox[{"Background", "\[Rule]", "LightRed"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"Length", "[", "s", "]"}]}], "}"}]}], "]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinStencils", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", "sub_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"pnt", "=", 
      RowBox[{"sub", ".", "V"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"DooSabinPlot", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"V", ",", "F"}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}], ",", 
        RowBox[{"GraphicsWeights", "[", 
         RowBox[{"V", ",", 
          RowBox[{
          "sub", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
         "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{"{", 
          RowBox[{"Red", ",", 
           RowBox[{"Disk", "[", 
            RowBox[{
             RowBox[{
             "pnt", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
             ",", "0.05"}], "]"}]}], "}"}], "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "sub", "]"}]}], "}"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V_", ",", "F_"}], "}"}], ",", "sub_", ",", "ind_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Print", "[", 
      RowBox[{"DooSabinStencils", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"V", ",", "F"}], "}"}], ",", "sub"}], "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"DooSabinDecomposition", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"V", ",", "F"}], "}"}], ",", "sub", ",", "ind"}], "]"}], 
      "]"}], ";"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6053279328724403`*^9, 3.605328023342615*^9}, {
   3.605328073853504*^9, 3.6053281294456835`*^9}, {3.6053281608344793`*^9, 
   3.605328190727189*^9}, {3.6053344118450165`*^9, 3.605334412448051*^9}, {
   3.6053379255949917`*^9, 3.6053379273090897`*^9}, {3.6056148686535444`*^9, 
   3.6056148866475735`*^9}, {3.605623319394899*^9, 3.605623323010106*^9}, {
   3.6056799995368123`*^9, 3.6056800091563625`*^9}, {3.6056800650635605`*^9, 
   3.605680075078133*^9}, {3.6056864121233034`*^9, 3.605686412642333*^9}, {
   3.605687316046005*^9, 3.6056873629646883`*^9}, {3.606000465804489*^9, 
   3.606000466110506*^9}, {3.606000496154225*^9, 3.606000517725458*^9}, {
   3.6060006614756804`*^9, 3.6060008992722816`*^9}, {3.606000965769085*^9, 
   3.606000968217225*^9}, {3.6060010137988324`*^9, 3.606001036997159*^9}, {
   3.6060010772454615`*^9, 3.6060010791785717`*^9}, 3.606001113697546*^9, {
   3.6060011679036465`*^9, 3.60600117250591*^9}, {3.6060012328363605`*^9, 
   3.6060012367525845`*^9}, {3.6060012700014863`*^9, 3.606001288791561*^9}, {
   3.6060013503740835`*^9, 3.606001361275707*^9}, {3.6060013922184763`*^9, 
   3.606001393620557*^9}, {3.6060014480266685`*^9, 3.6060015439171534`*^9}, {
   3.6060142794210863`*^9, 3.6060142806801577`*^9}, {3.6060828732180815`*^9, 
   3.606082874037128*^9}, {3.6060829137093973`*^9, 3.6060829145924473`*^9}, {
   3.606159131018979*^9, 3.6061591313469973`*^9}, {3.60616053496628*^9, 
   3.606160588145322*^9}, {3.6061607308594847`*^9, 3.606160743935232*^9}, {
   3.606245697066432*^9, 3.606245697746471*^9}, {3.6062457342265577`*^9, 
   3.6062457427050424`*^9}, {3.606475087562629*^9, 3.6064750877776327`*^9}, {
   3.606475119566121*^9, 3.606475143171484*^9}, {3.6064752302328215`*^9, 
   3.6064752398329687`*^9}, {3.606631773669779*^9, 3.6066318218885365`*^9}, {
   3.606692292087327*^9, 3.606692292825369*^9}, {3.6070292094499245`*^9, 
   3.607029219118477*^9}, 3.612309290020631*^9, {3.612309606178714*^9, 
   3.6123096174143567`*^9}, 3.6123096514583035`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinIndexing", "[", "n_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V", ",", "F"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"V", ",", "F"}], "}"}], "=", 
      RowBox[{"DooSabinDefault", "[", "n", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"DooSabinPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"V", ",", "F"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"V", ",", "F"}], "}"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"n", "\[Equal]", "4"}], ",", "Green", ",", "Red"}], 
          "]"}]}], "]"}], ",", 
       RowBox[{"GraphicsWeights", "[", 
        RowBox[{"V", ",", 
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", "V", "]"}], "]"}], ",", "Medium"}], "]"}]}], 
      "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"GetAt", "[", 
      RowBox[{"frm_", ",", 
       RowBox[{"{", 
        RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"frm", "\[LeftDoubleBracket]", 
      RowBox[{"k", ",", "j", ",", "i"}], "\[RightDoubleBracket]"}]}], ";"}], 
   "*)"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinIntegral", "[", "form_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"V", ",", "F", ",", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "form", "]"}]}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"V", ",", "F"}], "}"}], "=", 
      RowBox[{"DooSabinDefault", "[", 
       RowBox[{"n", "-", "5"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Show", "[", 
        RowBox[{
         RowBox[{"DooSabinPlot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"V", ",", "F"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"V", ",", "F"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"GraphicsWeights", "[", 
          RowBox[{"V", ",", 
           RowBox[{
            RowBox[{"form", "\[LeftDoubleBracket]", 
             RowBox[{"j", ",", "k", ",", "All"}], "\[RightDoubleBracket]"}], 
            "-", 
            RowBox[{"form", "\[LeftDoubleBracket]", 
             RowBox[{"k", ",", "j", ",", "All"}], 
             "\[RightDoubleBracket]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{"{", 
           RowBox[{"Red", ",", 
            RowBox[{"Circle", "[", 
             RowBox[{
              RowBox[{
              "V", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
              ",", "0.4"}], "]"}], ",", "Blue", ",", 
            RowBox[{"Circle", "[", 
             RowBox[{
              RowBox[{
              "V", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
              ",", "0.5"}], "]"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "n"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.606016315487542*^9, 3.606016336094721*^9}, {
  3.6060164095139203`*^9, 3.6060165875361023`*^9}, {3.6060167084960213`*^9, 
  3.6060168253447046`*^9}, {3.6060187613274364`*^9, 3.6060187840277348`*^9}, {
  3.6060192807461452`*^9, 3.606019281856209*^9}, {3.6060193161131687`*^9, 
  3.606019328766892*^9}, {3.6060194111776056`*^9, 3.606019413508739*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Animation utilities", "Subsection",
 CellChangeTimes->{{3.6121765636889744`*^9, 3.6121765698473263`*^9}, {
   3.6121773544582033`*^9, 3.612177355481262*^9}, 3.612281197503976*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinStencilList", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"rings", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", 
          RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{
           RowBox[{"rings", "\[LeftDoubleBracket]", 
            RowBox[{"F", "\[LeftDoubleBracket]", 
             RowBox[{"k", ",", "j"}], "\[RightDoubleBracket]"}], 
            "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"Length", "[", 
            RowBox[{
            "F", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
            "]"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"DooSabinStencil", "[", 
        RowBox[{
         RowBox[{
         "rings", "\[LeftDoubleBracket]", "n", "\[RightDoubleBracket]"}], ",",
          "n"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", 
         RowBox[{"Length", "[", "rings", "]"}]}], "}"}]}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinStencilPlot", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"lst", "=", 
      RowBox[{"DooSabinStencilList", "[", 
       RowBox[{"{", 
        RowBox[{"V", ",", "F"}], "}"}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Rasterize", "[", 
       RowBox[{
        RowBox[{"Show", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Graphics3D", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Opacity", "[", "0.1", "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Polygon", "[", 
                RowBox[{"V", "\[LeftDoubleBracket]", 
                 RowBox[{"#", ",", "All"}], "\[RightDoubleBracket]"}], "]"}], 
               "&"}], "/@", "F"}]}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Graphics3D", "[", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{"With", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ver", "=", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"V", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "5", ",", "4"}], "}"}], 
                    "\[RightDoubleBracket]"}], ",", "All"}], 
                   "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"V", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "6", ",", "5"}], "}"}], 
                    "\[RightDoubleBracket]"}], ",", "All"}], 
                   "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"V", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"4", ",", "5", ",", "8", ",", "7"}], "}"}], 
                    "\[RightDoubleBracket]"}], ",", "All"}], 
                   "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"V", "\[LeftDoubleBracket]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
                    RowBox[{"Reverse", "[", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"6", ",", "5"}], "}"}], ",", 
                    RowBox[{"Range", "[", 
                    RowBox[{"8", ",", 
                    RowBox[{"Length", "[", 
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "]"}]}], "]"}]}], "]"}], "]"}],
                     "\[RightDoubleBracket]"}], ",", "All"}], 
                   "\[RightDoubleBracket]"}]}], "}"}]}], 
               "\[IndentingNewLine]", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Opacity", "[", "1", "]"}], ",", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", 
                    RowBox[{
                    "lst", "\[LeftDoubleBracket]", "n", 
                    "\[RightDoubleBracket]"}], "]"}], "\[Equal]", "9"}], ",", 
                  "Green", ",", "Red"}], "]"}], ",", 
                RowBox[{"Polygon", "[", 
                 RowBox[{"Mean", "/@", 
                  RowBox[{"ver", "\[LeftDoubleBracket]", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "2", ",", "4", ",", "3"}], "}"}], 
                   "\[RightDoubleBracket]"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Opacity", "[", "0.7", "]"}], ",", "Gray", ",", 
                RowBox[{"Polygon", "/@", "ver"}]}], "}"}]}], "]"}], 
            "\[IndentingNewLine]", "}"}], "]"}], ",", 
          RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
          RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", 
          RowBox[{"ViewPoint", "\[Rule]", 
           RowBox[{"5", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "2.2"}], ",", 
              RowBox[{"-", "2.9"}], ",", "1.5"}], "}"}]}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "200"}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ImageResolution", "\[Rule]", "200"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", 
        RowBox[{"Min", "[", 
         RowBox[{
          RowBox[{"Length", "[", "lst", "]"}], ",", "300"}], "]"}]}], "}"}]}],
      "]"}]}], "]"}]}]}], "Input"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Applications", "Section",
 CellChangeTimes->{{3.605327924449959*^9, 3.6053279283121796`*^9}, {
  3.6056149079927945`*^9, 3.6056149089858513`*^9}, {3.6056228516001425`*^9, 
  3.6056228546483173`*^9}, {3.605646909007148*^9, 3.6056469329195156`*^9}, {
  3.60564698352641*^9, 3.6056469954380913`*^9}, {3.605696857837764*^9, 
  3.605696861844993*^9}, {3.605697358177382*^9, 3.605697358385394*^9}, {
  3.6123087117865577`*^9, 3.6123087140776887`*^9}}],

Cell[CellGroupData[{

Cell["Simple test", "Subsection",
 CellChangeTimes->{{3.612176085368616*^9, 3.6121760878417573`*^9}, {
  3.6121771037798653`*^9, 3.612177113539424*^9}}],

Cell[BoxData[
 RowBox[{"PlotMesh", "[", 
  RowBox[{"Nest", "[", 
   RowBox[{"DooSabinSubdivide", ",", "CubeMesh", ",", "2"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.612309371066266*^9, 3.6123093745464654`*^9}}],

Cell[BoxData[{
 RowBox[{"DooSabinVolume", "[", 
  RowBox[{"Nest", "[", 
   RowBox[{"DooSabinSubdivide", ",", "CubeMesh", ",", "1"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinVolume", "[", 
  RowBox[{"Nest", "[", 
   RowBox[{"DooSabinSubdivide", ",", "CubeMesh", ",", "2"}], "]"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.6123093863691416`*^9, 3.612309407578355*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Demo", "Subsection",
 CellChangeTimes->{{3.612176085368616*^9, 3.6121760878417573`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinDemo", "[", 
  RowBox[{"CubeMesh", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6121758752936*^9, 3.6121758824540095`*^9}, 
   3.612176750057634*^9, 3.6121771197347784`*^9, {3.6123094604483786`*^9, 
   3.6123094622004786`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinDemo", "[", 
  RowBox[{"TripodMesh", ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6121759043662634`*^9, 3.6121759052313128`*^9}, 
   3.6123094645736146`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Article", "Subsection",
 CellChangeTimes->{{3.6069472766574965`*^9, 3.606947283201871*^9}, {
  3.612176098402361*^9, 3.6121761035386553`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.6123096337272897`*^9, 3.6123096381515427`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"V", ",", "F"}], "}"}], "=", 
   RowBox[{"DooSabinDefault", "[", "5", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"V", ",", "F"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"V", ",", "F"}], "}"}], ",", "Red"}], "]"}]}], "Input",
 CellChangeTimes->{{3.607026848631893*^9, 3.6070268826188374`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derivation of coefficients", "Section",
 CellChangeTimes->{{3.605327924449959*^9, 3.6053279283121796`*^9}, {
   3.6056149079927945`*^9, 3.6056149089858513`*^9}, {3.6056228516001425`*^9, 
   3.6056228546483173`*^9}, 3.605696312889595*^9, {3.60570271998906*^9, 
   3.60570272033908*^9}, {3.605736403509533*^9, 3.6057364036745424`*^9}, {
   3.6060117398308296`*^9, 3.606011749371375*^9}, {3.6065151390956435`*^9, 
   3.6065151395236683`*^9}, {3.6066429196264505`*^9, 
   3.6066429218655787`*^9}, {3.607546641940421*^9, 3.607546642158434*^9}, 
   3.612308683445937*^9}],

Cell[CellGroupData[{

Cell["Valence 4 (general solution space)", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233784292755`*^9}, {
  3.6056963600892944`*^9, 3.605696366944687*^9}, {3.607244876780635*^9, 
  3.607244889530364*^9}}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.6065108234578032`*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "4", "]"}]], "Input",
 CellChangeTimes->{{3.607244908749463*^9, 3.607244910757578*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"], ",", 
    SubscriptBox["\[Omega]", "2"]}], "}"}], "=", 
  RowBox[{"16", " ", 
   RowBox[{"DooSabinWeight", "[", "4", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   SubscriptBox["\[Omega]", "1"], ",", 
   SubscriptBox["\[Omega]", "2"]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS4sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS4ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605623526106722*^9, 3.60562356785511*^9}, {
   3.6056238341423407`*^9, 3.605623873782608*^9}, {3.6056287677625275`*^9, 
   3.6056287914028797`*^9}, 3.605644527569937*^9, {3.6056803634436264`*^9, 
   3.6056803807856183`*^9}, {3.6059655375481844`*^9, 
   3.6059656389229827`*^9}, {3.606000562920044*^9, 3.6060005754237585`*^9}, 
   3.606001566817463*^9, {3.6072449161288853`*^9, 3.6072450200218277`*^9}, {
   3.607245078132151*^9, 3.6072451401196966`*^9}, {3.607245194256793*^9, 
   3.6072451958798857`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "4", "]"}], ",", "DS4sub", ",", 
    "DS4ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.606001609978932*^9, 3.606001610205945*^9}, {
   3.6062458169072866`*^9, 3.6062458173553123`*^9}, 3.6072449544030743`*^9, {
   3.607245198988064*^9, 3.607245200179132*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{
  3.6072448904524164`*^9, {3.607245361640367*^9, 3.607245365431584*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm4", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "9", ",", "9"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607245357929155*^9, 3.607245372338979*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Rhs", "=", 
   RowBox[{"RHS", "[", 
    RowBox[{
    "GeneralForm4", ",", "GeneralForm4", ",", "DS4sub", ",", "DS4ind"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607245545248869*^9, 3.6072455552644415`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mir", "=", 
   RowBox[{"NestP", "[", 
    RowBox[{"GeneralForm4", ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "2", ",", "1", ",", "  ", "6", ",", "5", ",", "4", ",", "  ", 
       "9", ",", "8", ",", "7"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rot", "=", 
   RowBox[{"NestP", "[", 
    RowBox[{"GeneralForm4", ",", 
     RowBox[{"{", 
      RowBox[{
      "3", ",", "6", ",", "9", ",", "  ", "2", ",", "5", ",", "8", ",", "  ", 
       "1", ",", "4", ",", "7"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.607245459898987*^9, 3.607245526803814*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"rot", "=", 
   RowBox[{"{", 
    RowBox[{
    "3", ",", "6", ",", "9", ",", "  ", "2", ",", "5", ",", "8", ",", "  ", 
     "1", ",", "4", ",", "7"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rng", "=", 
  RowBox[{"Range", "[", "9", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rng", "=", 
  RowBox[{
  "rng", "\[LeftDoubleBracket]", "rot", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rng", "=", 
  RowBox[{
  "rng", "\[LeftDoubleBracket]", "rot", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rng", "=", 
  RowBox[{
  "rng", "\[LeftDoubleBracket]", "rot", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rng", "=", 
  RowBox[{
  "rng", "\[LeftDoubleBracket]", "rot", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rng", "\[Equal]", 
  RowBox[{"Range", "[", "9", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6072455744265375`*^9, 3.6072455847301273`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BuildEssential", "[", "eqs_", "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"lst", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Normal", "[", 
          RowBox[{"CoefficientArrays", "[", 
           RowBox[{"#", ",", 
            RowBox[{"Flatten", "[", "GeneralForm4", "]"}]}], "]"}], "]"}], 
         "&"}], "/@", 
        RowBox[{"Flatten", "[", "eqs", "]"}]}]}], ",", 
      RowBox[{"out", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"1", "<", 
          RowBox[{"Length", "[", "#", "]"}]}], ",", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"out", ",", 
           RowBox[{
           "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}]}], "]"}], "&"}], "/@", "lst"}], ";", "\[IndentingNewLine]", 
     "out"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.6072459877121763`*^9, 3.607246082072573*^9}, {
  3.6073830399840045`*^9, 3.607383041566529*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"BuildEssential", "[", 
    RowBox[{"GeneralForm4", "-", "Rhs"}], "]"}]}], ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm4Null", "=", 
   RowBox[{"NullSpace", "[", "affine1", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.607280862775615*^9, {3.6102983322893295`*^9, 3.610298333503399*^9}}],

Cell[BoxData[{
 RowBox[{"DooSabinForm4Null", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"LinearSolve", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "DooSabinForm4Null", "]"}], ",", 
   RowBox[{"Flatten", "[", "DooSabinForm4", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.60728086653383*^9, 3.60728086757789*^9}, {
  3.6072809399010267`*^9, 3.60728094013804*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"affine2", "=", 
   RowBox[{"BuildEssential", "[", 
    RowBox[{"GeneralForm4", "+", "Mir"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"affine3", "=", 
   RowBox[{"BuildEssential", "[", 
    RowBox[{"GeneralForm4", "-", "Rot"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6072457915999594`*^9, 3.607245895920926*^9}, 
   3.6072460094634204`*^9, {3.607246105253899*^9, 3.607246113294359*^9}, {
   3.6072461772930193`*^9, 3.607246194550007*^9}, 3.60728084100737*^9, 
   3.6072809440552645`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"affine1", ",", "affine2", ",", "affine3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"matrix", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6072461148974504`*^9, 3.607246119829733*^9}, {
  3.607246200830366*^9, 3.607246222442602*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinForm4Null", "=", 
   RowBox[{"NullSpace", "[", "matrix", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinForm4Null", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.607246244702875*^9, 3.607246252444318*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSpace", "[", 
   RowBox[{"Join", "[", 
    RowBox[{"affine1", ",", "affine3"}], "]"}], "]"}], "//", 
  "Dimensions"}]], "Input",
 CellChangeTimes->{{3.610298437079323*^9, 3.6102984726413565`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm4Null", ">>", "\"\<DooSabinForm4Null.mx\>\""}]], "Input",
 CellChangeTimes->{{3.607246260227763*^9, 3.6072462684362326`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinForm4Null", "=", 
   RowBox[{"<<", "\"\<DooSabinForm4Null.mx\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinForm4Null", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.607383091419794*^9, 3.6073831028674707`*^9}, {
  3.60754635990129*^9, 3.6075463618854027`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinForm4Free3", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["\[Alpha]", "1"], ",", 
        SubscriptBox["\[Alpha]", "2"], ",", 
        SubscriptBox["\[Alpha]", "3"]}], "}"}], ".", "DooSabinForm4Null"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"9", ",", "9", ",", "9"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinForm4Free3", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.607246442683199*^9, 3.607246503298666*^9}, {
  3.6075464078140297`*^9, 3.6075464111132183`*^9}}],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"0", "\[Equal]", "#"}], "&"}], "/@", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Skew3", "[", 
     RowBox[{"DooSabinForm4Free3", "-", 
      RowBox[{"<<", "\"\<DooSabinForm4.mx\>\""}]}], "]"}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6072465141302853`*^9, 3.6072465397627516`*^9}, {
  3.607246932888237*^9, 3.6072469413917236`*^9}, {3.607546384060671*^9, 
  3.6075463905650434`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
  RowBox[{"DooSabinForm4Free3", "\[LeftDoubleBracket]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{{3.6072462876673326`*^9, 3.6072462937236795`*^9}, {
  3.607246599561172*^9, 3.6072466270167427`*^9}, {3.607246920632536*^9, 
  3.6072469258068323`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
  RowBox[{"DooSabinForm4", "\[LeftDoubleBracket]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{3.6072466681610956`*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calibration of 1st DOF", "Subsection",
 CellChangeTimes->{{3.606378196577406*^9, 3.6063782068569937`*^9}, {
  3.6063791489238772`*^9, 3.606379149377903*^9}, {3.607340556836029*^9, 
  3.607340557043532*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"V", ",", "F"}], "}"}], "=", "CubeMesh"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Vs", ",", "Fs"}], "}"}], "=", 
   RowBox[{"Nest", "[", 
    RowBox[{"QuadLinearSubdivide", ",", 
     RowBox[{"{", 
      RowBox[{"V", ",", "F"}], "}"}], ",", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Vn", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"V", "\[LeftDoubleBracket]", 
      RowBox[{
       RowBox[{"Sort", "[", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"With", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"dif", "=", 
              RowBox[{
               RowBox[{
               "Vs", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
               "-", 
               RowBox[{
               "V", "\[LeftDoubleBracket]", "j", 
                "\[RightDoubleBracket]"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"N", "[", 
               RowBox[{"dif", ".", "dif"}], "]"}], ",", "j"}], "}"}]}], "]"}],
           ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", 
            RowBox[{"Length", "[", "V", "]"}]}], "}"}]}], "]"}], "]"}], 
       "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], 
      "\[RightDoubleBracket]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"Length", "[", "Vs", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.607247290727704*^9, 3.607247293305852*^9}, {
   3.607247325001665*^9, 3.6072473323690863`*^9}, 3.6073829616078005`*^9, {
   3.6073831512582135`*^9, 3.6073831776236186`*^9}, {3.6073833382335854`*^9, 
   3.6073833657690086`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Rasterize", "[", 
    RowBox[{
     RowBox[{"Show", "[", 
      RowBox[{
       RowBox[{"PlotMesh", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", "\[Lambda]"}], ")"}], " ", "Vs"}], "+", 
            RowBox[{"\[Lambda]", " ", "Vn"}]}], ",", "Fs"}], "}"}], "/.", 
         RowBox[{"\[Lambda]", "\[Rule]", "#"}]}], "]"}], ",", 
       RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
       RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
       RowBox[{"Axes", "\[Rule]", "False"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "80"}]}], "]"}], ",", 
     RowBox[{"ImageResolution", "\[Rule]", "200"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0.4", ",", "0.7", ",", "1"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.6073832925903845`*^9, 3.607383301150516*^9}, {
  3.60738397330084*^9, 3.6073839764983892`*^9}, {3.6075474494396076`*^9, 
  3.6075474538618603`*^9}}],

Cell[BoxData[
 RowBox[{"Rasterize", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"PlotMesh", "[", 
      RowBox[{"Nest", "[", 
       RowBox[{"DooSabinSubdivide", ",", 
        RowBox[{"{", 
         RowBox[{"Vn", ",", "Fs"}], "}"}], ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
     RowBox[{"Axes", "\[Rule]", "False"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "80"}]}], "]"}], ",", 
   RowBox[{"ImageResolution", "\[Rule]", "200"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6073840224165945`*^9, 3.6073840370718193`*^9}, {
   3.607384067545788*^9, 3.6073840854085617`*^9}, {3.6075474809484096`*^9, 
   3.6075475131902537`*^9}, 3.6083656277719545`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinForm4", "=", "DooSabinForm4Free3"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinForm3", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["b", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "8", ",", "8"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6072473586355886`*^9, 3.6072474050192413`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DSRing", "[", 
   RowBox[{"V_", ",", "F_", ",", "f_", ",", "ind_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fn", "=", 
       RowBox[{"RotateLeft", "[", 
        RowBox[{"f", ",", 
         RowBox[{"ind", "-", "1"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      "v1", ",", "v2", ",", "adj", ",", 
      RowBox[{"wlk", "=", 
       RowBox[{"{", "}"}]}], ",", 
      RowBox[{"count", "=", "0"}], ",", 
      RowBox[{"RM", "=", 
       RowBox[{"DooSabinMatrix", "[", "4", "]"}]}], ",", "P1", ",", "P2", ",",
       "P3"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"adj", "=", "fn"}], ";", "\[IndentingNewLine]", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"wlk", ",", "adj"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"++", "count"}], "<", "10"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"v1", "=", 
         RowBox[{
         "adj", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"v2", "=", 
         RowBox[{
         "adj", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"adj", "=", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{"F", ",", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Union", "[", "#", "]"}], "\[NotEqual]", 
               RowBox[{"Union", "[", "adj", "]"}]}], "\[And]", 
              RowBox[{"MemberQ", "[", 
               RowBox[{"#", ",", "v1"}], "]"}], "\[And]", 
              RowBox[{"MemberQ", "[", 
               RowBox[{"#", ",", "v2"}], "]"}]}], "&"}]}], "]"}], 
          "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"adj", "=", 
         RowBox[{"RotateLeft", "[", 
          RowBox[{"adj", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{"adj", ",", "v1"}], "]"}], "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "-", "1"}]}],
           "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"adj", "\[Equal]", "fn"}], ",", 
          RowBox[{"Break", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"wlk", ",", "adj"}], "]"}]}]}], "\[IndentingNewLine]", "]"}],
      ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", "wlk", "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"P1", "=", 
      RowBox[{"RM", ".", 
       RowBox[{"V", "\[LeftDoubleBracket]", 
        RowBox[{"wlk", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
         "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"P2", "=", 
      RowBox[{"RM", ".", 
       RowBox[{"V", "\[LeftDoubleBracket]", 
        RowBox[{"wlk", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
         "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"P3", "=", 
      RowBox[{"RM", ".", 
       RowBox[{"V", "\[LeftDoubleBracket]", 
        RowBox[{"Last", "[", "wlk", "]"}], "\[RightDoubleBracket]"}]}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"Transpose", "[", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
          "P1", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "P1", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "P2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
          "P1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "P1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "P2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
          "P3", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "P3", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"RM", ".", 
              RowBox[{
              "V", "\[LeftDoubleBracket]", "#", "\[RightDoubleBracket]"}]}], 
             ")"}], "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
           "&"}], "/@", 
          RowBox[{"Reverse", "[", 
           RowBox[{"Take", "[", 
            RowBox[{"wlk", ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", 
               RowBox[{
                RowBox[{"Length", "[", "wlk", "]"}], "-", "1"}]}], "}"}]}], 
            "]"}], "]"}]}], ")"}]}], "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinVolumeSlow", "[", 
   RowBox[{"{", 
    RowBox[{"V_", ",", "F_"}], "}"}], "]"}], ":=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"point", "=", 
         RowBox[{"DSRing", "[", 
          RowBox[{"V", ",", "F", ",", 
           RowBox[{
           "F", "\[LeftDoubleBracket]", "m", "\[RightDoubleBracket]"}], ",", 
           "k"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"With", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"val", "=", 
           RowBox[{
            RowBox[{"Length", "[", 
             RowBox[{
             "point", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
             "]"}], "-", "5"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"With", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"frm", "=", 
             RowBox[{"Switch", "[", 
              RowBox[{
              "val", ",", "\[IndentingNewLine]", "3", ",", "DooSabinForm3", 
               ",", "\[IndentingNewLine]", "4", ",", "DooSabinForm4", ",", 
               "\[IndentingNewLine]", "5", ",", "DooSabinForm5", ",", 
               "\[IndentingNewLine]", "6", ",", "DooSabinForm6", ",", 
               "\[IndentingNewLine]", "7", ",", "DooSabinForm7", ",", 
               "\[IndentingNewLine]", "8", ",", "DooSabinForm8", ",", 
               "\[IndentingNewLine]", "9", ",", "DooSabinForm9", ",", 
               "\[IndentingNewLine]", "10", ",", "DooSabinForm10", ",", 
               "\[IndentingNewLine]", "11", ",", "DooSabinForm11", ",", 
               "\[IndentingNewLine]", "_", ",", 
               RowBox[{"Message", "[", 
                RowBox[{"VolumeForm", "::", "valence"}], "]"}]}], "]"}]}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Skew3", "[", "frm", "]"}], ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
            ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
            ".", 
            RowBox[{
            "point", "\[LeftDoubleBracket]", "3", 
             "\[RightDoubleBracket]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
        "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"m", ",", 
       RowBox[{"Length", "[", "F", "]"}]}], "}"}]}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.608365756636325*^9, 3.608365766607896*^9}}],

Cell[BoxData[
 RowBox[{"LinearVolume", "[", 
  RowBox[{"{", 
   RowBox[{"Vn", ",", "Fs"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.6072474198600903`*^9, 3.60724742055513*^9}, {
  3.607281063518097*^9, 3.6072810664062624`*^9}}],

Cell[BoxData[
 RowBox[{"volumeEqs", "=", 
  RowBox[{
   RowBox[{"DooSabinVolumeSlow", "[", 
    RowBox[{"{", 
     RowBox[{"Vn", ",", "Fs"}], "}"}], "]"}], "\[Equal]", 
   RowBox[{"LinearVolume", "[", 
    RowBox[{"{", 
     RowBox[{"Vn", ",", "Fs"}], "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6072474292736287`*^9, 3.6072474796755114`*^9}, {
   3.607247557344954*^9, 3.607247560050109*^9}, 3.6072810686053877`*^9, 
   3.6083657728312516`*^9}],

Cell[BoxData[{
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"Solve", "[", 
    RowBox[{"volumeEqs", ",", 
     SubscriptBox["\[Alpha]", "3"]}], "]"}], "//", 
   "Simplify"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinForm4Free2", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"DooSabinForm4Free3", "/.", 
     RowBox[{"sol", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6072475243320656`*^9, 3.6072475875506816`*^9}}],

Cell[BoxData[{
 RowBox[{"DooSabinForm4Free2", "//", "Variables"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Skew3", "[", "DooSabinForm4Free2", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}], ")"}], 
    "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{
  3.607281102852347*^9, {3.607281156198398*^9, 3.6072811978867826`*^9}}],

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"0", "\[Equal]", "#"}], "&"}], "/@", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Skew3", "[", 
     RowBox[{"DooSabinForm4Free2", "-", 
      RowBox[{"<<", "\"\<DooSabinForm4.mx\>\""}]}], "]"}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.607247647332101*^9, {3.6072476800519724`*^9, 3.6072476835061703`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DooSabinForm4", "=", 
   RowBox[{
    RowBox[{"DooSabinForm4Free2", "/.", 
     RowBox[{
      SubscriptBox["\[Alpha]", "1"], "\[Rule]", "0"}]}], "/.", 
    RowBox[{
     SubscriptBox["\[Alpha]", "2"], "\[Rule]", "0"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DooSabinForm4", ">>", "\"\<DooSabinAlt4.mx\>\""}]}], "Input",
 CellChangeTimes->{{3.6072812458615265`*^9, 3.607281268666831*^9}}],

Cell[BoxData[
 RowBox[{"Union", "[", 
  RowBox[{"Abs", "[", 
   RowBox[{"Flatten", "[", "DooSabinForm4", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.60728132652314*^9, 3.6072813364257064`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm4", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{
  3.6072476002364073`*^9, {3.6072477026912675`*^9, 3.607247714186925*^9}, {
   3.6072812225881953`*^9, 3.607281224190287*^9}, {3.6072812980395107`*^9, 
   3.60728131987676*^9}, 3.607281566643874*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Valence 3", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233784292755`*^9}, {
  3.6056963600892944`*^9, 3.605696366944687*^9}}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.6065108234578032`*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "3", "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "2"]}], "}"}], "=", 
   RowBox[{"16", " ", 
    RowBox[{"DooSabinWeight", "[", "3", "]"}]}]}], ";", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS3sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1"},
       {"0", "0", "0", "3", "9", "0", "1", "3"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3"},
       {"0", "0", "0", "1", "3", "0", "3", "9"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS3ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605623526106722*^9, 3.60562356785511*^9}, {
   3.6056238341423407`*^9, 3.605623873782608*^9}, {3.6056287677625275`*^9, 
   3.6056287914028797`*^9}, 3.605644527569937*^9, {3.6056803634436264`*^9, 
   3.6056803807856183`*^9}, {3.6059655375481844`*^9, 
   3.6059656389229827`*^9}, {3.606000562920044*^9, 3.6060005754237585`*^9}, 
   3.606001566817463*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "3", "]"}], ",", "DS3sub", ",", 
    "DS3ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.606001609978932*^9, 3.606001610205945*^9}, {
  3.6062458169072866`*^9, 3.6062458173553123`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SUB", "=", 
   RowBox[{"DS3sub", "\[LeftDoubleBracket]", 
    RowBox[{"DS3ind", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
    "\[RightDoubleBracket]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"SUB", "//", "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.606720655850067*^9, 3.606720683442645*^9}, {
   3.60672100172985*^9, 3.60672100592809*^9}, {3.606721062298314*^9, 
   3.6067210639764104`*^9}, 3.6067212869851656`*^9, 3.6076217811084538`*^9, 
   3.6076412676949043`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Eigensystem", "[", 
   RowBox[{"SUB", "//", "Transpose"}], "]"}], "\[LeftDoubleBracket]", "1", 
  "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.6076217007518578`*^9, 3.6076217205399895`*^9}, {
  3.607727805683078*^9, 3.607727807226166*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.6056459833952055`*^9, 3.6056459893175445`*^9}, {
  3.6056964913278008`*^9, 3.6056965130550437`*^9}, {3.6065108297941656`*^9, 
  3.6065108310172358`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm3", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "8", ",", "8"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6056233521867743`*^9, 3.6056233902269506`*^9}, 
   3.605623495750986*^9, {3.6056799017582197`*^9, 3.605679914208932*^9}, 
   3.605679976213478*^9, {3.605680025240282*^9, 3.605680040530157*^9}, {
   3.6056800958383207`*^9, 3.605680185222433*^9}, 3.605680249966136*^9, {
   3.605680280892905*^9, 3.6056803189730835`*^9}, {3.6056863919401493`*^9, 
   3.605686399854602*^9}, {3.605686817407484*^9, 3.605686819028577*^9}, {
   3.6060015827473745`*^9, 3.6060015918098927`*^9}, {3.606001653712433*^9, 
   3.606001678503851*^9}, 3.6061591094037423`*^9, 3.606159170016209*^9, {
   3.6061607935830717`*^9, 3.606160803807657*^9}, {3.606168991533968*^9, 
   3.6061690038626733`*^9}, 3.60624582903198*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm3", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm3", "-", "\[IndentingNewLine]", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm3", ",", "DS3sub", ",", "DS3ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.6062462029763684`*^9, {3.6062462914254274`*^9, 3.606246324935344*^9}, 
   3.606246814675356*^9, {3.606475339817004*^9, 3.606475393917835*^9}, {
   3.606476254816058*^9, 3.6064762559910765`*^9}, 3.606721183470245*^9, 
   3.606721379268444*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.6067207610630846`*^9, 3.6067207652183228`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{
    RowBox[{"IdentityMatrix", "[", "512", "]"}], "-", 
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"i", ",", "a"}], "\[RightDoubleBracket]"}], " ", 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"j", ",", "b"}], "\[RightDoubleBracket]"}], 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"k", ",", "c"}], "\[RightDoubleBracket]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "8"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"512", ",", "512"}], "}"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"matrix", "-", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
   "]"}], "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.6067207278581853`*^9, 3.606720988219077*^9}, {
  3.606721049267569*^9, 3.606721079912322*^9}, {3.606721238754407*^9, 
  3.606721263685833*^9}, {3.606721300831958*^9, 3.6067213314947114`*^9}, {
  3.606721394985343*^9, 3.6067214042058706`*^9}, {3.606721448691415*^9, 
  3.606721470529664*^9}, {3.6070338142126207`*^9, 3.607033817883831*^9}, {
  3.60703413764312*^9, 3.6070341556981525`*^9}, {3.6070342193707943`*^9, 
  3.607034221280904*^9}, {3.6070343303041396`*^9, 3.6070343330332956`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"i", ",", "a"}], "\[RightDoubleBracket]"}], " ", 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"j", ",", "b"}], "\[RightDoubleBracket]"}], 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"k", ",", "c"}], "\[RightDoubleBracket]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"c", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"b", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"a", ",", "8"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"512", ",", "512"}], "}"}]}], "]"}], "-", 
    RowBox[{"IdentityMatrix", "[", "512", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"matrix", "+", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
   "]"}], "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.6070342825774097`*^9, 3.6070342847205324`*^9}, {
  3.6070343177454214`*^9, 3.6070343290010653`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"a", ",", "i"}], "\[RightDoubleBracket]"}], " ", 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"b", ",", "j"}], "\[RightDoubleBracket]"}], 
           RowBox[{"SUB", "\[LeftDoubleBracket]", 
            RowBox[{"c", ",", "k"}], "\[RightDoubleBracket]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"c", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"b", ",", "8"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"a", ",", "8"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "8"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "8"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"512", ",", "512"}], "}"}]}], "]"}], "-", 
    RowBox[{"IdentityMatrix", "[", "512", "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Flatten", "[", 
   RowBox[{"matrix", "+", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
   "]"}], "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.6070342825774097`*^9, 3.6070342847205324`*^9}, {
  3.6070343177454214`*^9, 3.6070343290010653`*^9}, {3.607034387202394*^9, 
  3.607034407160536*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NullSpace", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "8", ",", "8"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
  "nul"}]}], "Input",
 CellChangeTimes->{{3.607620870191353*^9, 3.607620937923227*^9}, 
   3.607621457814963*^9}],

Cell["\<\
NOTE the minus sign in front of the \[OpenCurlyDoubleQuote]Flatten\
\[CloseCurlyDoubleQuote]\
\>", "Text",
 CellChangeTimes->{{3.607162057396263*^9, 3.6071620683868914`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"mat", ",", "vec"}], "}"}], "=", 
   RowBox[{"Corollary2", "[", 
    RowBox[{"DS3sub", ",", "DS3ind", ",", "DooSabinForm4"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6071626951317396`*^9, 3.607162719707145*^9}, {
  3.6071628348067284`*^9, 3.6071628395009966`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"vector", "=", 
   RowBox[{"-", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"NestT", "[", 
       RowBox[{"DooSabinForm4", ",", 
        RowBox[{"DS3sub", "\[LeftDoubleBracket]", 
         RowBox[{
         "DS3ind", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         "\[RightDoubleBracket]"}]}], "]"}], "+", 
      RowBox[{"NestT", "[", 
       RowBox[{"DooSabinForm4", ",", 
        RowBox[{"DS3sub", "\[LeftDoubleBracket]", 
         RowBox[{
         "DS3ind", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
         "\[RightDoubleBracket]"}]}], "]"}], "+", 
      RowBox[{"NestT", "[", 
       RowBox[{"DooSabinForm4", ",", 
        RowBox[{"DS3sub", "\[LeftDoubleBracket]", 
         RowBox[{
         "DS3ind", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
         "\[RightDoubleBracket]"}]}], "]"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vector", "+", 
   RowBox[{"(", 
    RowBox[{"-", 
     RowBox[{
     "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
    ")"}]}], "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.6067218044057603`*^9, 3.606721893547859*^9}, {
  3.6070346954520245`*^9, 3.607034706246642*^9}, {3.607034823452346*^9, 
  3.6070348362820797`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol1", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{
     "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6071622402657223`*^9, 3.6071622473171263`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol2", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{"matrix", ",", "vector"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607162251222349*^9, 3.60716227675381*^9}, {
  3.607162850487625*^9, 3.6071628719038506`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol3", "=", 
   RowBox[{"LinearSolve", "@@", 
    RowBox[{"{", 
     RowBox[{"mat", ",", "vec"}], "}"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607162853048772*^9, 3.607162868977683*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol1", "-", "sol3"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.6071622611619177`*^9, 3.6071622631690326`*^9}, 
   3.6071628736569505`*^9, {3.60716290563678*^9, 3.6071629069488544`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"dsForm3", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{"sol1", ",", 
     RowBox[{"Dimensions", "[", "GeneralForm3", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.607163015241049*^9, 3.607163021696418*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror3", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", 
     "6"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror3", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex3", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror3", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti3", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "8", " ", "8"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "8"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror3", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", 
     "6"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "8", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress3", ",", "inflate3"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "8"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex3", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti3", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress3", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress3"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"MatrixRank", "[", 
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress3", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606475952048908*^9, 3.606475966001622*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
     "#", "\[LeftDoubleBracket]", "inflate3", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"NullSpace", "[", 
     RowBox[{"Compress3", "[", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nul", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606462536417879*^9, 3.60646255024967*^9}, 
   3.606464157033573*^9, {3.6064652563384495`*^9, 3.6064652608327065`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Skew3", "[", 
    RowBox[{"ArrayReshape", "[", 
     RowBox[{"nul", ",", 
      RowBox[{"Dimensions", "[", "GeneralForm3", "]"}]}], "]"}], "]"}], "//", 
   "Flatten"}], "//", "Union"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{"Compress3", "[", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sol", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6064760416002836`*^9, 3.6064760515604362`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm3", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{
     RowBox[{
     "sol", "\[LeftDoubleBracket]", "inflate3", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{"Dimensions", "[", "GeneralForm3", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056450882710075`*^9, 3.6056451301284018`*^9}, {
   3.605645311734789*^9, 3.6056453137419033`*^9}, {3.605645642456705*^9, 
   3.6056456938796463`*^9}, {3.605645728581631*^9, 3.6056457340199423`*^9}, 
   3.6056566941628213`*^9, 3.6056568003908973`*^9, {3.605681550012494*^9, 
   3.6056815552197924`*^9}, {3.605686469340576*^9, 3.605686479842177*^9}, 
   3.6057329227204432`*^9, {3.6057330426083*^9, 3.605733044246394*^9}, {
   3.6057402349476786`*^9, 3.6057402386368895`*^9}, {3.605777810958691*^9, 
   3.605777811916746*^9}, {3.606247304968399*^9, 3.606247307743558*^9}, {
   3.6064760638606253`*^9, 3.6064760692407084`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm3", "\[LeftDoubleBracket]", 
  RowBox[{"1", ",", "3", ",", "5"}], "\[RightDoubleBracket]"}]], "Input",
 CellChangeTimes->{{3.607167304663791*^9, 3.607167314186336*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm3", ">>", "\"\<DooSabinAlt3.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.607281665993557*^9, 3.6072816666665955`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"unique", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"DooSabinForm3", "//", "Abs"}], "//", "Flatten"}], "//", 
    "Union"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"unique", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"1", "-", 
    RowBox[{"Unitize", "[", "DooSabinForm3", "]"}]}], "//", "Flatten"}], "//",
   "Total"}]}], "Input",
 CellChangeTimes->{{3.606169474592597*^9, 3.6061695051743464`*^9}, {
  3.6062465838691545`*^9, 3.606246617310067*^9}, {3.6062466717651815`*^9, 
  3.606246677243495*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm3", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.60728167146987*^9, 3.607281697195341*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Symmetry study", "Subsubsection",
 CellChangeTimes->{{3.606506039059151*^9, 3.606506046419572*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GiveValue", "[", 
   RowBox[{"form_", ",", "val_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ret", "=", 
      RowBox[{"{", "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"form", "\[LeftDoubleBracket]", 
           RowBox[{"k", ",", "j", ",", "i"}], "\[RightDoubleBracket]"}], 
          "\[Equal]", "val"}], ",", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"ret", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], "]"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", 
         RowBox[{"Length", "[", "form", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", 
         RowBox[{"Length", "[", "form", "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "form", "]"}]}], "}"}]}], "]"}], ";", 
     "\[IndentingNewLine]", "ret"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.60616862406495*^9, 3.606168682265279*^9}, {
  3.606168715368172*^9, 3.606168780155878*^9}, {3.606171526661969*^9, 
  3.60617158035804*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"val", "=", 
         RowBox[{
         "unique", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}]}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"val", ",", 
         RowBox[{"GiveValue", "[", 
          RowBox[{"DooSabinForm3", ",", "val"}], "]"}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"val", "\[Equal]", "0"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"GiveValue", "[", 
            RowBox[{"DooSabinForm3", ",", 
             RowBox[{"-", "val"}]}], "]"}]}], "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"Length", "[", "unique", "]"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6061690515193987`*^9, 3.6061691053204765`*^9}, {
  3.6061695148088975`*^9, 3.6061695634266787`*^9}, {3.6061695982596707`*^9, 
  3.6061696556199512`*^9}, {3.6061716210573683`*^9, 3.6061716257496367`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrientedA", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"DooSabinPlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"V", ",", "F"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"V", ",", "F"}], "}"}], ",", "Red"}], "]"}], ",", 
    RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Red", ",", 
       RowBox[{"Disk", "[", 
        RowBox[{
         RowBox[{"V", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
         ",", ".15"}], "]"}], ",", "\[IndentingNewLine]", "Green", ",", 
       RowBox[{"Circle", "[", 
        RowBox[{
         RowBox[{"V", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
         ",", ".18"}], "]"}], ",", 
       RowBox[{"Rectangle", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"V", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
           "+", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.5"}], ",", 
             RowBox[{"-", "0.1"}]}], "}"}], "0.5"}]}], ",", 
         RowBox[{
          RowBox[{"V", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
           "+", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.1"}], "}"}], "0.5"}]}]}], "]"}], ",", 
       "\[IndentingNewLine]", "Blue", ",", 
       RowBox[{"Circle", "[", 
        RowBox[{
         RowBox[{"V", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
         ",", ".16"}], "]"}], ",", 
       RowBox[{"Rectangle", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"V", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}],
           "+", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "0.1"}], ",", 
             RowBox[{"-", "0.5"}]}], "}"}], "0.5"}]}], ",", 
         RowBox[{
          RowBox[{"V", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}],
           "+", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.1", ",", "0.5"}], "}"}], "0.5"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6061716972977285`*^9, 3.6061718387158175`*^9}, {
  3.606171893427947*^9, 3.606171905640645*^9}, {3.6061720375791917`*^9, 
  3.60617204401856*^9}, {3.606172089955188*^9, 3.606172214166292*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShowSymmetries", "[", "index_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Print", "[", 
       RowBox[{"res", "\[LeftDoubleBracket]", 
        RowBox[{"index", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OrientedA", "[", "#", "]"}], "&"}], "/@", 
        RowBox[{"res", "\[LeftDoubleBracket]", 
         RowBox[{"index", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"OrientedA", "[", "#", "]"}], "&"}], "/@", 
        RowBox[{"res", "\[LeftDoubleBracket]", 
         RowBox[{"index", ",", "3"}], "\[RightDoubleBracket]"}]}], "]"}], 
      ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.606171823426943*^9, 3.6061718644002867`*^9}, {
  3.606171925768797*^9, 3.606171976233683*^9}, {3.606172018896123*^9, 
  3.6061720237213993`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"V", ",", "F"}], "}"}], "=", 
   RowBox[{"DooSabinDefault", "[", "3", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ShowSymmetries", "[", "k", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", 
        RowBox[{"Length", "[", "res", "]"}]}], "}"}]}], "]"}], ";"}], 
   "*)"}]}]}], "Input",
 CellChangeTimes->{{3.606172003863263*^9, 3.6061720108876653`*^9}, 
   3.6061722026536336`*^9, {3.606172247582203*^9, 3.6061723445347486`*^9}, {
   3.606246728308416*^9, 3.6062467551569514`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 5", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.606510815065323*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "5", "]"}]], "Input",
 CellChangeTimes->{3.606506185293515*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "2"]}], "}"}], "=", 
   RowBox[{
    RowBox[{"16", " ", 
     RowBox[{"DooSabinWeight", "[", "5", "]"}]}], "//", "Expand"}]}], ";", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"]}], "}"}], "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"8", ",", 
     RowBox[{"2", "+", 
      RowBox[{"2", " ", "s"}]}], ",", 
     RowBox[{"2", "-", 
      RowBox[{"2", " ", "s"}]}]}], "}"}], "//", 
   "Expand"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS5sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS5ind", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6060018680146904`*^9, 3.6060018801133823`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "5", "]"}], ",", 
    RowBox[{"DS5sub", "/.", 
     RowBox[{"s", "\[Rule]", 
      RowBox[{"1", "/", 
       SqrtBox["5"]}]}]}], ",", "DS5ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060018867337613`*^9, 3.6060018984634323`*^9}, {
  3.606001985987438*^9, 3.60600198619845*^9}, {3.6062469490270405`*^9, 
  3.606246949498067*^9}, {3.6062474482165923`*^9, 3.606247456601072*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Solving over ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[DoubleStruckCapitalQ]", "+", 
    RowBox[{
     SqrtBox["5"], "\[DoubleStruckCapitalQ]"}]}], TraditionalForm]]],
 " "
}], "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, {
  3.606247845731329*^9, 3.6062478596791267`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm5", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "10", ",", "10"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6056233521867743`*^9, 3.6056233902269506`*^9}, 
   3.605623495750986*^9, {3.6056799017582197`*^9, 3.605679914208932*^9}, 
   3.605679976213478*^9, {3.605680025240282*^9, 3.605680040530157*^9}, {
   3.6056800958383207`*^9, 3.605680185222433*^9}, 3.605680249966136*^9, {
   3.605680280892905*^9, 3.6056803189730835`*^9}, {3.6056863919401493`*^9, 
   3.605686399854602*^9}, {3.605686817407484*^9, 3.605686819028577*^9}, {
   3.6060015827473745`*^9, 3.6060015918098927`*^9}, {3.606001653712433*^9, 
   3.606001678503851*^9}, 3.6061591094037423`*^9, 3.606159170016209*^9, {
   3.6061607935830717`*^9, 3.606160803807657*^9}, {3.606168991533968*^9, 
   3.6061690038626733`*^9}, 3.60624582903198*^9, {3.6062469718383446`*^9, 
   3.606246978170707*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm5", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm5", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm5", ",", "DS5sub", ",", "DS5ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NullSpace", "[", 
       RowBox[{
        RowBox[{
        "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "/.", 
        RowBox[{"s", "\[Rule]", 
         RowBox[{"1.", "/", 
          SqrtBox["5"]}]}]}], "]"}], "\[LeftDoubleBracket]", "1", 
      "\[RightDoubleBracket]"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "10", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Print", "[", 
    RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
  RowBox[{"Chop", "[", "nul", "]"}]}]}], "Input",
 CellChangeTimes->{{3.607621488350709*^9, 3.6076214924069414`*^9}, {
  3.6076215276449566`*^9, 3.607621561821912*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"rep", "=", 
   RowBox[{"N", "[", 
    RowBox[{"affine1", "/.", 
     RowBox[{"s", "\[Rule]", 
      RowBox[{"1", "/", 
       SqrtBox["5"]}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6071648713716145`*^9, 3.60716489488796*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"rep", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.6071636197306232`*^9, 3.6071636230678144`*^9}, {
  3.6071649026594048`*^9, 3.6071649032114363`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "//", "Flatten"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.607164497226215*^9, 3.607164516449314*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol1", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{"rep", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{"-", 
      RowBox[{
      "rep", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.607163447437769*^9, 3.607163494185443*^9}, {
  3.6071636279290924`*^9, 3.6071636283831186`*^9}, {3.6071645504812613`*^9, 
  3.607164585523265*^9}, {3.6071649209304495`*^9, 3.6071649327901278`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sol2", "=", 
   RowBox[{"LinearSolve", "@@", 
    RowBox[{"Corollary2", "[", 
     RowBox[{
      RowBox[{"N", "[", 
       RowBox[{"DS5sub", "/.", 
        RowBox[{"s", "\[Rule]", 
         RowBox[{"1", "/", 
          SqrtBox["5"]}]}]}], "]"}], ",", "DS5ind", ",", "DooSabinForm4"}], 
     "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6071634666748695`*^9, 3.6071635032919636`*^9}, {
  3.607164946175894*^9, 3.6071649596986666`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sol1", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{"sol1", ",", 
     RowBox[{"Dimensions", "[", "GeneralForm5", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sol2", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{"sol2", ",", 
     RowBox[{"Dimensions", "[", "GeneralForm5", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Skew3", "[", "Sol1", "]"}], "-", 
     RowBox[{"Skew3", "[", "Sol2", "]"}]}], "//", "Flatten"}], "//", "Chop"}],
   "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.6071654185489116`*^9, 3.607165453750925*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror5", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "10", ",", "9"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror5", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex5", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror5", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti5", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "10", " ", "10"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "10"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror5", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "10", ",", "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "10", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress5", ",", "inflate5"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "10"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex5", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti5", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress5", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress5"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"Compress5", "[", 
    RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vector", "=", 
   RowBox[{"-", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"matrix", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"vector", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605902428728287*^9, 3.6059024298513513`*^9}, {
  3.605903620610459*^9, 3.605903630825043*^9}, {3.606247389591239*^9, 
  3.6062473955065775`*^9}, {3.606506489617922*^9, 3.6065065046677823`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Abig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"mat", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", 
         RowBox[{"Flatten", "[", "matrix", "]"}]}]}], ",", "A1", ",", "A2"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A1", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], "/", 
           "5"}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"A2", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}], "/", 
           "5"}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayFlatten", "[", 
       RowBox[{"(", GridBox[{
          {"A1", 
           RowBox[{"A2", "/", "5"}]},
          {"A2", "A1"}
         }], ")"}], "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Abig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6059018202024813`*^9, 3.605901876088678*^9}, {
  3.6059019797526073`*^9, 3.605902108843991*^9}, {3.60590230744335*^9, 
  3.605902401074705*^9}, {3.60590243542667*^9, 3.6059024380588207`*^9}, {
  3.6059036403075857`*^9, 3.605903765512747*^9}, {3.6059037983406243`*^9, 
  3.6059038132964797`*^9}, {3.6062475368126593`*^9, 3.6062475764519267`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"bBig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vec", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", "vector"}]}], ",", "b1", ",", "b2"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"b1", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}], "/", 
         "5"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"b2", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}], "/", 
         "5"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Join", "[", 
       RowBox[{"b1", ",", "b2"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"bBig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605903794291393*^9, 3.6059038293924007`*^9}, {
  3.6062476157671757`*^9, 3.6062476455098767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"NullSpace", "[", "Abig", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065065623490815`*^9, 3.606506597755107*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NUL", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"Range", "[", "510", "]"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         FractionBox["1", 
          SqrtBox["5"]], 
         RowBox[{"#", "\[LeftDoubleBracket]", 
          RowBox[{"510", "+", 
           RowBox[{"Range", "[", "510", "]"}]}], 
          "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
      "inflate5", "\[RightDoubleBracket]"}], "&"}], "/@", "nul"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NUL", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6065066379594064`*^9, 3.6065066987188816`*^9}, {
  3.6065067692769175`*^9, 3.60650676950293*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Skew3", "[", 
      RowBox[{"ArrayReshape", "[", 
       RowBox[{"#", ",", 
        RowBox[{"Dimensions", "[", "GeneralForm5", "]"}]}], "]"}], "]"}], 
     "]"}], "]"}], "&"}], "/@", "NUL"}]], "Input",
 CellChangeTimes->{{3.606506741794345*^9, 3.606506758727314*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm5", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sol", "=", 
       RowBox[{"LinearSolve", "[", 
        RowBox[{"Abig", ",", "bBig"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sol", "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "510", "]"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{
           FractionBox["1", 
            SqrtBox["5"]], 
           RowBox[{"sol", "\[LeftDoubleBracket]", 
            RowBox[{"510", "+", 
             RowBox[{"Range", "[", "510", "]"}]}], 
            "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
        "inflate5", "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Dimensions", "[", "GeneralForm5", "]"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6059039307671986`*^9, 3.6059039982410583`*^9}, {
  3.6059040950745964`*^9, 3.605904107824326*^9}, {3.606247663362898*^9, 
  3.6062476684691896`*^9}, {3.6065067937903194`*^9, 3.6065068091131954`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm5", ">>", "\"\<DooSabinAlt5.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6059041277484655`*^9, 
  3.605904148076628*^9}, {3.6072817694094715`*^9, 3.607281770113512*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm5", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, {3.606506885574569*^9, 3.6065068891617746`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 6", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.6065108081699286`*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "6", "]"}]], "Input",
 CellChangeTimes->{3.6065069688633327`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "2"]}], "}"}], "=", 
   RowBox[{"16", " ", 
    RowBox[{"DooSabinWeight", "[", "6", "]"}]}]}], ";", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"], ",", 
    SubscriptBox["\[Omega]", "4"]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS6sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS6ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18"}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6060017240154543`*^9, 3.60600173845128*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "6", "]"}], ",", "DS6sub", ",", 
    "DS6ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060017433825617`*^9, 3.606001746374733*^9}, {
   3.606001810594406*^9, 3.6060018108054185`*^9}, 3.6062478188207893`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution", "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.606510842377885*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm6", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.6060018010878625`*^9, 3.6060018163107333`*^9}, {3.60600242100532*^9, 
   3.60600243167493*^9}, {3.606247826536231*^9, 3.6062478313455057`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm6", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm6", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm6", ",", "DS6sub", ",", "DS6ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror6", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "11", ",", "10", ",", "9"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror6", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex6", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror6", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti6", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "11", " ", "11"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "11"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror6", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "11", ",", "10", ",", "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "11", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065071426282716`*^9, 
   3.6065071791553607`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress6", ",", "inflate6"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "11"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex6", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti6", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress6", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress6"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.606507197685421*^9, 3.6065072151344185`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
     "#", "\[LeftDoubleBracket]", "inflate6", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"NullSpace", "[", 
     RowBox[{"Compress6", "[", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nul", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606462536417879*^9, 3.60646255024967*^9}, 
   3.606464157033573*^9, {3.6064652563384495`*^9, 3.6064652608327065`*^9}, {
   3.606507358142598*^9, 3.606507360499733*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Skew3", "[", 
    RowBox[{"ArrayReshape", "[", 
     RowBox[{"nul", ",", 
      RowBox[{"Dimensions", "[", "GeneralForm6", "]"}]}], "]"}], "]"}], "//", 
   "Flatten"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.606507374798551*^9, 3.6065073749975624`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{"Compress6", "[", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
      "]"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sol", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{3.606507430269724*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm6", "=", 
   RowBox[{"ArrayReshape", "[", 
    RowBox[{
     RowBox[{
     "sol", "\[LeftDoubleBracket]", "inflate6", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{"Dimensions", "[", "GeneralForm6", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056938650715876`*^9, 3.605693874975154*^9}, 
   3.6056966021671405`*^9, 3.605696688502079*^9, {3.6057038304285736`*^9, 
   3.6057038447803946`*^9}, {3.6057345241330385`*^9, 3.605734535147669*^9}, {
   3.605735607117982*^9, 3.6057356082840486`*^9}, {3.6057787138633347`*^9, 
   3.605778714693382*^9}, {3.6062480456127615`*^9, 3.6062480482029095`*^9}, {
   3.606507231623362*^9, 3.606507244846118*^9}, {3.6065074104295893`*^9, 
   3.606507416860957*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm6", ">>", "\"\<DooSabinAlt6.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6057038462764797`*^9, 
  3.6057038476915607`*^9}, {3.607282296053594*^9, 3.6072822966376276`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm6", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, 3.6057038508367405`*^9, {3.6065072490543585`*^9, 
   3.606507251997527*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 7", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, {
  3.6065107964742594`*^9, 3.6065107993374233`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "7", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "7", "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "2"]}], "}"}], "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{"16", " ", 
     RowBox[{"DooSabinWeight", "[", "7", "]"}]}], "]"}]}], ";", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"], ",", 
    SubscriptBox["\[Omega]", "4"]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS7sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS7ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "7", "]"}], ",", "DS7sub", ",", 
    "DS7ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution (numerical)", "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.60651086588923*^9, 
   3.6065108717125635`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm7", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "12", ",", "12"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm7", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm7", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm7", ",", "DS7sub", ",", "DS7ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 
        0}, {(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {(
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {0, 1}, {0, 0}}, {{0, 0}, {1, 0}, {
        1.3449970239279148`, 0.4370160244488211}, {1.1441228056353685`, 
        0.8312538755549068}, {0.8312538755549068, 1.1441228056353685`}, {
        0.4370160244488211, 1.3449970239279148`}, {0, 1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 
        0}, {(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {(
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {0, 1}}, {{0, 0}, {1, 0}, {1.3449970239279148`, 
        0.4370160244488211}, {1.1441228056353685`, 0.8312538755549068}, {
        0.8312538755549068, 1.1441228056353685`}, {0.4370160244488211, 
        1.3449970239279148`}, {0, 1}}]]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 7] (
          1 + (2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + (
            2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + 
          Rational[1, 2] 2^Rational[-1, 2] (-1 + 5^Rational[1, 2]) + 
          Rational[1, 2] 2^Rational[-1, 2] (1 + 5^Rational[1, 2])), 
         Rational[1, 7] (
          1 + (2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + (
            2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + 
          Rational[1, 2] 2^Rational[-1, 2] (-1 + 5^Rational[1, 2]) + 
          Rational[1, 2] 2^Rational[-1, 2] (1 + 5^Rational[1, 2]))}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.6796271042238587, 0.6796271042238587}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] 
        2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
         2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
        Rational[1, 2]}, {0.4370160244488211, 1.3449970239279148`}], 0.04], 
     DiskBox[NCache[{(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
        Rational[1, 2], Rational[1, 2] 
        2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {0.8312538755549068, 
       1.1441228056353685`}], 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] 
        2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
         2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
        Rational[1, 2]}, {1.1441228056353685`, 0.8312538755549068}], 0.04], 
     DiskBox[NCache[{(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
        Rational[1, 2], Rational[1, 2] 
        2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {1.3449970239279148`, 
       0.4370160244488211}], 0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] 
       2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
        2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
       Rational[1, 2]}, {0.4370160244488211, 1.3449970239279148`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
       Rational[1, 2], Rational[1, 2] 
       2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {0.8312538755549068, 
      1.1441228056353685`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] 
       2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
        2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
       Rational[1, 2]}, {1.1441228056353685`, 0.8312538755549068}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
       Rational[1, 2], Rational[1, 2] 
       2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {1.3449970239279148`, 
      0.4370160244488211}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror7", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "12", ",", "11", ",", "10", ",", "9"}], "}"}], 
   "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror7", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex7", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror7", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti7", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "12", " ", "12"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "12"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror7", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "12", ",", "11", ",", "10", ",", "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "12", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065071426282716`*^9, 
   3.6065071791553607`*^9}, {3.6065076884234896`*^9, 3.6065077388843756`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress7", ",", "inflate7"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "12"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex7", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti7", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress7", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress7"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.606507197685421*^9, 3.6065072151344185`*^9}, {3.6065077449787245`*^9, 
   3.6065077624507236`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
     "#", "\[LeftDoubleBracket]", "inflate7", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"NullSpace", "[", 
     RowBox[{
      RowBox[{"Compress7", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nul", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606462536417879*^9, 3.60646255024967*^9}, 
   3.606464157033573*^9, {3.6064652563384495`*^9, 3.6064652608327065`*^9}, {
   3.606507358142598*^9, 3.606507360499733*^9}, {3.6065077718042583`*^9, 
   3.606507773994384*^9}, {3.606507811419524*^9, 3.606507811890551*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Skew3", "[", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{"nul", ",", 
       RowBox[{"Dimensions", "[", "GeneralForm7", "]"}]}], "]"}], "]"}], "//",
     "Flatten"}], "//", "Chop"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.606507374798551*^9, 3.6065073749975624`*^9}, {
  3.6065078227151704`*^9, 3.6065078294795575`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Compress7", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sol", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{
  3.606507430269724*^9, 3.6065078669947033`*^9, {3.606507909107112*^9, 
   3.606507909905157*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm7", "=", 
   RowBox[{
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{
      "sol", "\[LeftDoubleBracket]", "inflate7", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"Dimensions", "[", "GeneralForm7", "]"}]}], "]"}], "//", 
    "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6056938650715876`*^9, 3.605693874975154*^9}, 
   3.6056966021671405`*^9, 3.605696688502079*^9, {3.6057038304285736`*^9, 
   3.6057038447803946`*^9}, {3.6057345241330385`*^9, 3.605734535147669*^9}, {
   3.605735607117982*^9, 3.6057356082840486`*^9}, {3.6057787138633347`*^9, 
   3.605778714693382*^9}, {3.6062480456127615`*^9, 3.6062480482029095`*^9}, {
   3.606507231623362*^9, 3.606507244846118*^9}, {3.6065074104295893`*^9, 
   3.606507416860957*^9}, {3.60650787935141*^9, 3.606507887542878*^9}, {
   3.6072823991094885`*^9, 3.6072824008455877`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm7", ">>", "\"\<DooSabinAlt7.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
   3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6057038462764797`*^9, 
   3.6057038476915607`*^9}, 3.60599579020006*^9, {3.6059958404249325`*^9, 
   3.6059958405599403`*^9}, {3.6072823851326895`*^9, 3.607282385788727*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm7", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, 3.6057038508367405`*^9, 3.605995844688176*^9, {
   3.6065079200657387`*^9, 3.606507923537937*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 8", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9, {
   3.6065079591279726`*^9, 3.6065079609340763`*^9}}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.60651080154555*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "8", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}, 
   3.60650796676741*^9}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "8", "]"}]], "Input",
 CellChangeTimes->{
  3.6065079760889425`*^9, {3.6065109065705566`*^9, 3.6065109093237143`*^9}, 
   3.6065109406755075`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "5"]}], "}"}], "=", 
   RowBox[{"16", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["13", "32"], ",", 
      RowBox[{
       FractionBox["1", "32"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", "s"}], ")"}]}], ",", 
      FractionBox["3", "32"], ",", 
      RowBox[{
       FractionBox["1", "32"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "-", "s"}], ")"}]}], ",", 
      FractionBox["1", "32"]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS8sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS8ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19", ",", "20"}], 
      "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}, {
   3.6065109500920463`*^9, 3.6065109534842405`*^9}, {3.6065109874981856`*^9, 
   3.6065110193820095`*^9}, {3.6065112693993096`*^9, 
   3.6065112826410666`*^9}, {3.606511345785679*^9, 3.6065113933443985`*^9}, {
   3.6065114267113075`*^9, 3.6065115669903307`*^9}, 3.6065126393416653`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "8", "]"}], ",", 
    RowBox[{"DS8sub", "/.", 
     RowBox[{"s", "\[Rule]", 
      SqrtBox["2"]}]}], ",", "DS8ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9, {3.6065115751597977`*^9, 3.606511577517933*^9}, {
   3.6065119116640453`*^9, 3.60651191577428*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Solving over ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[DoubleStruckCapitalQ]", "+", 
    RowBox[{
     SqrtBox["2"], "\[DoubleStruckCapitalQ]"}]}], TraditionalForm]]],
 " "
}], "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.6065116826919484`*^9, 
   3.6065116843010406`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm8", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"13", ",", "13", ",", "13"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}, {
   3.606511617896242*^9, 3.606511622796523*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm8", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm8", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm8", ",", "DS8sub", ",", "DS8ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}, {3.606511627208775*^9, 3.6065116360962834`*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 0}, {
        Rational[1, 2] (1 + 3^Rational[1, 2]), 
         Rational[1, 2] (-1 + 3^Rational[1, 2])}, {
        Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {1, 1}, {
        2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
        Rational[1, 2] (-1 + 3^Rational[1, 2]), 
         Rational[1, 2] (1 + 3^Rational[1, 2])}, {0, 1}, {0, 0}}, {{0, 0}, {1,
         0}, {1.3660254037844386`, 0.3660254037844386}, {1.224744871391589, 
        0.7071067811865475}, {1, 1}, {0.7071067811865475, 
        1.224744871391589}, {0.3660254037844386, 1.3660254037844386`}, {0, 
        1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 0}, {
        Rational[1, 2] (1 + 3^Rational[1, 2]), 
         Rational[1, 2] (-1 + 3^Rational[1, 2])}, {
        Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {1, 1}, {
        2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
        Rational[1, 2] (-1 + 3^Rational[1, 2]), 
         Rational[1, 2] (1 + 3^Rational[1, 2])}, {0, 1}}, {{0, 0}, {1, 0}, {
        1.3660254037844386`, 0.3660254037844386}, {1.224744871391589, 
        0.7071067811865475}, {1, 1}, {0.7071067811865475, 
        1.224744871391589}, {0.3660254037844386, 1.3660254037844386`}, {0, 
        1}}]]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 8] (2 + Rational[3, 2]^Rational[1, 2] + 2^Rational[-1, 2] + 
          Rational[1, 2] (-1 + 3^Rational[1, 2]) + 
          Rational[1, 2] (1 + 3^Rational[1, 2])), 
         Rational[1, 8] (2 + Rational[3, 2]^Rational[1, 2] + 
          2^Rational[-1, 2] + Rational[1, 2] (-1 + 3^Rational[1, 2]) + 
          Rational[1, 2] (1 + 3^Rational[1, 2]))}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.7079878075183768, 0.7079878075183768}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] (-1 + 3^Rational[1, 2]), 
        Rational[1, 2] (1 + 3^Rational[1, 2])}, {0.3660254037844386, 
       1.3660254037844386`}], 0.04], 
     DiskBox[NCache[{2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
       0.7071067811865475, 1.224744871391589}], 0.04], DiskBox[{1, 1}, 0.04], 
     DiskBox[NCache[{Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
       1.224744871391589, 0.7071067811865475}], 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] (1 + 3^Rational[1, 2]), 
        Rational[1, 2] (-1 + 3^Rational[1, 2])}, {1.3660254037844386`, 
       0.3660254037844386}], 0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] (-1 + 3^Rational[1, 2]), 
       Rational[1, 2] (1 + 3^Rational[1, 2])}, {0.3660254037844386, 
      1.3660254037844386`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
      0.7071067811865475, 1.224744871391589}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
      1.224744871391589, 0.7071067811865475}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["13",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] (1 + 3^Rational[1, 2]), 
       Rational[1, 2] (-1 + 3^Rational[1, 2])}, {1.3660254037844386`, 
      0.3660254037844386}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input",
 CellChangeTimes->{{3.606511895391114*^9, 3.6065118956891313`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror8", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "13", ",", "12", ",", "11", ",", "10", ",", "9"}], "}"}], 
   "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror8", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex8", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror8", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti8", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "13", " ", "13"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "13"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror8", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "13", ",", "12", ",", "11", ",", "10", ",", "9"}], "}"}], "]"}], 
  "\[Equal]", 
  RowBox[{"Range", "[", "13", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065117667157545`*^9, 
   3.6065118244110546`*^9}, {3.6065119538874598`*^9, 3.6065119616579046`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress8", ",", "inflate8"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "13"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex8", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti8", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress8", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress8"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.6065118534067125`*^9, 3.6065118750459504`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"Compress8", "[", 
    RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vector", "=", 
   RowBox[{"-", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"matrix", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"vector", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605902428728287*^9, 3.6059024298513513`*^9}, {
   3.605903620610459*^9, 3.605903630825043*^9}, {3.606247389591239*^9, 
   3.6062473955065775`*^9}, {3.606506489617922*^9, 3.6065065046677823`*^9}, 
   3.60651196962936*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Abig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"mat", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", 
         RowBox[{"Flatten", "[", "matrix", "]"}]}]}], ",", "A1", ",", "A2"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A1", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"A2", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayFlatten", "[", 
       RowBox[{"(", GridBox[{
          {"A1", 
           RowBox[{"2", " ", "A2"}]},
          {"A2", "A1"}
         }], ")"}], "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Abig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6059018202024813`*^9, 3.605901876088678*^9}, {
  3.6059019797526073`*^9, 3.605902108843991*^9}, {3.60590230744335*^9, 
  3.605902401074705*^9}, {3.60590243542667*^9, 3.6059024380588207`*^9}, {
  3.6059036403075857`*^9, 3.605903765512747*^9}, {3.6059037983406243`*^9, 
  3.6059038132964797`*^9}, {3.6062475368126593`*^9, 3.6062475764519267`*^9}, {
  3.60651199165462*^9, 3.606512000474125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"bBig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vec", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", "vector"}]}], ",", "b1", ",", "b2"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"b1", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"b2", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", 
       RowBox[{"b1", ",", "b2"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"bBig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605903794291393*^9, 3.6059038293924007`*^9}, {
  3.6062476157671757`*^9, 3.6062476455098767`*^9}, {3.6065120108437176`*^9, 
  3.606512014298915*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"NullSpace", "[", "Abig", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065065623490815`*^9, 3.606506597755107*^9}}],

Cell[BoxData[
 RowBox[{"nul", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.606512057891409*^9, 3.606512059437497*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NUL", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"Range", "[", "1118", "]"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         SqrtBox["2"], 
         RowBox[{"#", "\[LeftDoubleBracket]", 
          RowBox[{"1118", "+", 
           RowBox[{"Range", "[", "1118", "]"}]}], 
          "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
      "inflate8", "\[RightDoubleBracket]"}], "&"}], "/@", "nul"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NUL", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6065066379594064`*^9, 3.6065066987188816`*^9}, {
  3.6065067692769175`*^9, 3.60650676950293*^9}, {3.606512065139823*^9, 
  3.606512080142681*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{"Skew3", "[", 
      RowBox[{"ArrayReshape", "[", 
       RowBox[{"#", ",", 
        RowBox[{"Dimensions", "[", "GeneralForm8", "]"}]}], "]"}], "]"}], 
     "]"}], "]"}], "&"}], "/@", "NUL"}]], "Input",
 CellChangeTimes->{{3.606506741794345*^9, 3.606506758727314*^9}, {
  3.6065121129095554`*^9, 3.6065121130125613`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm8", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sol", "=", 
       RowBox[{"LinearSolve", "[", 
        RowBox[{"Abig", ",", "bBig"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sol", "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "1118", "]"}], "\[RightDoubleBracket]"}], 
          "+", 
          RowBox[{
           SqrtBox["2"], 
           RowBox[{"sol", "\[LeftDoubleBracket]", 
            RowBox[{"1118", "+", 
             RowBox[{"Range", "[", "1118", "]"}]}], 
            "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
        "inflate8", "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Dimensions", "[", "GeneralForm8", "]"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6059039307671986`*^9, 3.6059039982410583`*^9}, {
  3.6059040950745964`*^9, 3.605904107824326*^9}, {3.606247663362898*^9, 
  3.6062476684691896`*^9}, {3.6065067937903194`*^9, 3.6065068091131954`*^9}, {
  3.606512125693287*^9, 3.6065121477505484`*^9}}],

Cell[BoxData[
 RowBox[{"Union", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Chop", "[", 
    RowBox[{"DooSabinForm8", "-", 
     RowBox[{"RHS", "[", 
      RowBox[{"DooSabinForm4", ",", 
       RowBox[{"N", "[", "DooSabinForm8", "]"}], ",", 
       RowBox[{"DS8sub", "/.", 
        RowBox[{"s", "\[Rule]", 
         SqrtBox["2"]}]}], ",", "DS8ind"}], "]"}]}], "]"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.606512198595456*^9, 3.6065122090830564`*^9}, {
  3.6065123004512825`*^9, 3.606512302297388*^9}, {3.6065123711973286`*^9, 
  3.606512373717473*^9}, {3.6065124173649693`*^9, 3.6065124338429117`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm8", ">>", "\"\<DooSabinAlt8.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6059041277484655`*^9, 
  3.605904148076628*^9}, {3.6065121577531204`*^9, 3.6065121609133015`*^9}, {
  3.6072825050455475`*^9, 3.6072825061796126`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"DooSabinForm8", "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, {3.606506885574569*^9, 3.6065068891617746`*^9}, 
   3.6065121646355143`*^9}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 9", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9, {
   3.6065079591279726`*^9, 3.6065079609340763`*^9}, 3.6065127899242783`*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.60651080154555*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "9", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}, 
   3.60650796676741*^9, 3.6065127962546406`*^9}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "9", "]"}]], "Input",
 CellChangeTimes->{
  3.6065079760889425`*^9, {3.6065109065705566`*^9, 3.6065109093237143`*^9}, 
   3.6065109406755075`*^9, 3.606512800711896*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Omega]", "1"], ",", 
    SubscriptBox["\[Omega]", "2"], ",", 
    SubscriptBox["\[Omega]", "3"], ",", 
    SubscriptBox["\[Omega]", "4"], ",", 
    SubscriptBox["\[Omega]", "5"]}], "}"}], "=", 
  RowBox[{
   RowBox[{"16", 
    RowBox[{
     RowBox[{"DooSabinWeight", "[", "9", "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"Range", "[", "5", "]"}], "\[RightDoubleBracket]"}]}], "//", 
   "N"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS9sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS9ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", 
       "21"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}, {
   3.6065109500920463`*^9, 3.6065109534842405`*^9}, {3.6065109874981856`*^9, 
   3.6065110193820095`*^9}, {3.6065112693993096`*^9, 
   3.6065112826410666`*^9}, {3.606511345785679*^9, 3.6065113933443985`*^9}, {
   3.6065114267113075`*^9, 3.6065115669903307`*^9}, 3.6065126393416653`*^9, {
   3.6066168745906005`*^9, 3.6066170388359947`*^9}, {3.6066171036447015`*^9, 
   3.606617133075385*^9}, {3.606617177695937*^9, 3.606617267470072*^9}, {
   3.606617300162942*^9, 3.606617300264948*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "9", "]"}], ",", "DS9sub", ",", 
    "DS9ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9, {3.6065115751597977`*^9, 3.606511577517933*^9}, {
   3.6065119116640453`*^9, 3.60651191577428*^9}, {3.6066169459746833`*^9, 
   3.6066169534941134`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution (numerical)", "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.60651086588923*^9, 
   3.6065108717125635`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm9", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "14", ",", "14"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}, {
   3.6066174551308055`*^9, 3.606617459128034*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm9", "]"}]}], "]"}], "]"}], "&"}],
      "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm9", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm9", ",", "DS9sub", ",", "DS9ind"}], 
        "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}, {3.6066174629162507`*^9, 3.6066174689635963`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 14] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 14] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 7] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 7] Pi]}, {
        2^Rational[1, 2] Cos[Rational[3, 14] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 14] Pi]}, {
        2^Rational[1, 2] Sin[Rational[3, 14] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 14] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 7] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 7] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 14] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 14] Pi]}, {0, 1}, {0, 0}}, {{0, 0}, {1, 0}, {
        1.378756275743621, 0.3146921227129476}, {1.2741623922635348`, 
        0.6136042683532005}, {1.1056766859965506`, 0.8817477337899348}, {
        0.8817477337899348, 1.1056766859965506`}, {0.6136042683532005, 
        1.2741623922635348`}, {0.3146921227129476, 1.378756275743621}, {0, 
        1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 14] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 14] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 7] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 7] Pi]}, {
        2^Rational[1, 2] Cos[Rational[3, 14] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 14] Pi]}, {
        2^Rational[1, 2] Sin[Rational[3, 14] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 14] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 7] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 7] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 14] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 14] Pi]}, {0, 1}}, {{0, 0}, {1, 0}, {
        1.378756275743621, 0.3146921227129476}, {1.2741623922635348`, 
        0.6136042683532005}, {1.1056766859965506`, 0.8817477337899348}, {
        0.8817477337899348, 1.1056766859965506`}, {0.6136042683532005, 
        1.2741623922635348`}, {0.3146921227129476, 1.378756275743621}, {0, 
        1}}]]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 9] (1 + 2^Rational[1, 2] Cos[Rational[1, 14] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 7] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 14] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 14] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 7] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 14] Pi]), 
         Rational[1, 9] (1 + 2^Rational[1, 2] Cos[Rational[1, 14] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 7] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 14] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 14] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 7] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 14] Pi])}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.7298488309844209, 0.7298488309844209}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[1, 14] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 14] Pi]}, {0.3146921227129476, 1.378756275743621}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Sin[Rational[1, 7] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 7] Pi]}, {0.6136042683532005, 1.2741623922635348`}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Sin[Rational[3, 14] Pi], 2^Rational[1, 2] 
        Cos[Rational[3, 14] Pi]}, {0.8817477337899348, 1.1056766859965506`}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[3, 14] Pi], 2^Rational[1, 2] 
        Sin[Rational[3, 14] Pi]}, {1.1056766859965506`, 0.8817477337899348}], 
      0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Cos[Rational[1, 7] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 7] Pi]}, {1.2741623922635348`, 0.6136042683532005}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[1, 14] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 14] Pi]}, {1.378756275743621, 0.3146921227129476}], 
      0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 14] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 14] Pi]}, {0.3146921227129476, 1.378756275743621}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 7] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 7] Pi]}, {0.6136042683532005, 1.2741623922635348`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[3, 14] Pi], 2^Rational[1, 2] 
       Cos[Rational[3, 14] Pi]}, {0.8817477337899348, 1.1056766859965506`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[3, 14] Pi], 2^Rational[1, 2] 
       Sin[Rational[3, 14] Pi]}, {1.1056766859965506`, 0.8817477337899348}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["13",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 7] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 7] Pi]}, {1.2741623922635348`, 0.6136042683532005}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["14",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 14] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 14] Pi]}, {1.378756275743621, 0.3146921227129476}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input",
 CellChangeTimes->{{3.606617497449226*^9, 3.6066175056946974`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror9", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "14", ",", "13", ",", "12", ",", "11", ",", "10", ",", "9"}], 
    "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror9", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex9", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror9", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti9", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "14", " ", "14"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "14"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror9", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "14", ",", "13", ",", "12", ",", "11", ",", "10", ",", "9"}], 
    "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "14", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065071426282716`*^9, 
   3.6065071791553607`*^9}, {3.6065076884234896`*^9, 
   3.6065077388843756`*^9}, {3.606617509342906*^9, 3.6066175654171133`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress9", ",", "inflate9"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "14"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex9", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti9", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress9", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress9"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.606507197685421*^9, 3.6065072151344185`*^9}, {3.6065077449787245`*^9, 
   3.6065077624507236`*^9}, {3.606617570444401*^9, 3.6066175875203776`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
     "#", "\[LeftDoubleBracket]", "inflate9", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"NullSpace", "[", 
     RowBox[{
      RowBox[{"Compress9", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nul", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606462536417879*^9, 3.60646255024967*^9}, 
   3.606464157033573*^9, {3.6064652563384495`*^9, 3.6064652608327065`*^9}, {
   3.606507358142598*^9, 3.606507360499733*^9}, {3.6065077718042583`*^9, 
   3.606507773994384*^9}, {3.606507811419524*^9, 3.606507811890551*^9}, {
   3.6066175946337843`*^9, 3.606617597388942*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Skew3", "[", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{"nul", ",", 
       RowBox[{"Dimensions", "[", "GeneralForm9", "]"}]}], "]"}], "]"}], "//",
     "Flatten"}], "//", "Chop"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.606507374798551*^9, 3.6065073749975624`*^9}, {
  3.6065078227151704`*^9, 3.6065078294795575`*^9}, {3.6066176079055433`*^9, 
  3.6066176084665756`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Compress9", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sol", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{
  3.606507430269724*^9, 3.6065078669947033`*^9, {3.606507909107112*^9, 
   3.606507909905157*^9}, {3.6066176134498606`*^9, 3.6066176135698676`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm9", "=", 
   RowBox[{
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{
      "sol", "\[LeftDoubleBracket]", "inflate9", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"Dimensions", "[", "GeneralForm9", "]"}]}], "]"}], "//", 
    "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6056938650715876`*^9, 3.605693874975154*^9}, 
   3.6056966021671405`*^9, 3.605696688502079*^9, {3.6057038304285736`*^9, 
   3.6057038447803946`*^9}, {3.6057345241330385`*^9, 3.605734535147669*^9}, {
   3.605735607117982*^9, 3.6057356082840486`*^9}, {3.6057787138633347`*^9, 
   3.605778714693382*^9}, {3.6062480456127615`*^9, 3.6062480482029095`*^9}, {
   3.606507231623362*^9, 3.606507244846118*^9}, {3.6065074104295893`*^9, 
   3.606507416860957*^9}, {3.60650787935141*^9, 3.606507887542878*^9}, {
   3.6066176209692907`*^9, 3.6066176270496387`*^9}, {3.607282676515355*^9, 
   3.607282677665421*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm9", ">>", "\"\<DooSabinAlt9.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
   3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6057038462764797`*^9, 
   3.6057038476915607`*^9}, 3.60599579020006*^9, {3.6059958404249325`*^9, 
   3.6059958405599403`*^9}, {3.6066176306718454`*^9, 3.606617632824969*^9}, {
   3.607282669130933*^9, 3.6072826695549574`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{
    RowBox[{"Skew3", "[", "DooSabinForm9", "]"}], "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, 3.6057038508367405`*^9, 3.605995844688176*^9, {
   3.6065079200657387`*^9, 3.606507923537937*^9}, {3.6066176375522394`*^9, 
   3.6066176460167236`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 10", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9, {
   3.6065079591279726`*^9, 3.6065079609340763`*^9}, {3.6066176870400696`*^9, 
   3.6066176874700947`*^9}}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.60651080154555*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "10", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}, 
   3.60650796676741*^9, {3.606617745767429*^9, 3.6066177458724346`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "10", "]"}]], "Input",
 CellChangeTimes->{
  3.6065079760889425`*^9, {3.6065109065705566`*^9, 3.6065109093237143`*^9}, 
   3.6065109406755075`*^9, {3.6066177494316387`*^9, 3.606617749525644*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "5"], ",", 
     SubscriptBox["\[Omega]", "6"]}], "}"}], "=", 
   RowBox[{"16", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["3", "8"], ",", 
      RowBox[{
       FractionBox["1", "40"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", "s"}], ")"}]}]}], ")"}]}], ",", 
      RowBox[{
       FractionBox["1", "40"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "s"}], ")"}]}]}], ")"}]}], ",", 
      RowBox[{
       FractionBox["1", "40"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", "s"}], ")"}]}]}], ")"}]}], ",", 
      RowBox[{
       FractionBox["1", "40"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", "s"}], ")"}]}]}], ")"}]}], ",", 
      FractionBox["1", "40"]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS10sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", 
        "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS10ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", 
       "21", ",", "22"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}, {
   3.6065109500920463`*^9, 3.6065109534842405`*^9}, {3.6065109874981856`*^9, 
   3.6065110193820095`*^9}, {3.6065112693993096`*^9, 
   3.6065112826410666`*^9}, {3.606511345785679*^9, 3.6065113933443985`*^9}, {
   3.6065114267113075`*^9, 3.6065115669903307`*^9}, 3.6065126393416653`*^9, {
   3.606617785456699*^9, 3.606617848567309*^9}, {3.6066180721760983`*^9, 
   3.606618077347394*^9}, {3.60661814791543*^9, 3.6066182399966974`*^9}, {
   3.6066182820521026`*^9, 3.6066183193792377`*^9}, {3.6066183733743258`*^9, 
   3.6066183802897215`*^9}, {3.606618417956876*^9, 3.6066184192259483`*^9}, 
   3.606618462892446*^9, {3.6066185391248064`*^9, 3.606618583051319*^9}, 
   3.606618633721217*^9, {3.6066186714993773`*^9, 3.6066187012550793`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "10", "]"}], ",", 
    RowBox[{"DS10sub", "/.", 
     RowBox[{"s", "\[Rule]", 
      SqrtBox["5."]}]}], ",", "DS10ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9, {3.6065115751597977`*^9, 3.606511577517933*^9}, {
   3.6065119116640453`*^9, 3.60651191577428*^9}, {3.6066182920156727`*^9, 
   3.6066183006731677`*^9}, 3.6066183405644493`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Solving over ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[DoubleStruckCapitalQ]", "+", 
    RowBox[{
     SqrtBox["5"], "\[DoubleStruckCapitalQ]"}]}], TraditionalForm]]],
 " "
}], "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.6065116826919484`*^9, 
   3.6065116843010406`*^9}, {3.606617967119089*^9, 3.606617967119089*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm10", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"15", ",", "15", ",", "15"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}, {
   3.606511617896242*^9, 3.606511622796523*^9}, {3.6066187542331095`*^9, 
   3.606618758769369*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm10", "]"}]}], "]"}], "]"}], 
      "&"}], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm10", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm10", ",", "DS10sub", ",", 
         "DS10ind"}], "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}, {3.606511627208775*^9, 3.6065116360962834`*^9}, {
  3.606618769026956*^9, 3.6066187798415747`*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 16] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 16] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 8] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 8] Pi]}, {
        2^Rational[1, 2] Cos[Rational[3, 16] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 16] Pi]}, {1, 1}, {
        2^Rational[1, 2] Sin[Rational[3, 16] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 16] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 8] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 8] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 16] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 16] Pi]}, {0, 1}, {0, 0}}, {{0, 0}, {1, 0}, {
        1.3870398453221475`, 0.275899379282943}, {1.3065629648763766`, 
        0.541196100146197}, {1.1758756024193588`, 0.7856949583871021}, {1, 
        1}, {0.7856949583871021, 1.1758756024193588`}, {0.541196100146197, 
        1.3065629648763766`}, {0.275899379282943, 1.3870398453221475`}, {0, 
        1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 16] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 16] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 8] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 8] Pi]}, {
        2^Rational[1, 2] Cos[Rational[3, 16] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 16] Pi]}, {1, 1}, {
        2^Rational[1, 2] Sin[Rational[3, 16] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 16] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 8] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 8] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 16] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 16] Pi]}, {0, 1}}, {{0, 0}, {1, 0}, {
        1.3870398453221475`, 0.275899379282943}, {1.3065629648763766`, 
        0.541196100146197}, {1.1758756024193588`, 0.7856949583871021}, {1, 
        1}, {0.7856949583871021, 1.1758756024193588`}, {0.541196100146197, 
        1.3065629648763766`}, {0.275899379282943, 1.3870398453221475`}, {0, 
        1}}]]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 10] (2 + 2^Rational[1, 2] Cos[Rational[1, 16] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 8] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 16] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 16] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 8] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 16] Pi]), 
         Rational[1, 10] (2 + 2^Rational[1, 2] Cos[Rational[1, 16] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 8] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 16] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 16] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 8] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 16] Pi])}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.7472268850434125, 0.7472268850434125}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[1, 16] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 16] Pi]}, {0.275899379282943, 1.3870398453221475`}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Sin[Rational[1, 8] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 8] Pi]}, {0.541196100146197, 1.3065629648763766`}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Sin[Rational[3, 16] Pi], 2^Rational[1, 2] 
        Cos[Rational[3, 16] Pi]}, {0.7856949583871021, 1.1758756024193588`}], 
      0.04], DiskBox[{1, 1}, 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Cos[Rational[3, 16] Pi], 2^Rational[1, 2] 
        Sin[Rational[3, 16] Pi]}, {1.1758756024193588`, 0.7856949583871021}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[1, 8] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 8] Pi]}, {1.3065629648763766`, 0.541196100146197}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[1, 16] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 16] Pi]}, {1.3870398453221475`, 0.275899379282943}], 
      0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 16] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 16] Pi]}, {0.275899379282943, 1.3870398453221475`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 8] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 8] Pi]}, {0.541196100146197, 1.3065629648763766`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[3, 16] Pi], 2^Rational[1, 2] 
       Cos[Rational[3, 16] Pi]}, {0.7856949583871021, 1.1758756024193588`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["13",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[3, 16] Pi], 2^Rational[1, 2] 
       Sin[Rational[3, 16] Pi]}, {1.1758756024193588`, 0.7856949583871021}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["14",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 8] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 8] Pi]}, {1.3065629648763766`, 0.541196100146197}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["15",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 16] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 16] Pi]}, {1.3870398453221475`, 0.275899379282943}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input",
 CellChangeTimes->{{3.606511895391114*^9, 3.6065118956891313`*^9}, {
  3.6066189268639836`*^9, 3.6066189414108157`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror10", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "15", ",", "14", ",", "13", ",", "12", ",", "11", ",", "10", ",", 
     "9"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror10", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex10", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror10", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti10", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "15", " ", "15"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "15"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror10", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "15", ",", "14", ",", "13", ",", "12", ",", "11", ",", "10", ",", 
     "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "15", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065117667157545`*^9, 
   3.6065118244110546`*^9}, {3.6065119538874598`*^9, 
   3.6065119616579046`*^9}, {3.6066189994411345`*^9, 3.606619060257613*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress10", ",", "inflate10"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "15"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex10", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti10", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress10", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress10"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.6065118534067125`*^9, 3.6065118750459504`*^9}, {3.6066190672000103`*^9, 
   3.6066190883722215`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"Compress10", "[", 
    RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vector", "=", 
   RowBox[{"-", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"matrix", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"vector", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605902428728287*^9, 3.6059024298513513`*^9}, {
   3.605903620610459*^9, 3.605903630825043*^9}, {3.606247389591239*^9, 
   3.6062473955065775`*^9}, {3.606506489617922*^9, 3.6065065046677823`*^9}, 
   3.60651196962936*^9, {3.6066190932395*^9, 3.6066190933415055`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Abig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"mat", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", 
         RowBox[{"Flatten", "[", "matrix", "]"}]}]}], ",", "A1", ",", "A2"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A1", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"5", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"A2", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"5", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayFlatten", "[", 
       RowBox[{"(", GridBox[{
          {"A1", 
           RowBox[{"5", " ", "A2"}]},
          {"A2", "A1"}
         }], ")"}], "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Abig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6059018202024813`*^9, 3.605901876088678*^9}, {
  3.6059019797526073`*^9, 3.605902108843991*^9}, {3.60590230744335*^9, 
  3.605902401074705*^9}, {3.60590243542667*^9, 3.6059024380588207`*^9}, {
  3.6059036403075857`*^9, 3.605903765512747*^9}, {3.6059037983406243`*^9, 
  3.6059038132964797`*^9}, {3.6062475368126593`*^9, 3.6062475764519267`*^9}, {
  3.60651199165462*^9, 3.606512000474125*^9}, {3.606619117651896*^9, 
  3.606619123223215*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"bBig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vec", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", "vector"}]}], ",", "b1", ",", "b2"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"b1", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"b2", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"5", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", 
       RowBox[{"b1", ",", "b2"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"bBig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605903794291393*^9, 3.6059038293924007`*^9}, {
  3.6062476157671757`*^9, 3.6062476455098767`*^9}, {3.6065120108437176`*^9, 
  3.606512014298915*^9}, {3.606619156501118*^9, 3.606619157261162*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"NullSpace", "[", 
    RowBox[{"Abig", "//", "N"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065065623490815`*^9, 3.606506597755107*^9}, {
  3.60661968156315*^9, 3.606619682018176*^9}}],

Cell[BoxData[
 RowBox[{"nul", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.606512057891409*^9, 3.606512059437497*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NUL", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"Range", "[", "1710", "]"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         SqrtBox["5"], 
         RowBox[{"#", "\[LeftDoubleBracket]", 
          RowBox[{"1710", "+", 
           RowBox[{"Range", "[", "1710", "]"}]}], 
          "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
      "inflate10", "\[RightDoubleBracket]"}], "&"}], "/@", "nul"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NUL", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6065066379594064`*^9, 3.6065066987188816`*^9}, {
  3.6065067692769175`*^9, 3.60650676950293*^9}, {3.606512065139823*^9, 
  3.606512080142681*^9}, {3.606619506661146*^9, 3.606619517669776*^9}, {
  3.6066196898256226`*^9, 3.6066196899396296`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Chop", "[", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Skew3", "[", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Dimensions", "[", "GeneralForm10", "]"}]}], "]"}], "]"}], 
      "]"}], "]"}], "]"}], "&"}], "/@", "NUL"}]], "Input",
 CellChangeTimes->{{3.606506741794345*^9, 3.606506758727314*^9}, {
  3.6065121129095554`*^9, 3.6065121130125613`*^9}, {3.606619698329109*^9, 
  3.606619698416114*^9}, {3.6066197465068645`*^9, 3.6066197509781203`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm10", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sol", "=", 
       RowBox[{"LinearSolve", "[", 
        RowBox[{"Abig", ",", "bBig"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sol", "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "1710", "]"}], "\[RightDoubleBracket]"}], 
          "+", 
          RowBox[{
           SqrtBox["5"], 
           RowBox[{"sol", "\[LeftDoubleBracket]", 
            RowBox[{"1710", "+", 
             RowBox[{"Range", "[", "1710", "]"}]}], 
            "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
        "inflate10", "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Dimensions", "[", "GeneralForm10", "]"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6059039307671986`*^9, 3.6059039982410583`*^9}, {
  3.6059040950745964`*^9, 3.605904107824326*^9}, {3.606247663362898*^9, 
  3.6062476684691896`*^9}, {3.6065067937903194`*^9, 3.6065068091131954`*^9}, {
  3.606512125693287*^9, 3.6065121477505484`*^9}, {3.6066192318004255`*^9, 
  3.6066192318934307`*^9}, {3.606619525856244*^9, 3.606619538749982*^9}}],

Cell[BoxData[
 RowBox[{"Union", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Chop", "[", 
    RowBox[{"DooSabinForm10", "-", 
     RowBox[{"RHS", "[", 
      RowBox[{"DooSabinForm4", ",", 
       RowBox[{"N", "[", "DooSabinForm10", "]"}], ",", 
       RowBox[{"DS10sub", "/.", 
        RowBox[{"s", "\[Rule]", 
         SqrtBox["5"]}]}], ",", "DS10ind"}], "]"}]}], "]"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.606512198595456*^9, 3.6065122090830564`*^9}, {
  3.6065123004512825`*^9, 3.606512302297388*^9}, {3.6065123711973286`*^9, 
  3.606512373717473*^9}, {3.6065124173649693`*^9, 3.6065124338429117`*^9}, {
  3.606619595427223*^9, 3.6066196073609056`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm10", ">>", "\"\<DooSabinAlt10.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6059041277484655`*^9, 
  3.605904148076628*^9}, {3.6065121577531204`*^9, 3.6065121609133015`*^9}, {
  3.606619628900138*^9, 3.6066196314582844`*^9}, {3.607282744912267*^9, 
  3.6072827454242964`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{
    RowBox[{"Skew3", "[", "DooSabinForm10", "]"}], "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, {3.606506885574569*^9, 3.6065068891617746`*^9}, 
   3.6065121646355143`*^9, {3.606619637209613*^9, 3.606619645289075*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 11", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9, {
   3.6065079591279726`*^9, 3.6065079609340763`*^9}, 3.6065127899242783`*^9, {
   3.6066198357899714`*^9, 3.606619837119047*^9}, 3.6066210881576023`*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.60651080154555*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "11", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}, 
   3.60650796676741*^9, {3.606617745767429*^9, 3.6066177458724346`*^9}, 
   3.606620054254467*^9}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "11", "]"}]], "Input",
 CellChangeTimes->{
  3.6065079760889425`*^9, {3.6065109065705566`*^9, 3.6065109093237143`*^9}, 
   3.6065109406755075`*^9, {3.6066177494316387`*^9, 3.606617749525644*^9}, 
   3.6066200638620167`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "5"], ",", 
     SubscriptBox["\[Omega]", "6"]}], "}"}], "=", 
   RowBox[{
    RowBox[{"16", 
     RowBox[{
      RowBox[{"DooSabinWeight", "[", "11", "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"Range", "[", "6", "]"}], "\[RightDoubleBracket]"}]}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS11sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", 
        "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS11ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", 
       "21", ",", "22", ",", "23"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}, {
   3.6065109500920463`*^9, 3.6065109534842405`*^9}, {3.6065109874981856`*^9, 
   3.6065110193820095`*^9}, {3.6065112693993096`*^9, 
   3.6065112826410666`*^9}, {3.606511345785679*^9, 3.6065113933443985`*^9}, {
   3.6065114267113075`*^9, 3.6065115669903307`*^9}, 3.6065126393416653`*^9, {
   3.606617785456699*^9, 3.606617848567309*^9}, {3.6066180721760983`*^9, 
   3.606618077347394*^9}, {3.60661814791543*^9, 3.6066182399966974`*^9}, {
   3.6066182820521026`*^9, 3.6066183193792377`*^9}, {3.6066183733743258`*^9, 
   3.6066183802897215`*^9}, {3.606618417956876*^9, 3.6066184192259483`*^9}, 
   3.606618462892446*^9, {3.6066185391248064`*^9, 3.606618583051319*^9}, 
   3.606618633721217*^9, {3.6066186714993773`*^9, 3.6066187012550793`*^9}, {
   3.6066200911055746`*^9, 3.606620193529433*^9}, {3.6066203218337717`*^9, 
   3.606620337351659*^9}, {3.606620424751658*^9, 3.606620523468304*^9}, {
   3.6066205551231146`*^9, 3.606620582291669*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "11", "]"}], ",", "DS11sub", ",", 
    "DS11ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9, {3.6065115751597977`*^9, 3.606511577517933*^9}, {
   3.6065119116640453`*^9, 3.60651191577428*^9}, {3.6066182920156727`*^9, 
   3.6066183006731677`*^9}, 3.6066183405644493`*^9, {3.6066201747673597`*^9, 
   3.60662018141574*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Solution (numerical)", "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.60651086588923*^9, 
   3.6065108717125635`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm11", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "16", ",", "16"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}, {
   3.6066174551308055`*^9, 3.606617459128034*^9}, {3.6066208297478223`*^9, 
   3.606620835897174*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm11", "]"}]}], "]"}], "]"}], 
      "&"}], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm11", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm11", ",", "DS11sub", ",", 
         "DS11ind"}], "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}, {3.6066174629162507`*^9, 3.6066174689635963`*^9}, {
  3.6066208425335536`*^9, 3.606620851049041*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 18] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 18] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 9] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 9] Pi]}, {
        Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
        2^Rational[1, 2] Cos[Rational[2, 9] Pi], 2^Rational[1, 2] 
         Sin[Rational[2, 9] Pi]}, {
        2^Rational[1, 2] Sin[Rational[2, 9] Pi], 2^Rational[1, 2] 
         Cos[Rational[2, 9] Pi]}, {
        2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
        2^Rational[1, 2] Sin[Rational[1, 9] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 9] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 18] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 18] Pi]}, {0, 1}, {0, 0}}, {{0, 0}, {1, 0}, {
        1.392728480640038, 0.2455756079379457}, {1.3289260487773495`, 
        0.48368952529595055`}, {1.224744871391589, 0.7071067811865475}, {
        1.0833504408394037`, 0.9090389553440873}, {0.9090389553440873, 
        1.0833504408394037`}, {0.7071067811865475, 1.224744871391589}, {
        0.48368952529595055`, 1.3289260487773495`}, {0.2455756079379457, 
        1.392728480640038}, {0, 1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 18] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 18] Pi]}, {
        2^Rational[1, 2] Cos[Rational[1, 9] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 9] Pi]}, {
        Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
        2^Rational[1, 2] Cos[Rational[2, 9] Pi], 2^Rational[1, 2] 
         Sin[Rational[2, 9] Pi]}, {
        2^Rational[1, 2] Sin[Rational[2, 9] Pi], 2^Rational[1, 2] 
         Cos[Rational[2, 9] Pi]}, {
        2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
        2^Rational[1, 2] Sin[Rational[1, 9] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 9] Pi]}, {
        2^Rational[1, 2] Sin[Rational[1, 18] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 18] Pi]}, {0, 1}}, {{0, 0}, {1, 0}, {
        1.392728480640038, 0.2455756079379457}, {1.3289260487773495`, 
        0.48368952529595055`}, {1.224744871391589, 0.7071067811865475}, {
        1.0833504408394037`, 0.9090389553440873}, {0.9090389553440873, 
        1.0833504408394037`}, {0.7071067811865475, 1.224744871391589}, {
        0.48368952529595055`, 1.3289260487773495`}, {0.2455756079379457, 
        1.392728480640038}, {0, 1}}]]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 11] (1 + Rational[3, 2]^Rational[1, 2] + 
          2^Rational[-1, 2] + 2^Rational[1, 2] Cos[Rational[1, 18] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 9] Pi] + 
          2^Rational[1, 2] Cos[Rational[2, 9] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 18] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 9] Pi] + 
          2^Rational[1, 2] Sin[Rational[2, 9] Pi]), 
         Rational[1, 11] (1 + Rational[3, 2]^Rational[1, 2] + 
          2^Rational[-1, 2] + 2^Rational[1, 2] Cos[Rational[1, 18] Pi] + 
          2^Rational[1, 2] Cos[Rational[1, 9] Pi] + 
          2^Rational[1, 2] Cos[Rational[2, 9] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 18] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 9] Pi] + 
          2^Rational[1, 2] Sin[Rational[2, 9] Pi])}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.7613782464920827, 0.7613782464920827}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[1, 18] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 18] Pi]}, {0.2455756079379457, 1.392728480640038}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Sin[Rational[1, 9] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 9] Pi]}, {0.48368952529595055`, 1.3289260487773495`}],
       0.04], DiskBox[
      NCache[{2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
       0.7071067811865475, 1.224744871391589}], 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[2, 9] Pi], 2^Rational[1, 2] 
        Cos[Rational[2, 9] Pi]}, {0.9090389553440873, 1.0833504408394037`}], 
      0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[2, 9] Pi], 2^Rational[1, 2] 
        Sin[Rational[2, 9] Pi]}, {1.0833504408394037`, 0.9090389553440873}], 
      0.04], DiskBox[
      NCache[{Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
       1.224744871391589, 0.7071067811865475}], 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Cos[Rational[1, 9] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 9] Pi]}, {1.3289260487773495`, 0.48368952529595055`}],
       0.04], DiskBox[
      NCache[{2^Rational[1, 2] Cos[Rational[1, 18] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 18] Pi]}, {1.392728480640038, 0.2455756079379457}], 
      0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 18] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 18] Pi]}, {0.2455756079379457, 1.392728480640038}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 9] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 9] Pi]}, {0.48368952529595055`, 1.3289260487773495`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[-1, 2], Rational[3, 2]^Rational[1, 2]}, {
      0.7071067811865475, 1.224744871391589}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[2, 9] Pi], 2^Rational[1, 2] 
       Cos[Rational[2, 9] Pi]}, {0.9090389553440873, 1.0833504408394037`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["13",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[2, 9] Pi], 2^Rational[1, 2] 
       Sin[Rational[2, 9] Pi]}, {1.0833504408394037`, 0.9090389553440873}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["14",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[3, 2]^Rational[1, 2], 2^Rational[-1, 2]}, {
      1.224744871391589, 0.7071067811865475}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["15",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 9] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 9] Pi]}, {1.3289260487773495`, 0.48368952529595055`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["16",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 18] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 18] Pi]}, {1.392728480640038, 0.2455756079379457}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input",
 CellChangeTimes->{{3.606617497449226*^9, 3.6066175056946974`*^9}, {
  3.606620872320257*^9, 3.6066208726032734`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror11", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "16", ",", "15", ",", "14", ",", "13", ",", "12", ",", "11", ",", 
     "10", ",", "9"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror11", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex11", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror11", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti11", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "16", " ", "16"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "16"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror11", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "16", ",", "15", ",", "14", ",", "13", ",", "12", ",", "11", ",", 
     "10", ",", "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "16", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065071426282716`*^9, 
   3.6065071791553607`*^9}, {3.6065076884234896`*^9, 
   3.6065077388843756`*^9}, {3.606617509342906*^9, 3.6066175654171133`*^9}, {
   3.6066208834578943`*^9, 3.6066209377720013`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress11", ",", "inflate11"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "16"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex11", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti11", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress11", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress11"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.606507197685421*^9, 3.6065072151344185`*^9}, {3.6065077449787245`*^9, 
   3.6065077624507236`*^9}, {3.606617570444401*^9, 3.6066175875203776`*^9}, {
   3.606620980993473*^9, 3.606620996938385*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
     "#", "\[LeftDoubleBracket]", "inflate11", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"NullSpace", "[", 
     RowBox[{
      RowBox[{"Compress11", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nul", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.606462536417879*^9, 3.60646255024967*^9}, 
   3.606464157033573*^9, {3.6064652563384495`*^9, 3.6064652608327065`*^9}, {
   3.606507358142598*^9, 3.606507360499733*^9}, {3.6065077718042583`*^9, 
   3.606507773994384*^9}, {3.606507811419524*^9, 3.606507811890551*^9}, {
   3.6066175946337843`*^9, 3.606617597388942*^9}, {3.6066210044788165`*^9, 
   3.6066210068949547`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Skew3", "[", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{"nul", ",", 
       RowBox[{"Dimensions", "[", "GeneralForm11", "]"}]}], "]"}], "]"}], "//",
     "Flatten"}], "//", "Chop"}], "//", "Union"}]], "Input",
 CellChangeTimes->{{3.606507374798551*^9, 3.6065073749975624`*^9}, {
  3.6065078227151704`*^9, 3.6065078294795575`*^9}, {3.6066176079055433`*^9, 
  3.6066176084665756`*^9}, {3.6066210172075443`*^9, 3.606621017384555*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"LinearSolve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Compress11", "[", 
       RowBox[{
       "affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
       "]"}], "//", "N"}], ",", 
     RowBox[{"-", 
      RowBox[{
      "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"sol", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{
  3.606507430269724*^9, 3.6065078669947033`*^9, {3.606507909107112*^9, 
   3.606507909905157*^9}, {3.6066176134498606`*^9, 3.6066176135698676`*^9}, {
   3.606621028560194*^9, 3.606621028743204*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm11", "=", 
   RowBox[{
    RowBox[{"ArrayReshape", "[", 
     RowBox[{
      RowBox[{
      "sol", "\[LeftDoubleBracket]", "inflate11", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"Dimensions", "[", "GeneralForm11", "]"}]}], "]"}], "//", 
    "Chop"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6056938650715876`*^9, 3.605693874975154*^9}, 
   3.6056966021671405`*^9, 3.605696688502079*^9, {3.6057038304285736`*^9, 
   3.6057038447803946`*^9}, {3.6057345241330385`*^9, 3.605734535147669*^9}, {
   3.605735607117982*^9, 3.6057356082840486`*^9}, {3.6057787138633347`*^9, 
   3.605778714693382*^9}, {3.6062480456127615`*^9, 3.6062480482029095`*^9}, {
   3.606507231623362*^9, 3.606507244846118*^9}, {3.6065074104295893`*^9, 
   3.606507416860957*^9}, {3.60650787935141*^9, 3.606507887542878*^9}, {
   3.6066176209692907`*^9, 3.6066176270496387`*^9}, {3.606621046608226*^9, 
   3.6066210504624467`*^9}, {3.6072829851020055`*^9, 3.60728298658409*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm11", ">>", "\"\<DooSabinAlt11.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
   3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6057038462764797`*^9, 
   3.6057038476915607`*^9}, 3.60599579020006*^9, {3.6059958404249325`*^9, 
   3.6059958405599403`*^9}, {3.6066176306718454`*^9, 3.606617632824969*^9}, {
   3.606621054006649*^9, 3.606621055728748*^9}, {3.607282956241355*^9, 
   3.6072829570003977`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{
    RowBox[{"Skew3", "[", "DooSabinForm11", "]"}], "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, 3.6057038508367405`*^9, 3.605995844688176*^9, {
   3.6065079200657387`*^9, 3.606507923537937*^9}, {3.6066176375522394`*^9, 
   3.6066176460167236`*^9}, {3.606621065535309*^9, 3.606621065712319*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Valence 12", "Subsection",
 CellChangeTimes->{{3.60562336381744*^9, 3.6056233680776834`*^9}, 
   3.605696534656279*^9, 3.6057027124516287`*^9, 3.605994463176158*^9, {
   3.6065079591279726`*^9, 3.6065079609340763`*^9}, 3.6065127899242783`*^9, {
   3.6066198357899714`*^9, 3.606619837119047*^9}, 3.6066210881576023`*^9, 
   3.6072830421832705`*^9}],

Cell[CellGroupData[{

Cell["Subdivision", "Subsubsection",
 CellChangeTimes->{{3.606507015219984*^9, 3.606507020668296*^9}, 
   3.60651080154555*^9}],

Cell[BoxData[
 RowBox[{"DooSabinIndexing", "[", "12", "]"}]], "Input",
 CellChangeTimes->{{3.606507594314107*^9, 3.6065075999394283`*^9}, 
   3.60650796676741*^9, {3.606617745767429*^9, 3.6066177458724346`*^9}, 
   3.606620054254467*^9, 3.60728304549646*^9}],

Cell[BoxData[
 RowBox[{"DooSabinWeight", "[", "12", "]"}]], "Input",
 CellChangeTimes->{
  3.6065079760889425`*^9, {3.6065109065705566`*^9, 3.6065109093237143`*^9}, 
   3.6065109406755075`*^9, {3.6066177494316387`*^9, 3.606617749525644*^9}, 
   3.6066200638620167`*^9, 3.60728305057775*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "5"], ",", 
     SubscriptBox["\[Omega]", "6"], ",", 
     SubscriptBox["\[Omega]", "7"]}], "}"}], "=", 
   RowBox[{
    RowBox[{"16", 
     RowBox[{
      RowBox[{"DooSabinWeight", "[", "12", "]"}], "\[LeftDoubleBracket]", 
      RowBox[{"Range", "[", "7", "]"}], "\[RightDoubleBracket]"}]}], "//", 
    "N"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SubscriptBox["\[Omega]", "1"], ",", 
     SubscriptBox["\[Omega]", "2"], ",", 
     SubscriptBox["\[Omega]", "3"], ",", 
     SubscriptBox["\[Omega]", "4"], ",", 
     SubscriptBox["\[Omega]", "5"], ",", 
     SubscriptBox["\[Omega]", "6"], ",", 
     SubscriptBox["\[Omega]", "7"]}], "}"}], "=", 
   RowBox[{"16", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["17", "48"], ",", 
      RowBox[{
       FractionBox["1", "48"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", "s"}], ")"}]}], ",", 
      FractionBox["1", "12"], ",", 
      FractionBox["1", "16"], ",", 
      FractionBox["1", "24"], ",", 
      RowBox[{
       FractionBox["1", "48"], " ", 
       RowBox[{"(", 
        RowBox[{"3", "-", "s"}], ")"}]}], ",", 
      FractionBox["1", "48"]}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS12sub", "=", 
   RowBox[{
    FractionBox["1", "16"], 
    RowBox[{"(", GridBox[{
       {"9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "0", "0", "9", "3", "0", "3", "1", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "0", "0", "3", "9", "0", "1", "3", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "3", "1", "0", "9", "3", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "0", "0", "1", "3", "0", "3", "9", "0", "0", "0", "0", "0", "0", 
        "0", "0", "0"},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], "0", 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "4"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], "0", 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "3"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], "0", 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"], 
        SubscriptBox["\[Omega]", "2"]},
       {"0", "0", "0", "0", 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], "0", 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "7"], 
        SubscriptBox["\[Omega]", "6"], 
        SubscriptBox["\[Omega]", "5"], 
        SubscriptBox["\[Omega]", "4"], 
        SubscriptBox["\[Omega]", "3"], 
        SubscriptBox["\[Omega]", "2"], 
        SubscriptBox["\[Omega]", "1"]}
      }], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DS12ind", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "2", ",", "3", ",", "5", ",", "6", ",", "7", ",", "9", ",", 
       "10", ",", "11"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "2", ",", "3", ",", "4", ",", "6", ",", "7", ",", "8", ",", "10", ",", 
       "11", ",", "12"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "5", ",", "6", ",", "7", ",", "9", ",", "10", ",", "11", ",", "13", ",",
        "14", ",", "15"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "6", ",", "7", ",", "8", ",", "10", ",", "11", ",", "12", ",", "14", 
       ",", "15", ",", "16", ",", "17", ",", "18", ",", "19", ",", "20", ",", 
       "21", ",", "22", ",", "23", ",", "24"}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6060020159881544`*^9, 3.6060020447587996`*^9}, {
   3.6065109500920463`*^9, 3.6065109534842405`*^9}, {3.6065109874981856`*^9, 
   3.6065110193820095`*^9}, {3.6065112693993096`*^9, 
   3.6065112826410666`*^9}, {3.606511345785679*^9, 3.6065113933443985`*^9}, {
   3.6065114267113075`*^9, 3.6065115669903307`*^9}, 3.6065126393416653`*^9, {
   3.606617785456699*^9, 3.606617848567309*^9}, {3.6066180721760983`*^9, 
   3.606618077347394*^9}, {3.60661814791543*^9, 3.6066182399966974`*^9}, {
   3.6066182820521026`*^9, 3.6066183193792377`*^9}, {3.6066183733743258`*^9, 
   3.6066183802897215`*^9}, {3.606618417956876*^9, 3.6066184192259483`*^9}, 
   3.606618462892446*^9, {3.6066185391248064`*^9, 3.606618583051319*^9}, 
   3.606618633721217*^9, {3.6066186714993773`*^9, 3.6066187012550793`*^9}, {
   3.6066200911055746`*^9, 3.606620193529433*^9}, {3.6066203218337717`*^9, 
   3.606620337351659*^9}, {3.606620424751658*^9, 3.606620523468304*^9}, {
   3.6066205551231146`*^9, 3.606620582291669*^9}, {3.6072830869478307`*^9, 
   3.607283407318155*^9}, {3.6072834542798405`*^9, 3.6072834576650343`*^9}, {
   3.6072837359329505`*^9, 3.6072837692338552`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Total", "/@", "DS12sub"}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.607283423039054*^9, 3.607283428291354*^9}, {
  3.6072837612143965`*^9, 3.6072837788454046`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinShow", "[", 
   RowBox[{
    RowBox[{"DooSabinDefault", "[", "12", "]"}], ",", 
    RowBox[{"DS12sub", "/.", 
     RowBox[{"s", "\[Rule]", 
      SqrtBox["3"]}]}], ",", "DS12ind"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060020500691037`*^9, 3.6060020896213655`*^9}, 
   3.606248080639765*^9, {3.6065115751597977`*^9, 3.606511577517933*^9}, {
   3.6065119116640453`*^9, 3.60651191577428*^9}, {3.6066182920156727`*^9, 
   3.6066183006731677`*^9}, 3.6066183405644493`*^9, {3.6066201747673597`*^9, 
   3.60662018141574*^9}, {3.6072830939432306`*^9, 3.6072830968943996`*^9}, {
   3.60728379240318*^9, 3.6072837948473206`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Solving over ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[DoubleStruckCapitalQ]", "+", 
    RowBox[{
     SqrtBox["3"], "\[DoubleStruckCapitalQ]"}]}], TraditionalForm]]],
 " "
}], "Subsubsection",
 CellChangeTimes->{{3.605646090001303*^9, 3.605646094212544*^9}, 
   3.605704768127207*^9, 3.6062482140303946`*^9, {3.6065116826919484`*^9, 
   3.6065116843010406`*^9}, {3.606617967119089*^9, 3.606617967119089*^9}, {
   3.6072838081210794`*^9, 3.6072838081210794`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"GeneralForm12", "=", 
   RowBox[{"Array", "[", 
    RowBox[{
     RowBox[{
      SubscriptBox["a", 
       RowBox[{"#3", ",", "#2", ",", "#1"}]], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"17", ",", "17", ",", "17"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.605614982813074*^9, 3.605615045220643*^9}, {
   3.6056150860689793`*^9, 3.6056151687117066`*^9}, {3.6056174591757135`*^9, 
   3.605617459934757*^9}, {3.6056180096421986`*^9, 3.6056180739638777`*^9}, 
   3.605623343347269*^9, 3.605628559250602*^9, {3.6056931050981197`*^9, 
   3.60569317573816*^9}, {3.605702729338595*^9, 3.605702743200388*^9}, {
   3.605994472093668*^9, 3.605994493389886*^9}, {3.606002098474872*^9, 
   3.606002108029419*^9}, {3.6062480930994773`*^9, 3.606248100098878*^9}, {
   3.606511617896242*^9, 3.606511622796523*^9}, {3.6066187542331095`*^9, 
   3.606618758769369*^9}, {3.6072838154755*^9, 3.607283842187028*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "[", 
       RowBox[{"CoefficientArrays", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Flatten", "[", "GeneralForm12", "]"}]}], "]"}], "]"}], 
      "&"}], "/@", 
     RowBox[{"Flatten", "[", 
      RowBox[{"GeneralForm12", "-", 
       RowBox[{"RHS", "[", 
        RowBox[{
        "DooSabinForm4", ",", "GeneralForm12", ",", "DS12sub", ",", 
         "DS12ind"}], "]"}]}], "]"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065063417174625`*^9, 3.6065063645497684`*^9}, {
  3.6065070355301456`*^9, 3.606507041961514*^9}, {3.6065076559416313`*^9, 
  3.606507662820025*^9}, {3.606511627208775*^9, 3.6065116360962834`*^9}, {
  3.606618769026956*^9, 3.6066187798415747`*^9}, {3.6072838483333797`*^9, 
  3.6072838586639705`*^9}}],

Cell[BoxData[
 RowBox[{"ArrayPlot", "[", 
  RowBox[{"Unitize", "[", 
   RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
   "]"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]], "Input",
 CellChangeTimes->{{3.60650707616447*^9, 3.606507077370539*^9}}],

Cell[BoxData[
 GraphicsBox[{{
    {GrayLevel[0.5], LineBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}, {-1, -1}}], 
     LineBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}, {0, -1}}], 
     LineBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}, {-1, 0}}], 
     LineBox[NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 20] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 20] Pi]}, {(
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {
        2^Rational[1, 2] Cos[Rational[3, 20] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 20] Pi]}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {1, 
        1}, {(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {
        2^Rational[1, 2] Sin[Rational[3, 20] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 20] Pi]}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {
        2^Rational[1, 2] Sin[Rational[1, 20] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 20] Pi]}, {0, 1}, {0, 0}}, {{0, 0}, {1, 0}, {
        1.3968022466674208`, 0.22123174208247431`}, {1.3449970239279148`, 
        0.4370160244488211}, {1.260073510670101, 0.6420395219202061}, {
        1.1441228056353685`, 0.8312538755549068}, {1, 1}, {0.8312538755549068,
         1.1441228056353685`}, {0.6420395219202061, 1.260073510670101}, {
        0.4370160244488211, 1.3449970239279148`}, {0.22123174208247431`, 
        1.3968022466674208`}, {0, 1}, {0, 0}}]]}, 
    {RGBColor[0.88, 1, 0.88], EdgeForm[Dashing[{Small, Small}]], 
     PolygonBox[{{-1, -1}, {0, -1}, {0, 0}, {-1, 0}}], 
     PolygonBox[{{0, -1}, {1, -1}, {1, 0}, {0, 0}}], 
     PolygonBox[{{-1, 0}, {0, 0}, {0, 1}, {-1, 1}}], 
     PolygonBox[
      NCache[{{0, 0}, {1, 0}, {
        2^Rational[1, 2] Cos[Rational[1, 20] Pi], 2^Rational[1, 2] 
         Sin[Rational[1, 20] Pi]}, {(
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {
        2^Rational[1, 2] Cos[Rational[3, 20] Pi], 2^Rational[1, 2] 
         Sin[Rational[3, 20] Pi]}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {1, 
        1}, {(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
         Rational[1, 2], Rational[1, 2] 
         2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {
        2^Rational[1, 2] Sin[Rational[3, 20] Pi], 2^Rational[1, 2] 
         Cos[Rational[3, 20] Pi]}, {
        Rational[1, 2] 
         2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
          2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
         Rational[1, 2]}, {
        2^Rational[1, 2] Sin[Rational[1, 20] Pi], 2^Rational[1, 2] 
         Cos[Rational[1, 20] Pi]}, {0, 1}}, {{0, 0}, {1, 0}, {
        1.3968022466674208`, 0.22123174208247431`}, {1.3449970239279148`, 
        0.4370160244488211}, {1.260073510670101, 0.6420395219202061}, {
        1.1441228056353685`, 0.8312538755549068}, {1, 1}, {0.8312538755549068,
         1.1441228056353685`}, {0.6420395219202061, 1.260073510670101}, {
        0.4370160244488211, 1.3449970239279148`}, {0.22123174208247431`, 
        1.3968022466674208`}, {0, 1}}]]}, 
    {RGBColor[1, 0, 0], Opacity[0.5], 
     PolygonBox[
      NCache[{{Rational[-1, 2], Rational[-1, 2]}, {
        Rational[1, 2], Rational[-1, 2]}, {
        Rational[1, 12] (
          2 + (2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + (
            2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + 
          Rational[1, 2] 2^Rational[-1, 2] (-1 + 5^Rational[1, 2]) + 
          Rational[1, 2] 2^Rational[-1, 2] (1 + 5^Rational[1, 2]) + 
          2^Rational[1, 2] Cos[Rational[1, 20] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 20] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 20] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 20] Pi]), 
         Rational[1, 12] (
          2 + (2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + (
            2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
           Rational[1, 2] + 
          Rational[1, 2] 2^Rational[-1, 2] (-1 + 5^Rational[1, 2]) + 
          Rational[1, 2] 2^Rational[-1, 2] (1 + 5^Rational[1, 2]) + 
          2^Rational[1, 2] Cos[Rational[1, 20] Pi] + 
          2^Rational[1, 2] Cos[Rational[3, 20] Pi] + 
          2^Rational[1, 2] Sin[Rational[1, 20] Pi] + 
          2^Rational[1, 2] Sin[Rational[3, 20] Pi])}, {
        Rational[-1, 2], Rational[1, 2]}}, {{-0.5, -0.5}, {0.5, -0.5}, {
       0.7731280625756011, 0.7731280625756011}, {-0.5, 0.5}}]]}, 
    {RGBColor[0, 1, 0], EdgeForm[RGBColor[0, 0, 1]], DiskBox[{-1, -1}, 0.04], 
     DiskBox[{0, -1}, 0.04], DiskBox[{1, -1}, 0.04], DiskBox[{-1, 0}, 0.04], 
     DiskBox[{0, 0}, 0.04], DiskBox[{1, 0}, 0.04], DiskBox[{-1, 1}, 0.04], 
     DiskBox[{0, 1}, 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[1, 20] Pi], 2^Rational[1, 2] 
        Cos[Rational[1, 20] Pi]}, {0.22123174208247431`, 
       1.3968022466674208`}], 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] 
        2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
         2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
        Rational[1, 2]}, {0.4370160244488211, 1.3449970239279148`}], 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Sin[Rational[3, 20] Pi], 2^Rational[1, 2] 
        Cos[Rational[3, 20] Pi]}, {0.6420395219202061, 1.260073510670101}], 
      0.04], DiskBox[
      NCache[{(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
        Rational[1, 2], Rational[1, 2] 
        2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {0.8312538755549068, 
       1.1441228056353685`}], 0.04], DiskBox[{1, 1}, 0.04], 
     DiskBox[NCache[{
       Rational[1, 2] 
        2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
         2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
        Rational[1, 2]}, {1.1441228056353685`, 0.8312538755549068}], 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Cos[Rational[3, 20] Pi], 2^Rational[1, 2] 
        Sin[Rational[3, 20] Pi]}, {1.260073510670101, 0.6420395219202061}], 
      0.04], DiskBox[
      NCache[{(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
        Rational[1, 2], Rational[1, 2] 
        2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {1.3449970239279148`, 
       0.4370160244488211}], 0.04], 
     DiskBox[NCache[{
       2^Rational[1, 2] Cos[Rational[1, 20] Pi], 2^Rational[1, 2] 
        Sin[Rational[1, 20] Pi]}, {1.3968022466674208`, 
       0.22123174208247431`}], 0.04]}}, {InsetBox[
     StyleBox["1",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["2",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["3",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, -1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["4",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["5",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["6",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 0},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["7",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {-1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["8",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {0, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["9",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[1, 20] Pi], 2^Rational[1, 2] 
       Cos[Rational[1, 20] Pi]}, {0.22123174208247431`, 1.3968022466674208`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["10",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] 
       2^Rational[-1, 2] (-1 + 5^Rational[1, 2]), (
        2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
       Rational[1, 2]}, {0.4370160244488211, 1.3449970239279148`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["11",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Sin[Rational[3, 20] Pi], 2^Rational[1, 2] 
       Cos[Rational[3, 20] Pi]}, {0.6420395219202061, 1.260073510670101}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["12",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{(2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
       Rational[1, 2], Rational[1, 2] 
       2^Rational[-1, 2] (1 + 5^Rational[1, 2])}, {0.8312538755549068, 
      1.1441228056353685`}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["13",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], {1, 1},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["14",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{Rational[1, 2] 
       2^Rational[-1, 2] (1 + 5^Rational[1, 2]), (
        2 (Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2]))^
       Rational[1, 2]}, {1.1441228056353685`, 0.8312538755549068}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["15",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[3, 20] Pi], 2^Rational[1, 2] 
       Sin[Rational[3, 20] Pi]}, {1.260073510670101, 0.6420395219202061}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["16",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{(2 (Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2]))^
       Rational[1, 2], Rational[1, 2] 
       2^Rational[-1, 2] (-1 + 5^Rational[1, 2])}, {1.3449970239279148`, 
      0.4370160244488211}],
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     StyleBox["17",
      StripOnInput->False,
      FontSize->Medium,
      FontWeight->Bold], 
     NCache[{2^Rational[1, 2] Cos[Rational[1, 20] Pi], 2^Rational[1, 2] 
       Sin[Rational[1, 20] Pi]}, {1.3968022466674208`, 0.22123174208247431`}],
     Background->RGBColor[1, 0.85, 0.85]]}},
  Axes->False,
  PlotRange->All]], "Input",
 CellChangeTimes->{{3.606511895391114*^9, 3.6065118956891313`*^9}, {
  3.6066189268639836`*^9, 3.6066189414108157`*^9}, {3.6072838998243246`*^9, 
  3.6072839001003404`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mirror12", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "17", ",", "16", ",", "15", ",", "14", ",", "13", ",", "12", ",", 
     "11", ",", "10", ",", "9"}], "}"}], "\[LeftDoubleBracket]", "n", 
   "\[RightDoubleBracket]"}]}], "\[IndentingNewLine]", 
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Mirror12", ",", "Listable"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MirrorIndex12", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{"Mirror12", "/@", 
   RowBox[{"{", 
    RowBox[{"i", ",", "k", ",", "j"}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MapMulti12", "[", 
   RowBox[{"{", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"k", "-", "1"}], ")"}], " ", "17", " ", "17"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"j", "-", "1"}], ")"}], "17"}], "+", 
   "i"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Mirror12", "[", 
   RowBox[{"{", 
    RowBox[{
    "1", ",", "4", ",", "7", ",", "2", ",", "5", ",", "8", ",", "3", ",", "6",
      ",", "17", ",", "16", ",", "15", ",", "14", ",", "13", ",", "12", ",", 
     "11", ",", "10", ",", "9"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{"Range", "[", "17", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064597960761404`*^9, 3.606459981197729*^9}, {
   3.6064600503186827`*^9, 3.606460053797881*^9}, {3.6064648600587835`*^9, 
   3.6064648602527947`*^9}, 3.606464912318773*^9, {3.606465074482048*^9, 
   3.6064650746660585`*^9}, {3.606475536232521*^9, 3.606475580240697*^9}, {
   3.606506209905923*^9, 3.6065062511932845`*^9}, {3.6065117667157545`*^9, 
   3.6065118244110546`*^9}, {3.6065119538874598`*^9, 
   3.6065119616579046`*^9}, {3.6066189994411345`*^9, 3.606619060257613*^9}, {
   3.607283921449561*^9, 3.607283945656946*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"compress12", ",", "inflate12"}], "}"}], "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"hash", ",", 
       RowBox[{"n", "=", "17"}], ",", 
       RowBox[{"list", "=", 
        RowBox[{"{", "}"}]}], ",", "key", ",", "value", ",", "mir", ",", 
       RowBox[{"index", "=", 
        RowBox[{"{", "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"key", "=", 
          RowBox[{"{", 
           RowBox[{"i", ",", "j", ",", "k"}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"value", "=", 
          RowBox[{"HashGet", "[", 
           RowBox[{"hash", ",", "key"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"value", "===", "Null"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"mir", "=", 
             RowBox[{"MirrorIndex12", "[", "key", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"list", ",", 
              RowBox[{"MapMulti12", "/@", 
               RowBox[{"Union", "[", 
                RowBox[{"{", 
                 RowBox[{"key", ",", "mir"}], "}"}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "key", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"hash", "[", "mir", "]"}], "=", 
             RowBox[{"Length", "[", "list", "]"}]}], ";"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"index", ",", 
           RowBox[{"hash", "[", "key", "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"list", ",", "index"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Compress12", "[", "mat_", "]"}], ":=", 
  RowBox[{"Transpose", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Total", "[", 
      RowBox[{"Transpose", "[", 
       RowBox[{"mat", "\[LeftDoubleBracket]", 
        RowBox[{"All", ",", "#"}], "\[RightDoubleBracket]"}], "]"}], "]"}], 
     "&"}], "/@", "compress12"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6064607678477225`*^9, 3.606460818710632*^9}, {
   3.606464024319982*^9, 3.606464039159831*^9}, {3.606464975580391*^9, 
   3.6064650084722724`*^9}, {3.6064650852146616`*^9, 3.606465085394672*^9}, 
   3.606475587450808*^9, {3.6065062600607915`*^9, 3.6065062766697416`*^9}, {
   3.6065118534067125`*^9, 3.6065118750459504`*^9}, {3.6066190672000103`*^9, 
   3.6066190883722215`*^9}, {3.6072839511042576`*^9, 3.6072839707713823`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"matrix", "=", 
   RowBox[{"Compress12", "[", 
    RowBox[{"affine1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vector", "=", 
   RowBox[{"-", 
    RowBox[{
    "affine1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"matrix", "//", "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{"vector", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605902428728287*^9, 3.6059024298513513`*^9}, {
   3.605903620610459*^9, 3.605903630825043*^9}, {3.606247389591239*^9, 
   3.6062473955065775`*^9}, {3.606506489617922*^9, 3.6065065046677823`*^9}, 
   3.60651196962936*^9, {3.6066190932395*^9, 3.6066190933415055`*^9}, 
   3.6072839749936237`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Abig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"mat", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", 
         RowBox[{"Flatten", "[", "matrix", "]"}]}]}], ",", "A1", ",", "A2"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A1", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"A2", "=", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"mat", "\[LeftDoubleBracket]", 
           RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
          RowBox[{"3", " ", 
           RowBox[{"mat", "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}], ",", 
         RowBox[{"Dimensions", "[", "matrix", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayFlatten", "[", 
       RowBox[{"(", GridBox[{
          {"A1", 
           RowBox[{"3", " ", "A2"}]},
          {"A2", "A1"}
         }], ")"}], "]"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Abig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6059018202024813`*^9, 3.605901876088678*^9}, {
  3.6059019797526073`*^9, 3.605902108843991*^9}, {3.60590230744335*^9, 
  3.605902401074705*^9}, {3.60590243542667*^9, 3.6059024380588207`*^9}, {
  3.6059036403075857`*^9, 3.605903765512747*^9}, {3.6059037983406243`*^9, 
  3.6059038132964797`*^9}, {3.6062475368126593`*^9, 3.6062475764519267`*^9}, {
  3.60651199165462*^9, 3.606512000474125*^9}, {3.606619117651896*^9, 
  3.606619123223215*^9}, {3.6072840004750814`*^9, 3.6072840045783157`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"bBig", "=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"vec", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"CoefficientList", "[", 
              RowBox[{"#", ",", "s"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "]"}], 
           "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "4", "]"}], "\[RightDoubleBracket]"}], "&"}],
          "/@", "vector"}]}], ",", "b1", ",", "b2"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"b1", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "3"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"b2", "=", 
       RowBox[{
        RowBox[{"vec", "\[LeftDoubleBracket]", 
         RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{"3", " ", 
         RowBox[{"vec", "\[LeftDoubleBracket]", 
          RowBox[{"All", ",", "4"}], "\[RightDoubleBracket]"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", 
       RowBox[{"b1", ",", "b2"}], "]"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"bBig", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.605903794291393*^9, 3.6059038293924007`*^9}, {
  3.6062476157671757`*^9, 3.6062476455098767`*^9}, {3.6065120108437176`*^9, 
  3.606512014298915*^9}, {3.606619156501118*^9, 3.606619157261162*^9}, {
  3.607284021936309*^9, 3.6072840228323603`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"nul", "=", 
   RowBox[{"NullSpace", "[", 
    RowBox[{"Abig", "//", "N"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6065065623490815`*^9, 3.606506597755107*^9}, {
  3.60661968156315*^9, 3.606619682018176*^9}}],

Cell[BoxData[
 RowBox[{"nul", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.606512057891409*^9, 3.606512059437497*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NUL", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "\[LeftDoubleBracket]", 
         RowBox[{"Range", "[", "2482", "]"}], "\[RightDoubleBracket]"}], "+", 
        RowBox[{
         SqrtBox["3"], 
         RowBox[{"#", "\[LeftDoubleBracket]", 
          RowBox[{"2482", "+", 
           RowBox[{"Range", "[", "2482", "]"}]}], 
          "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
      "inflate12", "\[RightDoubleBracket]"}], "&"}], "/@", "nul"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"NUL", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6065066379594064`*^9, 3.6065066987188816`*^9}, {
  3.6065067692769175`*^9, 3.60650676950293*^9}, {3.606512065139823*^9, 
  3.606512080142681*^9}, {3.606619506661146*^9, 3.606619517669776*^9}, {
  3.6066196898256226`*^9, 3.6066196899396296`*^9}, {3.607284466942762*^9, 
  3.607284473838156*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Union", "[", 
    RowBox[{"Chop", "[", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Skew3", "[", 
       RowBox[{"ArrayReshape", "[", 
        RowBox[{"#", ",", 
         RowBox[{"Dimensions", "[", "GeneralForm12", "]"}]}], "]"}], "]"}], 
      "]"}], "]"}], "]"}], "&"}], "/@", "NUL"}]], "Input",
 CellChangeTimes->{{3.606506741794345*^9, 3.606506758727314*^9}, {
   3.6065121129095554`*^9, 3.6065121130125613`*^9}, {3.606619698329109*^9, 
   3.606619698416114*^9}, {3.6066197465068645`*^9, 3.6066197509781203`*^9}, 
   3.607284481263581*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DooSabinForm12", "=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"sol", "=", 
       RowBox[{"LinearSolve", "[", 
        RowBox[{"Abig", ",", "bBig"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ArrayReshape", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"sol", "\[LeftDoubleBracket]", 
           RowBox[{"Range", "[", "2482", "]"}], "\[RightDoubleBracket]"}], 
          "+", 
          RowBox[{
           SqrtBox["3"], 
           RowBox[{"sol", "\[LeftDoubleBracket]", 
            RowBox[{"2482", "+", 
             RowBox[{"Range", "[", "2482", "]"}]}], 
            "\[RightDoubleBracket]"}]}]}], ")"}], "\[LeftDoubleBracket]", 
        "inflate12", "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Dimensions", "[", "GeneralForm12", "]"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6059039307671986`*^9, 3.6059039982410583`*^9}, {
  3.6059040950745964`*^9, 3.605904107824326*^9}, {3.606247663362898*^9, 
  3.6062476684691896`*^9}, {3.6065067937903194`*^9, 3.6065068091131954`*^9}, {
  3.606512125693287*^9, 3.6065121477505484`*^9}, {3.6066192318004255`*^9, 
  3.6066192318934307`*^9}, {3.606619525856244*^9, 3.606619538749982*^9}, {
  3.607284122576065*^9, 3.607284136401856*^9}}],

Cell[BoxData[
 RowBox[{"Union", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{"Chop", "[", 
    RowBox[{"DooSabinForm12", "-", 
     RowBox[{"RHS", "[", 
      RowBox[{"DooSabinForm4", ",", 
       RowBox[{"N", "[", "DooSabinForm12", "]"}], ",", 
       RowBox[{"DS12sub", "/.", 
        RowBox[{"s", "\[Rule]", 
         SqrtBox["3"]}]}], ",", "DS12ind"}], "]"}]}], "]"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.606512198595456*^9, 3.6065122090830564`*^9}, {
  3.6065123004512825`*^9, 3.606512302297388*^9}, {3.6065123711973286`*^9, 
  3.606512373717473*^9}, {3.6065124173649693`*^9, 3.6065124338429117`*^9}, {
  3.606619595427223*^9, 3.6066196073609056`*^9}, {3.607284157351054*^9, 
  3.607284164879485*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm12", ">>", "\"\<DooSabinForm12.mx\>\""}]], "Input",
 CellChangeTimes->{{3.605696638369211*^9, 3.6056966397362895`*^9}, {
  3.6056966748232965`*^9, 3.605696676448389*^9}, {3.6059041277484655`*^9, 
  3.605904148076628*^9}, {3.6065121577531204`*^9, 3.6065121609133015`*^9}, {
  3.606619628900138*^9, 3.6066196314582844`*^9}, {3.607282744912267*^9, 
  3.6072827454242964`*^9}, {3.6072841711338425`*^9, 3.6072841732629642`*^9}, {
  3.607683685854491*^9, 3.6076836863995223`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{
    RowBox[{"Skew3", "[", "DooSabinForm12", "]"}], "\[LeftDoubleBracket]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "4"}], "}"}], "\[RightDoubleBracket]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6056967055450535`*^9, 3.605696734622717*^9}, 
   3.6056967867766995`*^9, {3.606506885574569*^9, 3.6065068891617746`*^9}, 
   3.6065121646355143`*^9, {3.606619637209613*^9, 3.606619645289075*^9}, {
   3.607284176370142*^9, 3.6072841764121447`*^9}, {3.607284598419282*^9, 
   3.6072845989393115`*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other", "Section",
 CellChangeTimes->{{3.605327924449959*^9, 3.6053279283121796`*^9}, {
   3.6056149079927945`*^9, 3.6056149089858513`*^9}, {3.6056228516001425`*^9, 
   3.6056228546483173`*^9}, {3.605646909007148*^9, 3.6056469329195156`*^9}, {
   3.60564698352641*^9, 3.6056469954380913`*^9}, {3.605696857837764*^9, 
   3.605696861844993*^9}, {3.605697358177382*^9, 3.605697358385394*^9}, 
   3.6066296785789466`*^9, {3.607458396293597*^9, 3.6074583982697105`*^9}, 
   3.61230973915932*^9, {3.6123104295278068`*^9, 3.612310430326853*^9}}],

Cell[CellGroupData[{

Cell["Deprecated", "Subsection",
 CellChangeTimes->{{3.6056540916429653`*^9, 3.6056540971372795`*^9}, {
  3.606474578729313*^9, 3.606474580536841*^9}, {3.6121383503004975`*^9, 
  3.612138350844529*^9}, {3.612177470241826*^9, 3.612177471568902*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"ImageRes", "=", "200"}], ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DooSabinComparison", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Vs_", ",", "Fs_"}], "}"}], ",", "viewPoint_", ",", 
      RowBox[{"plotRange_:", "All"}]}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Vd", ",", "Fd", ",", "vol", ",", "img1", ",", "img2"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"DooSabinLoadAlt", ";", "\[IndentingNewLine]", 
       RowBox[{"vol", "=", 
        RowBox[{"DooSabinVolumeVertex", "[", 
         RowBox[{"{", 
          RowBox[{"Vs", ",", "Fs"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Vd", ",", "Fd"}], "}"}], "=", 
        RowBox[{"DualMesh", "[", 
         RowBox[{"{", 
          RowBox[{"Vs", ",", "Fs"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"img1", "=", 
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"PlotMesh", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Vd", ",", "Fd"}], "}"}], ",", "vol"}], "]"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "ImageRes"}], ",", 
          RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
          RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
          RowBox[{"ViewPoint", "\[Rule]", "viewPoint"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "plotRange"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"DooSabinLoadInt", ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"DooSabinLoadKernel", "[", "1", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"vol", "=", 
          RowBox[{"DooSabinVolumeVertex", "[", 
           RowBox[{"{", 
            RowBox[{"Vs", ",", "Fs"}], "}"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"img2", "=", 
          RowBox[{"Show", "[", 
           RowBox[{
            RowBox[{"PlotMesh", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Vd", ",", "Fd"}], "}"}], ",", "vol"}], "]"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
            RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
            RowBox[{"Boxed", "\[Rule]", "False"}], ",", 
            RowBox[{"ViewPoint", "\[Rule]", "viewPoint"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "plotRange"}]}], "]"}]}], ";"}], 
        "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"Rasterize", "[", 
         RowBox[{"img1", ",", 
          RowBox[{"ImageResolution", "\[Rule]", "ImageRes"}]}], "]"}], "]"}], 
       ";"}]}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Rasterize", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ImageResolution", "\[Rule]", "400"}]}], "]"}], "&"}], "/@", 
         RowBox[{"{", 
          RowBox[{"img1", ",", "img2"}], "}"}]}], "]"}], ";"}], "*)"}], 
     "\[IndentingNewLine]", "]"}]}]}], "*)"}]], "Input",
 CellChangeTimes->{
  3.607502776327345*^9, {3.6075028188317766`*^9, 3.6075028811253395`*^9}, {
   3.6075029498082676`*^9, 3.607502999643118*^9}, {3.607503116007774*^9, 
   3.607503171284936*^9}, {3.6075051670650873`*^9, 3.6075051695592303`*^9}, {
   3.6076821537008567`*^9, 3.607682180347381*^9}, {3.607682361514743*^9, 
   3.6076823650969477`*^9}, {3.6076825461143017`*^9, 
   3.6076825543777742`*^9}, {3.6076840552946215`*^9, 3.607684076645843*^9}, {
   3.607684920607115*^9, 3.6076849240963144`*^9}, {3.6081684560234656`*^9, 
   3.6081684583906007`*^9}, {3.608168529076644*^9, 3.608168531772798*^9}, {
   3.6088500838588257`*^9, 3.6088501091292715`*^9}, {3.6088501458963737`*^9, 
   3.6088501633293715`*^9}, {3.6088788311495743`*^9, 
   3.6088788584761376`*^9}, {3.6123088541507006`*^9, 3.6123088566908455`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Quadratic B-Spline", "Subsection",
 CellChangeTimes->{{3.604664346574308*^9, 3.6046643521896296`*^9}, {
  3.6052569012648907`*^9, 3.6052569032320037`*^9}, {3.605318991083868*^9, 
  3.6053189916358995`*^9}, {3.607335252489545*^9, 3.607335252679548*^9}, {
  3.6088532425714936`*^9, 3.608853242783506*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"bas2", "[", "x_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "x"}], ")"}], "2"]}], ",", 
     RowBox[{
      FractionBox["1", "2"], "+", "x", "-", 
      SuperscriptBox["x", "2"]}], ",", 
     FractionBox[
      SuperscriptBox["x", "2"], "2"]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"bas2", "[", "s", "]"}], "\[LeftDoubleBracket]", "k1", 
        "\[RightDoubleBracket]"}], 
       RowBox[{
        RowBox[{"bas2", "[", "t", "]"}], "\[LeftDoubleBracket]", "k2", 
        "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k1", ",", "3"}], "}"}]}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    SubscriptBox["\[PartialD]", "s"], 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    SubscriptBox["\[PartialD]", "t"], 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605311373856182*^9, 3.6053113916902018`*^9}, {
  3.6053183209275374`*^9, 3.605318322126606*^9}, {3.605679142382786*^9, 
  3.605679142872814*^9}, {3.6056792859319963`*^9, 3.6056792882031264`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Print", "[", "#", "]"}], "&"}], "/@", 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}], "//", "FullSimplify"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060826221457205`*^9, 3.606082624318845*^9}, {
   3.606082689999602*^9, 3.6060826970970078`*^9}, {3.606083136025113*^9, 
   3.6060831518750196`*^9}, 3.6061592838177185`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Ten2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Bas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "a1", 
       "\[RightDoubleBracket]"}], " ", 
      RowBox[{
       RowBox[{"Sas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "b1", 
       "\[RightDoubleBracket]"}], 
      RowBox[{
       RowBox[{"Tas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "c1", 
       "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b1", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a1", ",", "9"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DooSabinForm4", "=", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", "0", "1"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox["\[Integral]", "0", "1"], 
       RowBox[{
        RowBox[{"Ten2", "[", 
         RowBox[{"s", ",", "t"}], "]"}], 
        RowBox[{"\[DifferentialD]", "t"}]}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "s"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605311415842583*^9, 3.605311425491135*^9}, {
   3.6053177189571066`*^9, 3.6053177200421686`*^9}, {3.6053178185128007`*^9, 
   3.605317818732814*^9}, 3.6056567554633274`*^9, 3.6056749796226892`*^9, {
   3.6056806477328873`*^9, 3.605680649254974*^9}, {3.6061681049632587`*^9, 
   3.6061681082464466`*^9}}],

Cell[BoxData[
 RowBox[{"DooSabinForm4", ">>", "\"\<DooSabinForm4.mx\>\""}]], "Input",
 CellChangeTimes->{{3.6056806604366136`*^9, 3.6056806838659534`*^9}, 
   3.605680973864541*^9}],

Cell["\<\
Here we ensure that our orientation of vertices yields positive volume \
(instead of negative):\
\>", "Text",
 CellChangeTimes->{{3.6056960408260336`*^9, 3.605696080666312*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"P", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "1"}], "0", "1", 
       RowBox[{"-", "1"}], "0", "1", 
       RowBox[{"-", "1"}], "0", "1"},
      {
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "0", "0", "0", "1", "1", "1"},
      {"1", "1", "1", "1", "1", "1", "1", "1", "1"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}]}]}]}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.6056751414849477`*^9, 3.6056752216245317`*^9}, {
  3.605675324382409*^9, 3.605675368213916*^9}, {3.60567916833327*^9, 
  3.605679197614945*^9}, {3.60567929840771*^9, 3.6056793214150257`*^9}, {
  3.6056807076843157`*^9, 3.6056807842326946`*^9}}],

Cell["\<\
Coefficients of volume form for regular patch (scaled by 57600):\
\>", "Text",
 CellChangeTimes->{{3.6056960858646097`*^9, 3.6056961138182087`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", 
      RowBox[{"57600", " ", "#1"}], "]"}], "]"}], "&"}], "/@", 
   "DooSabinForm4"}], ";"}]], "Input",
 CellChangeTimes->{{3.6053184242454467`*^9, 3.6053184420424647`*^9}, {
  3.605318499722764*^9, 3.605318521142989*^9}, {3.6056806776005955`*^9, 
  3.60568068555305*^9}, {3.605696756296956*^9, 3.6056967785772305`*^9}, {
  3.6061598296519384`*^9, 3.6061598613517513`*^9}, {3.6062456727720423`*^9, 
  3.6062456737220964`*^9}}],

Cell["We approximate the volume of a torus (only to check):", "Text",
 CellChangeTimes->{{3.605610756768358*^9, 3.605610762173667*^9}, {
  3.6056961984740505`*^9, 3.60569627748057*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Torus", "[", 
    RowBox[{"R_", ",", "r_", ",", "\[Theta]_", ",", "\[Phi]_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TorusVolume", "[", 
    RowBox[{"R_", ",", "r_"}], "]"}], "=", 
   RowBox[{"2", " ", 
    SuperscriptBox["\[Pi]", "2"], "R", " ", 
    SuperscriptBox["r", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TorusVolume", "[", 
   RowBox[{"2", ",", "1"}], "]"}], "//", "N"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TorusSample", "[", 
   RowBox[{"N_", ",", "M_", ",", "i_", ",", "j_"}], "]"}], ":=", 
  RowBox[{"Torus", "[", 
   RowBox[{"2", ",", "1", ",", 
    FractionBox[
     RowBox[{"2", "\[Pi]", " ", "i"}], "N"], ",", 
    FractionBox[
     RowBox[{"2", "\[Pi]", " ", "j"}], "M"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ParametricPlot3D", "[", 
    RowBox[{
     RowBox[{"Torus", "[", 
      RowBox[{"2", ",", "1", ",", "\[Theta]", ",", "\[Phi]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Phi]", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "z"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ListPointPlot3D", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"TorusSample", "[", 
         RowBox[{"60", ",", "20", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "20"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "60"}], "}"}]}], "]"}], ",", "1"}], "]"}], "]"}]}],
   "}"}]}], "Input",
 CellChangeTimes->{{3.60530326388444*^9, 3.60530327035681*^9}, {
   3.6053033048367825`*^9, 3.6053033626270876`*^9}, {3.6053034043744755`*^9, 
   3.6053034172622128`*^9}, {3.605303486944198*^9, 3.6053034974617996`*^9}, {
   3.6053035845447807`*^9, 3.6053037029515533`*^9}, {3.605304029281218*^9, 
   3.605304039642811*^9}, {3.605305062622322*^9, 3.6053050743329916`*^9}, 
   3.605307382028984*^9, {3.6053176021624265`*^9, 3.6053176023304358`*^9}, {
   3.605318836373019*^9, 3.6053188521489215`*^9}, {3.6056755722345853`*^9, 
   3.6056755763198185`*^9}, {3.6056763335421295`*^9, 3.605676336260285*^9}, {
   3.6056776414139357`*^9, 3.605677663031172*^9}, {3.6056777897974224`*^9, 
   3.60567779324962*^9}, {3.6056867128575044`*^9, 3.605686729531458*^9}}],

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", "=", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"TorusSample", "[", 
              RowBox[{"60", ",", "20", ",", 
               RowBox[{"i", "+", "k"}], ",", 
               RowBox[{"j", "+", "l"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", 
               RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", 
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], ",", "1"}], 
          "]"}], "]"}], "//", "N"}]}], "}"}], ",", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"pX", "=", 
          RowBox[{"p", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
         RowBox[{"pY", "=", 
          RowBox[{"p", "\[LeftDoubleBracket]", 
           RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
         RowBox[{"pZ", "=", 
          RowBox[{"p", "\[LeftDoubleBracket]", 
           RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}]}]}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DooSabinForm4", ".", "pX", ".", "pY", ".", "pZ"}], "-", 
        RowBox[{"DooSabinForm4", ".", "pX", ".", "pZ", ".", "pY"}]}]}], 
      "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "60"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "20"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6056792453706765`*^9, 3.6056792750893764`*^9}, {
  3.605680808448079*^9, 3.605680809894162*^9}, {3.6056810337459655`*^9, 
  3.605681097601618*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SubsuperscriptBox["\[Integral]", "0", "b"], 
     RowBox[{
      RowBox[{"f", "[", "a", "]"}], 
      RowBox[{"\[DifferentialD]", "a"}]}]}], "\[Equal]", 
    RowBox[{
     RowBox[{"1", "/", "2"}], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", "0", 
       RowBox[{"2", " ", "b"}]], 
      RowBox[{
       RowBox[{"f", "[", 
        FractionBox["a", "2"], "]"}], 
       RowBox[{"\[DifferentialD]", "a"}]}]}]}]}], "/.", 
   RowBox[{"f", "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox["#", "3"], "+", "#", "+", "3"}], "&"}], ")"}]}]}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.6072960100159883`*^9, 3.6072961249595623`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ep1", "=", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{"a1", ",", "a2"}], "]"}], ",", "a1"}], "]"}]}], "}"}], 
       ",", 
       RowBox[{
        SubsuperscriptBox["\[Integral]", "0", "c"], 
        RowBox[{
         SubsuperscriptBox["\[Integral]", "0", "b"], 
         RowBox[{
          RowBox[{"f", "[", 
           RowBox[{"a1", ",", "a2"}], "]"}], "ep1", 
          RowBox[{"\[DifferentialD]", "a1"}], 
          RowBox[{"\[DifferentialD]", "a2"}]}]}]}]}], "]"}], "\[Equal]", 
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ep2", "=", 
         RowBox[{"D", "[", 
          RowBox[{
           RowBox[{"g", "[", 
            RowBox[{
             RowBox[{"a1", "/", "\[Lambda]"}], ",", 
             RowBox[{"a2", "/", "\[Lambda]"}]}], "]"}], ",", "a1"}], "]"}]}], 
        "}"}], ",", 
       RowBox[{
        RowBox[{"Print", "[", "ep2", "]"}], ";", 
        RowBox[{
         FractionBox["1", 
          SuperscriptBox["\[Lambda]", "2"]], "\[Lambda]", 
         RowBox[{
          SubsuperscriptBox["\[Integral]", "0", 
           RowBox[{"\[Lambda]", " ", "c"}]], 
          RowBox[{
           SubsuperscriptBox["\[Integral]", "0", 
            RowBox[{"\[Lambda]", " ", "b"}]], 
           RowBox[{
            RowBox[{"f", "[", 
             RowBox[{
              RowBox[{"a1", "/", "\[Lambda]"}], ",", 
              RowBox[{"a2", "/", "\[Lambda]"}]}], "]"}], "ep2", 
            RowBox[{"\[DifferentialD]", "a1"}], 
            RowBox[{"\[DifferentialD]", "a2"}]}]}]}]}]}]}], "]"}]}], ")"}], "/.", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"f", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "^", "3"}], "+", 
         RowBox[{"#2", "^", "2"}], "+", "3"}], "&"}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"g", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"#1", "^", "2"}], "#2"}], "+", 
         RowBox[{"#1", 
          RowBox[{"#2", "^", "2"}]}], "+", 
         RowBox[{"#2", "^", "4"}], "+", 
         RowBox[{"8", "#2"}]}], "&"}], ")"}]}]}], "}"}]}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.607296136151202*^9, 3.6072961469568205`*^9}, {
   3.607296325566036*^9, 3.6072963912387924`*^9}, {3.6072964851591644`*^9, 
   3.607296534075962*^9}, 3.6072965659747868`*^9, {3.6072966889258194`*^9, 
   3.607296725204894*^9}, {3.607296961804427*^9, 3.60729698214159*^9}, {
   3.607298369535945*^9, 3.6072984856775875`*^9}, {3.6073002570019016`*^9, 
   3.6073002624402122`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Quad Determinant", "Subsection",
 CellChangeTimes->{{3.604664346574308*^9, 3.6046643521896296`*^9}, {
  3.6052569012648907`*^9, 3.6052569032320037`*^9}, {3.605318991083868*^9, 
  3.6053189916358995`*^9}, {3.607335252489545*^9, 3.607335252679548*^9}, {
  3.6088532425714936`*^9, 3.608853242783506*^9}, {3.6092353049947615`*^9, 
  3.6092353076739144`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"bas2", "[", "x_", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "-", "x"}], ",", "x"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"bas2", "[", "s", "]"}], "\[LeftDoubleBracket]", "k1", 
        "\[RightDoubleBracket]"}], 
       RowBox[{
        RowBox[{"bas2", "[", "t", "]"}], "\[LeftDoubleBracket]", "k2", 
        "\[RightDoubleBracket]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"k2", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k1", ",", "2"}], "}"}]}], "]"}], "//", "Flatten"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    SubscriptBox["\[PartialD]", "s"], 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Tas2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{
    SubscriptBox["\[PartialD]", "t"], 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605311373856182*^9, 3.6053113916902018`*^9}, {
  3.6053183209275374`*^9, 3.605318322126606*^9}, {3.605679142382786*^9, 
  3.605679142872814*^9}, {3.6056792859319963`*^9, 3.6056792882031264`*^9}, {
  3.609235322229747*^9, 3.609235329258149*^9}, {3.609235365901245*^9, 
  3.6092353758568144`*^9}}],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"bas2", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.609235335732519*^9, 3.6092353516594305`*^9}, {
  3.6092353873334703`*^9, 3.6092353907646666`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Print", "[", "#", "]"}], "&"}], "/@", 
    RowBox[{"Bas2", "[", 
     RowBox[{"s", ",", "t"}], "]"}]}], "//", "FullSimplify"}], ";"}]], "Input",
 CellChangeTimes->{{3.6060826221457205`*^9, 3.606082624318845*^9}, {
   3.606082689999602*^9, 3.6060826970970078`*^9}, {3.606083136025113*^9, 
   3.6060831518750196`*^9}, 3.6061592838177185`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Ten2", "[", 
    RowBox[{"s_", ",", "t_"}], "]"}], "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Bas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "a1", 
       "\[RightDoubleBracket]"}], " ", 
      RowBox[{
       RowBox[{"Sas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "b1", 
       "\[RightDoubleBracket]"}], 
      RowBox[{
       RowBox[{"Tas2", "[", 
        RowBox[{"s", ",", "t"}], "]"}], "\[LeftDoubleBracket]", "c1", 
       "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b1", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a1", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"QuadDetForm4", "=", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", "0", "1"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox["\[Integral]", "0", "1"], 
       RowBox[{
        RowBox[{"Ten2", "[", 
         RowBox[{"s", ",", "t"}], "]"}], 
        RowBox[{"\[DifferentialD]", "t"}]}]}], ")"}], 
     RowBox[{"\[DifferentialD]", "s"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.605311415842583*^9, 3.605311425491135*^9}, {
   3.6053177189571066`*^9, 3.6053177200421686`*^9}, {3.6053178185128007`*^9, 
   3.605317818732814*^9}, 3.6056567554633274`*^9, 3.6056749796226892`*^9, {
   3.6056806477328873`*^9, 3.605680649254974*^9}, {3.6061681049632587`*^9, 
   3.6061681082464466`*^9}, {3.609235401960307*^9, 3.609235404592458*^9}, {
   3.609235508114379*^9, 3.609235511326563*^9}}],

Cell[BoxData[
 RowBox[{"QuadDetForm4", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.6056806604366136`*^9, 3.6056806838659534`*^9}, 
   3.605680973864541*^9, 3.609235417651205*^9, {3.60923551774793*^9, 
   3.6092355285315466`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalTau]\[ScriptCapitalA]", "[", "X_", "]"}], ":=", 
   RowBox[{
    RowBox[{"1", "/", 
     RowBox[{
      RowBox[{"TensorRank", "[", "X", "]"}], "!"}]}], " ", 
    RowBox[{"Plus", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Signature", "[", "#1", "]"}], " ", 
         RowBox[{"Transpose", "[", 
          RowBox[{"X", ",", "#1"}], "]"}]}], "&"}], "/@", 
       RowBox[{"Permutations", "[", 
        RowBox[{"Range", "[", 
         RowBox[{"TensorRank", "[", "X", "]"}], "]"}], "]"}]}], ")"}]}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6092356115702963`*^9, 3.6092356376007853`*^9}}],

Cell[BoxData[
 RowBox[{"\[CapitalTau]\[ScriptCapitalA]", "[", "QuadDetForm4", 
  "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", "#", "]"}], "]"}], "&"}], "/@", 
   RowBox[{"\[CapitalTau]\[ScriptCapitalA]", "[", "QuadDetForm4", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6092356473633437`*^9, 3.609235673506839*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pnt", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"N", "=", "20"}], ",", 
         RowBox[{"M", "=", "10"}]}], "}"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", 
             RowBox[{"k1", "+", "0"}], ",", 
             RowBox[{"k2", "+", "0"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", 
             RowBox[{"k1", "+", "1"}], ",", 
             RowBox[{"k2", "+", "0"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", 
             RowBox[{"k1", "+", "0"}], ",", 
             RowBox[{"k2", "+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"TorusSample", "[", 
            RowBox[{"N", ",", "M", ",", 
             RowBox[{"k1", "+", "1"}], ",", 
             RowBox[{"k2", "+", "1"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k1", ",", "N"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"k2", ",", "M"}], "}"}]}], "]"}]}], "]"}], ",", "1"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pnt", "//", "Dimensions"}]}], "Input",
 CellChangeTimes->{{3.6092358002160864`*^9, 3.6092360367946177`*^9}, {
  3.6092361520202084`*^9, 3.609236154730363*^9}, {3.6092363221689405`*^9, 
  3.609236336129739*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuadVolume", "[", "quad_", "]"}], ":=", 
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"points", "=", 
      RowBox[{"Transpose", "[", "quad", "]"}]}], "}"}], ",", 
    RowBox[{"QuadDetForm4", ".", 
     RowBox[{"points", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
      ".", 
     RowBox[{"points", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
      ".", 
     RowBox[{
     "points", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.60923617443649*^9, 3.609236269925952*^9}}],

Cell[BoxData[
 RowBox[{"Total", "[", 
  RowBox[{
   RowBox[{"QuadVolume", "/@", "pnt"}], "//", "N"}], "]"}]], "Input",
 CellChangeTimes->{{3.609236275605277*^9, 3.609236308582163*^9}}],

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Polygon", "/@", "pnt"}], "]"}]], "Input",
 CellChangeTimes->{{3.6092360381326942`*^9, 3.6092360734557147`*^9}}],

Cell["\<\
Here we ensure that our orientation of vertices yields positive volume \
(instead of negative):\
\>", "Text",
 CellChangeTimes->{{3.6056960408260336`*^9, 3.605696080666312*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"P", "=", 
   RowBox[{"(", GridBox[{
      {
       RowBox[{"-", "1"}], "0", "1", 
       RowBox[{"-", "1"}], "0", "1", 
       RowBox[{"-", "1"}], "0", "1"},
      {
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], 
       RowBox[{"-", "1"}], "0", "0", "0", "1", "1", "1"},
      {"1", "1", "1", "1", "1", "1", "1", "1", "1"}
     }], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}]}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"DooSabinForm4", ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
    RowBox[{"P", "\[LeftDoubleBracket]", 
     RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"-", 
    RowBox[{"DooSabinForm4", ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"3", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"2", ",", "All"}], "\[RightDoubleBracket]"}], ".", 
     RowBox[{"P", "\[LeftDoubleBracket]", 
      RowBox[{"1", ",", "All"}], "\[RightDoubleBracket]"}]}]}]}], 
  "}"}]}], "Input",
 CellChangeTimes->{{3.6056751414849477`*^9, 3.6056752216245317`*^9}, {
  3.605675324382409*^9, 3.605675368213916*^9}, {3.60567916833327*^9, 
  3.605679197614945*^9}, {3.60567929840771*^9, 3.6056793214150257`*^9}, {
  3.6056807076843157`*^9, 3.6056807842326946`*^9}}],

Cell["\<\
Coefficients of volume form for regular patch (scaled by 57600):\
\>", "Text",
 CellChangeTimes->{{3.6056960858646097`*^9, 3.6056961138182087`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"MatrixForm", "[", 
      RowBox[{"57600", " ", "#1"}], "]"}], "]"}], "&"}], "/@", 
   "DooSabinForm4"}], ";"}]], "Input",
 CellChangeTimes->{{3.6053184242454467`*^9, 3.6053184420424647`*^9}, {
  3.605318499722764*^9, 3.605318521142989*^9}, {3.6056806776005955`*^9, 
  3.60568068555305*^9}, {3.605696756296956*^9, 3.6056967785772305`*^9}, {
  3.6061598296519384`*^9, 3.6061598613517513`*^9}, {3.6062456727720423`*^9, 
  3.6062456737220964`*^9}}],

Cell["We approximate the volume of a torus (only to check):", "Text",
 CellChangeTimes->{{3.605610756768358*^9, 3.605610762173667*^9}, {
  3.6056961984740505`*^9, 3.60569627748057*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Torus", "[", 
    RowBox[{"R_", ",", "r_", ",", "\[Theta]_", ",", "\[Phi]_"}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"R", "+", 
        RowBox[{"r", " ", 
         RowBox[{"Cos", "[", "\[Phi]", "]"}]}]}], ")"}], " ", 
      RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", 
     RowBox[{"r", " ", 
      RowBox[{"Sin", "[", "\[Phi]", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TorusVolume", "[", 
    RowBox[{"R_", ",", "r_"}], "]"}], "=", 
   RowBox[{"2", " ", 
    SuperscriptBox["\[Pi]", "2"], "R", " ", 
    SuperscriptBox["r", "2"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TorusVolume", "[", 
   RowBox[{"2", ",", "1"}], "]"}], "//", "N"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TorusSample", "[", 
   RowBox[{"N_", ",", "M_", ",", "i_", ",", "j_"}], "]"}], ":=", 
  RowBox[{"Torus", "[", 
   RowBox[{"2", ",", "1", ",", 
    FractionBox[
     RowBox[{"2", "\[Pi]", " ", "i"}], "N"], ",", 
    FractionBox[
     RowBox[{"2", "\[Pi]", " ", "j"}], "M"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ParametricPlot3D", "[", 
    RowBox[{
     RowBox[{"Torus", "[", 
      RowBox[{"2", ",", "1", ",", "\[Theta]", ",", "\[Phi]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Theta]", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Phi]", ",", "0", ",", 
       RowBox[{"2", "\[Pi]"}]}], "}"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y", ",", "z"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ListPointPlot3D", "[", 
    RowBox[{"Flatten", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"TorusSample", "[", 
         RowBox[{"60", ",", "20", ",", "i", ",", "j"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "20"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "60"}], "}"}]}], "]"}], ",", "1"}], "]"}], "]"}]}],
   "}"}]}], "Input",
 CellChangeTimes->{{3.60530326388444*^9, 3.60530327035681*^9}, {
   3.6053033048367825`*^9, 3.6053033626270876`*^9}, {3.6053034043744755`*^9, 
   3.6053034172622128`*^9}, {3.605303486944198*^9, 3.6053034974617996`*^9}, {
   3.6053035845447807`*^9, 3.6053037029515533`*^9}, {3.605304029281218*^9, 
   3.605304039642811*^9}, {3.605305062622322*^9, 3.6053050743329916`*^9}, 
   3.605307382028984*^9, {3.6053176021624265`*^9, 3.6053176023304358`*^9}, {
   3.605318836373019*^9, 3.6053188521489215`*^9}, {3.6056755722345853`*^9, 
   3.6056755763198185`*^9}, {3.6056763335421295`*^9, 3.605676336260285*^9}, {
   3.6056776414139357`*^9, 3.605677663031172*^9}, {3.6056777897974224`*^9, 
   3.60567779324962*^9}, {3.6056867128575044`*^9, 3.605686729531458*^9}}]
}, Closed]]
}, Open  ]]
},
WindowSize->{920, 952},
WindowMargins->{{-2, Automatic}, {Automatic, 5}},
PrintingCopies->1,
PrintingPageRange->{32000, 32000},
PrintingOptions->{"Magnification"->0.75,
"PaperOrientation"->"Landscape",
"PaperSize"->{1056, 816},
"PrintingMargins"->{{72, 72}, {54, 54}}},
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 330, 6, 79, "Section"],
Cell[912, 30, 441, 9, 49, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1390, 44, 550, 7, 79, "Section"],
Cell[CellGroupData[{
Cell[1965, 55, 180, 2, 43, "Subsection"],
Cell[2148, 59, 2708, 75, 145, "Input"],
Cell[4859, 136, 216, 7, 29, "Input"],
Cell[5078, 145, 2825, 71, 88, "Input"],
Cell[7906, 218, 3289, 79, 145, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[11232, 302, 103, 1, 35, "Subsection"],
Cell[11338, 305, 4201, 104, 260, "Input"],
Cell[15542, 411, 1054, 33, 66, "Input"],
Cell[16599, 446, 4152, 98, 298, "Input"],
Cell[20754, 546, 9463, 208, 470, "Input"],
Cell[30220, 756, 4624, 118, 183, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[34881, 879, 235, 3, 35, "Subsection"],
Cell[35119, 884, 1842, 56, 92, "Input"],
Cell[36964, 942, 1176, 32, 72, "Input"],
Cell[38143, 976, 660, 17, 31, "Input"],
Cell[38806, 995, 1322, 32, 52, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[40165, 1032, 98, 1, 35, "Subsection"],
Cell[40266, 1035, 5102, 134, 240, "Input"],
Cell[45371, 1171, 3447, 80, 183, "Input"],
Cell[48821, 1253, 5114, 143, 202, "Input"],
Cell[53938, 1398, 12483, 274, 795, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[66458, 1677, 105, 1, 35, "Subsection"],
Cell[66566, 1680, 12510, 356, 2366, "Input"],
Cell[79079, 2038, 5566, 165, 1232, "Input"],
Cell[84648, 2205, 1609, 44, 83, "Input"],
Cell[86260, 2251, 2154, 59, 126, "Input"],
Cell[88417, 2312, 3085, 77, 145, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[91539, 2394, 153, 2, 35, "Subsection"],
Cell[91695, 2398, 5166, 143, 408, "Input"],
Cell[96864, 2543, 7670, 183, 317, "Input"],
Cell[104537, 2728, 1343, 40, 107, "Input"],
Cell[105883, 2770, 2389, 58, 145, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[108309, 2833, 185, 2, 35, "Subsection"],
Cell[108497, 2837, 7139, 174, 355, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[115685, 3017, 451, 6, 79, "Section"],
Cell[CellGroupData[{
Cell[116161, 3027, 152, 2, 43, "Subsection"],
Cell[116316, 3031, 220, 5, 31, "Input"],
Cell[116539, 3038, 387, 9, 52, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[116963, 3052, 94, 1, 35, "Subsection"],
Cell[117060, 3055, 265, 5, 29, "Input"],
Cell[117328, 3062, 195, 4, 29, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[117560, 3071, 148, 2, 35, "Subsection"],
Cell[117711, 3075, 139, 2, 29, "Input"],
Cell[117853, 3079, 428, 12, 49, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[118330, 3097, 571, 8, 79, "Section"],
Cell[CellGroupData[{
Cell[118926, 3109, 223, 3, 43, "Subsection"],
Cell[CellGroupData[{
Cell[119174, 3116, 130, 2, 34, "Subsubsection"],
Cell[119307, 3120, 135, 2, 50, "Input"],
Cell[119445, 3124, 3351, 79, 733, "Input"],
Cell[122799, 3205, 370, 8, 57, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[123206, 3218, 126, 2, 28, "Subsubsection"],
Cell[123335, 3222, 353, 10, 50, "Input"],
Cell[123691, 3234, 255, 7, 50, "Input"],
Cell[123949, 3243, 648, 18, 85, "Input"],
Cell[124600, 3263, 978, 27, 252, "Input"],
Cell[125581, 3292, 1147, 32, 186, "Input"],
Cell[126731, 3326, 153, 4, 50, "Input"],
Cell[126887, 3332, 219, 5, 50, "Input"],
Cell[127109, 3339, 379, 7, 85, "Input"],
Cell[127491, 3348, 555, 13, 97, "Input"],
Cell[128049, 3363, 344, 8, 97, "Input"],
Cell[128396, 3373, 269, 5, 97, "Input"],
Cell[128668, 3380, 235, 6, 57, "Input"],
Cell[128906, 3388, 161, 2, 57, "Input"],
Cell[129070, 3392, 329, 7, 97, "Input"],
Cell[129402, 3401, 631, 17, 97, "Input"],
Cell[130036, 3420, 466, 12, 57, "Input"],
Cell[130505, 3434, 445, 10, 57, "Input"],
Cell[130953, 3446, 312, 8, 57, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[131314, 3460, 212, 3, 43, "Subsection"],
Cell[131529, 3465, 1813, 53, 3428, "Input"],
Cell[133345, 3520, 1050, 26, 1926, "Input"],
Cell[134398, 3548, 776, 17, 1926, "Input"],
Cell[135177, 3567, 460, 13, 1926, "Input"],
Cell[135640, 3582, 7782, 190, 28294, "Input"],
Cell[143425, 3774, 232, 5, 1425, "Input"],
Cell[143660, 3781, 451, 11, 1425, "Input"],
Cell[144114, 3794, 497, 13, 2409, "Input"],
Cell[144614, 3809, 671, 19, 2409, "Input"],
Cell[145288, 3830, 389, 11, 1425, "Input"],
Cell[145680, 3843, 433, 11, 2409, "Input"],
Cell[146116, 3856, 202, 4, 1425, "Input"],
Cell[146321, 3862, 515, 13, 1425, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[146873, 3880, 149, 2, 35, "Subsection"],
Cell[CellGroupData[{
Cell[147047, 3886, 130, 2, 34, "Subsubsection"],
Cell[147180, 3890, 69, 1, 5450, "Input"],
Cell[147252, 3893, 2777, 69, 75071, "Input"],
Cell[150032, 3964, 295, 7, 5450, "Input"],
Cell[150330, 3973, 527, 10, 9193, "Input"],
Cell[150860, 3985, 288, 6, 5450, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[151185, 3996, 209, 3, 28, "Subsubsection"],
Cell[151397, 4001, 1002, 19, 29, "Input"],
Cell[152402, 4022, 830, 21, 68, "Input"],
Cell[153235, 4045, 205, 4, 29, "Input"],
Cell[153443, 4051, 1917, 45, 88, "Input"],
Cell[155363, 4098, 1527, 40, 88, "Input"],
Cell[156893, 4140, 1576, 41, 88, "Input"],
Cell[158472, 4183, 644, 19, 49, "Input"],
Cell[159119, 4204, 184, 4, 29, "Text"],
Cell[159306, 4210, 339, 9, 29, "Input"],
Cell[159648, 4221, 1311, 34, 107, "Input"],
Cell[160962, 4257, 396, 11, 29, "Input"],
Cell[161361, 4270, 260, 6, 29, "Input"],
Cell[161624, 4278, 226, 6, 29, "Input"],
Cell[161853, 4286, 228, 4, 29, "Input"],
Cell[162084, 4292, 261, 7, 29, "Input"],
Cell[162348, 4301, 174, 4, 29, "Input"],
Cell[162525, 4307, 1500, 40, 107, "Input"],
Cell[164028, 4349, 2912, 73, 298, "Input"],
Cell[166943, 4424, 517, 11, 68, "Input"],
Cell[167463, 4437, 576, 15, 49, "Input"],
Cell[168042, 4454, 242, 7, 29, "Input"],
Cell[168287, 4463, 507, 14, 11493, "Input"],
Cell[168797, 4479, 937, 18, 6818, "Input"],
Cell[169737, 4499, 204, 3, 6818, "Input"],
Cell[169944, 4504, 203, 3, 6818, "Input"],
Cell[170150, 4509, 572, 15, 15898, "Input"],
Cell[170725, 4526, 360, 10, 6818, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[171122, 4541, 105, 1, 28, "Subsubsection"],
Cell[171230, 4544, 1255, 34, 726548, "Input"],
Cell[172488, 4580, 1093, 29, 564967, "Input"],
Cell[173584, 4611, 2438, 64, 884957, "Input"],
Cell[176025, 4677, 1142, 28, 884957, "Input"],
Cell[177170, 4707, 646, 18, 408479, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[177865, 4731, 124, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[178014, 4737, 128, 2, 34, "Subsubsection"],
Cell[178145, 4741, 111, 2, 20823, "Input"],
Cell[178259, 4745, 3854, 100, 310045, "Input"],
Cell[182116, 4847, 490, 11, 25561, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[182643, 4863, 329, 10, 32, "Subsubsection"],
Cell[182975, 4875, 1057, 20, 20823, "Input"],
Cell[184035, 4897, 610, 17, 35085, "Input"],
Cell[184648, 4916, 818, 23, 39940, "Input"],
Cell[185469, 4941, 273, 8, 25561, "Input"],
Cell[185745, 4951, 254, 5, 20823, "Input"],
Cell[186002, 4958, 228, 5, 20823, "Input"],
Cell[186233, 4965, 538, 13, 20823, "Input"],
Cell[186774, 4980, 475, 13, 25561, "Input"],
Cell[187252, 4995, 672, 20, 48528, "Input"],
Cell[187927, 5017, 174, 4, 20823, "Input"],
Cell[188104, 5023, 1598, 41, 76011, "Input"],
Cell[189705, 5066, 2963, 73, 213119, "Input"],
Cell[192671, 5141, 712, 16, 62409, "Input"],
Cell[193386, 5159, 2334, 58, 93655, "Input"],
Cell[195723, 5219, 1659, 43, 76011, "Input"],
Cell[197385, 5264, 177, 4, 20823, "Input"],
Cell[197565, 5270, 789, 21, 52910, "Input"],
Cell[198357, 5293, 371, 10, 20823, "Input"],
Cell[198731, 5305, 1161, 29, 58819, "Input"],
Cell[199895, 5336, 302, 4, 20823, "Input"],
Cell[200200, 5342, 439, 11, 20823, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[200688, 5359, 148, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[200861, 5365, 130, 2, 34, "Subsubsection"],
Cell[200994, 5369, 113, 2, 242408, "Input"],
Cell[201110, 5373, 4075, 100, 3748082, "Input"],
Cell[205188, 5475, 320, 7, 242408, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[205545, 5487, 147, 2, 28, "Subsubsection"],
Cell[205695, 5491, 807, 16, 242408, "Input"],
Cell[206505, 5509, 661, 18, 408479, "Input"],
Cell[207169, 5529, 174, 4, 242408, "Input"],
Cell[207346, 5535, 200, 4, 242408, "Input"],
Cell[207549, 5541, 1674, 42, 884957, "Input"],
Cell[209226, 5585, 3015, 74, 2481090, "Input"],
Cell[212244, 5661, 626, 16, 408479, "Input"],
Cell[212873, 5679, 310, 8, 242408, "Input"],
Cell[213186, 5689, 479, 14, 408479, "Input"],
Cell[213668, 5705, 765, 16, 242408, "Input"],
Cell[214436, 5723, 304, 4, 242408, "Input"],
Cell[214743, 5729, 467, 12, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[215259, 5747, 170, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[215454, 5753, 155, 2, 34, "Subsubsection"],
Cell[215612, 5757, 137, 2, 242408, "Input"],
Cell[215752, 5761, 67, 1, 242408, "Input"],
Cell[215822, 5764, 4812, 116, 4046193, "Input"],
Cell[220637, 5882, 272, 7, 242408, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[220946, 5894, 212, 3, 28, "Subsubsection"],
Cell[221161, 5899, 805, 16, 242408, "Input"],
Cell[221969, 5917, 712, 19, 408479, "Input"],
Cell[222684, 5938, 174, 4, 242408, "Input"],
Cell[222861, 5944, 200, 4, 242408, "Input"],
Cell[223064, 5950, 7321, 165, 3228170, "Input"],
Cell[230388, 6117, 1750, 43, 884957, "Input"],
Cell[232141, 6162, 3069, 75, 2481090, "Input"],
Cell[235213, 6239, 755, 18, 408479, "Input"],
Cell[235971, 6259, 396, 10, 242408, "Input"],
Cell[236370, 6271, 587, 17, 408479, "Input"],
Cell[236960, 6290, 900, 18, 242408, "Input"],
Cell[237863, 6310, 381, 5, 242408, "Input"],
Cell[238247, 6317, 489, 12, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[238785, 6335, 224, 3, 43, "Subsection"],
Cell[CellGroupData[{
Cell[239034, 6342, 127, 2, 34, "Subsubsection"],
Cell[239164, 6346, 162, 3, 242408, "Input"],
Cell[239329, 6351, 192, 4, 14005402, "Input"],
Cell[239524, 6357, 5796, 139, 4159395, "Input"],
Cell[245323, 6498, 440, 10, 297591, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[245800, 6513, 382, 11, 32, "Subsubsection"],
Cell[246185, 6526, 855, 17, 242408, "Input"],
Cell[247043, 6545, 760, 19, 408479, "Input"],
Cell[247806, 6566, 174, 4, 242408, "Input"],
Cell[247983, 6572, 200, 4, 242408, "Input"],
Cell[248186, 6578, 5939, 137, 3228170, "Input"],
Cell[254128, 6717, 1775, 44, 884957, "Input"],
Cell[255906, 6763, 3017, 74, 2481090, "Input"],
Cell[258926, 6839, 739, 17, 726548, "Input"],
Cell[259668, 6858, 2358, 57, 1090359, "Input"],
Cell[262029, 6917, 1704, 44, 884957, "Input"],
Cell[263736, 6963, 177, 4, 242408, "Input"],
Cell[263916, 6969, 127, 2, 242408, "Input"],
Cell[264046, 6973, 812, 21, 464993, "Input"],
Cell[264861, 6996, 424, 11, 242408, "Input"],
Cell[265288, 7009, 1195, 30, 473456, "Input"],
Cell[266486, 7041, 614, 14, 297591, "Input"],
Cell[267103, 7057, 357, 5, 242408, "Input"],
Cell[267463, 7064, 467, 12, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[267979, 7082, 248, 3, 43, "Subsection"],
Cell[CellGroupData[{
Cell[268252, 7089, 127, 2, 34, "Subsubsection"],
Cell[268382, 7093, 186, 3, 242408, "Input"],
Cell[268571, 7098, 214, 4, 242408, "Input"],
Cell[268788, 7104, 6553, 151, 4167443, "Input"],
Cell[275344, 7257, 425, 9, 242408, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[275806, 7271, 212, 3, 28, "Subsubsection"],
Cell[276021, 7276, 857, 17, 242408, "Input"],
Cell[276881, 7295, 762, 19, 408479, "Input"],
Cell[277646, 7316, 200, 4, 242408, "Input"],
Cell[277849, 7322, 7939, 172, 3228170, "Input"],
Cell[285791, 7496, 1852, 45, 884957, "Input"],
Cell[287646, 7543, 3117, 75, 2481090, "Input"],
Cell[290766, 7620, 807, 19, 408479, "Input"],
Cell[291576, 7641, 449, 11, 242408, "Input"],
Cell[292028, 7654, 637, 17, 408479, "Input"],
Cell[292668, 7673, 950, 19, 242408, "Input"],
Cell[293621, 7694, 433, 6, 242408, "Input"],
Cell[294057, 7702, 577, 14, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[294683, 7722, 279, 4, 43, "Subsection"],
Cell[CellGroupData[{
Cell[294987, 7730, 127, 2, 34, "Subsubsection"],
Cell[295117, 7734, 211, 3, 242408, "Input"],
Cell[295331, 7739, 241, 4, 242408, "Input"],
Cell[295575, 7745, 8802, 221, 4445269, "Input"],
Cell[304380, 7968, 522, 11, 297591, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[304939, 7984, 428, 11, 32, "Subsubsection"],
Cell[305370, 7997, 908, 18, 242408, "Input"],
Cell[306281, 8017, 818, 20, 408479, "Input"],
Cell[307102, 8039, 174, 4, 242408, "Input"],
Cell[307279, 8045, 200, 4, 242408, "Input"],
Cell[307482, 8051, 8206, 178, 3228170, "Input"],
Cell[315691, 8231, 1882, 45, 884957, "Input"],
Cell[317576, 8278, 3077, 75, 2481090, "Input"],
Cell[320656, 8355, 786, 17, 726548, "Input"],
Cell[321445, 8374, 2407, 58, 1090359, "Input"],
Cell[323855, 8434, 1750, 44, 884957, "Input"],
Cell[325608, 8480, 251, 6, 242408, "Input"],
Cell[325862, 8488, 127, 2, 242408, "Input"],
Cell[325992, 8492, 912, 22, 464993, "Input"],
Cell[326907, 8516, 563, 13, 242408, "Input"],
Cell[327473, 8531, 1297, 31, 473456, "Input"],
Cell[328773, 8564, 669, 15, 297591, "Input"],
Cell[329445, 8581, 408, 6, 242408, "Input"],
Cell[329856, 8589, 548, 13, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[330453, 8608, 325, 4, 43, "Subsection"],
Cell[CellGroupData[{
Cell[330803, 8616, 127, 2, 34, "Subsubsection"],
Cell[330933, 8620, 237, 4, 242408, "Input"],
Cell[331173, 8626, 269, 5, 242408, "Input"],
Cell[331445, 8633, 9002, 213, 4445269, "Input"],
Cell[340450, 8848, 503, 10, 242408, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[340990, 8863, 212, 3, 28, "Subsubsection"],
Cell[341205, 8868, 910, 18, 242408, "Input"],
Cell[342118, 8888, 820, 20, 408479, "Input"],
Cell[342941, 8910, 200, 4, 242408, "Input"],
Cell[343144, 8916, 9335, 200, 3228170, "Input"],
Cell[352482, 9118, 1958, 46, 884957, "Input"],
Cell[354443, 9166, 3173, 76, 2481090, "Input"],
Cell[357619, 9244, 863, 20, 408479, "Input"],
Cell[358485, 9266, 498, 11, 242408, "Input"],
Cell[358986, 9279, 688, 18, 408479, "Input"],
Cell[359677, 9299, 1002, 19, 242408, "Input"],
Cell[360682, 9320, 485, 7, 242408, "Input"],
Cell[361170, 9329, 624, 14, 242408, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[361843, 9349, 353, 5, 43, "Subsection"],
Cell[CellGroupData[{
Cell[362221, 9358, 127, 2, 34, "Subsubsection"],
Cell[362351, 9362, 258, 4, 13323, "Input"],
Cell[362612, 9368, 290, 5, 13323, "Input"],
Cell[362905, 9375, 11093, 268, 268053, "Input"],
Cell[374001, 9645, 210, 4, 13323, "Input"],
Cell[374214, 9651, 673, 13, 16355, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[374924, 9669, 482, 12, 32, "Subsubsection"],
Cell[375409, 9683, 952, 18, 13323, "Input"],
Cell[376364, 9703, 871, 21, 22452, "Input"],
Cell[377238, 9726, 174, 4, 13323, "Input"],
Cell[377415, 9732, 200, 4, 13323, "Input"],
Cell[377618, 9738, 11311, 247, 177467, "Input"],
Cell[388932, 9987, 1976, 46, 48647, "Input"],
Cell[390911, 10035, 3127, 75, 136398, "Input"],
Cell[394041, 10112, 814, 18, 39940, "Input"],
Cell[394858, 10132, 2457, 58, 59940, "Input"],
Cell[397318, 10192, 1801, 45, 48647, "Input"],
Cell[399122, 10239, 251, 6, 13323, "Input"],
Cell[399376, 10247, 127, 2, 13323, "Input"],
Cell[399506, 10251, 961, 23, 25561, "Input"],
Cell[400470, 10276, 591, 14, 13323, "Input"],
Cell[401064, 10292, 1346, 32, 26030, "Input"],
Cell[402413, 10326, 718, 16, 16355, "Input"],
Cell[403134, 10344, 510, 7, 13323, "Input"],
Cell[403647, 10353, 652, 15, 13323, "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[404360, 10375, 544, 7, 79, "Section"],
Cell[CellGroupData[{
Cell[404929, 10386, 248, 3, 43, "Subsection"],
Cell[405180, 10391, 4054, 92, 336, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[409271, 10488, 309, 4, 35, "Subsection"],
Cell[409583, 10494, 1763, 54, 106, "Input"],
Cell[411349, 10550, 414, 10, 29, "Input"],
Cell[411766, 10562, 1586, 44, 86, "Input"],
Cell[413355, 10608, 181, 3, 29, "Input"],
Cell[413539, 10613, 187, 4, 29, "Text"],
Cell[413729, 10619, 3000, 67, 176, "Input"],
Cell[416732, 10688, 158, 3, 29, "Text"],
Cell[416893, 10693, 532, 12, 29, "Input"],
Cell[417428, 10707, 185, 2, 29, "Text"],
Cell[417616, 10711, 3078, 78, 141, "Input"],
Cell[420697, 10791, 1847, 48, 126, "Input"],
Cell[422547, 10841, 743, 24, 47, "Input"],
Cell[423293, 10867, 2774, 77, 153, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[426104, 10949, 360, 5, 35, "Subsection"],
Cell[426467, 10956, 1580, 47, 88, "Input"],
Cell[428050, 11005, 292, 7, 29, "Input"],
Cell[428345, 11014, 414, 10, 29, "Input"],
Cell[428762, 11026, 1681, 45, 86, "Input"],
Cell[430446, 11073, 239, 4, 29, "Input"],
Cell[430688, 11079, 691, 20, 68, "Input"],
Cell[431382, 11101, 97, 2, 29, "Input"],
Cell[431482, 11105, 301, 8, 29, "Input"],
Cell[431786, 11115, 1603, 39, 126, "Input"],
Cell[433392, 11156, 613, 16, 49, "Input"],
Cell[434008, 11174, 184, 4, 29, "Input"],
Cell[434195, 11180, 165, 3, 29, "Input"],
Cell[434363, 11185, 187, 4, 29, "Text"],
Cell[434553, 11191, 3000, 67, 176, "Input"],
Cell[437556, 11260, 158, 3, 29, "Text"],
Cell[437717, 11265, 532, 12, 29, "Input"],
Cell[438252, 11279, 185, 2, 29, "Text"],
Cell[438440, 11283, 3078, 78, 141, "Input"]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
